<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/controllers/categories.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.controller' );

/**
 * JMyLife Component Categories Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerCategories extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct( $default=array() )
	{
		parent::__construct( $default );
		$this->registerTask( 'add', 'edit' );
	}

	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		parent::display();
	}

	function remove()
	{
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$database =& JFactory::getDBO();
		$cid 		  = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );
		if( count( $cid ) < 1 )
		{
			JError::raiseError( 500, JText::_( 'COM_JMYLIFE_ERROR_CATEGORY_DELETE', true ) );
		}
		$cids = implode( ',', $cid );
		
		$query = 'DELETE FROM #__jmylife_categories'
		       . ' WHERE id IN ( '.$cids.' )'
		;
		
		$database->setQuery( $query );
		if( !$database->query() )
		{
			JError::raiseError( 500, $database->getErrorMsg() );
		}
		$appl->redirect( 'index.php?option=com_jmylife&view=categories' );
	}
	
	function unpublish()
	{
		$this->publish( 0 );
	}
	function publish( $publish=1 )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// J!1.6 doesn't use mainframe
		$appl     =& JFactory::getApplication();
		// Initialize variables
		$database =& JFactory::getDBO();
		$user     =& JFactory::getUser();
		$uid      =  $user->get( 'id' );
		$action   =  $publish ? 'publish' : 'unpublish';
		$cid      =  JRequest::getVar( 'cid', array(0), '', 'array' );
		$count    =  count( $cid );
		JArrayHelper::toInteger( $cid, array(0) );

		if( $count < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_CATEGORY_'.strtoupper($action), true));
		}
		
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__jmylife_categories'
		       . ' SET published = '.(int)$publish
		       . ' WHERE id IN ( '.$cids.' )'
		;
		$database->setQuery( $query );
		if( !$database->query() )
		{
			JError::raiseError( 500, $database->getErrorMsg() );
		}
		if( $count == 1 )
		{
			$row =& JTable::getInstance( 'categories', 'Table' );
			$row->checkin( $cid[0] );
		}
		$appl->redirect( 'index.php?option=com_jmylife&view=categories' );
	}
	function edit()
	{
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );
		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_CATEGORY_EDIT', true));
		}
		JRequest::setVar( 'cid', $cid[0] );
		JRequest::setVar( 'view', 'categories' );
		JRequest::setVar( 'layout', 'form' );
		JRequest::setVar( 'hidemainmenu', 1 );
		parent::display();
	}
	function cancel()
	{
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$appl->redirect( 'index.php?option=com_jmylife&view=categories' );
	}
	function apply()
	{
		$this->save( true );
	}
	function save( $apply=false )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// initialize variables
		$database       = &JFactory::getDBO();
		// yeah, I could do a generic JRequest::get() but I'd rather not...
		$bind = array();
		$bind['name']           = JRequest::getString( 'name', '' );
		$bind['color']          = JRequest::getString( 'color', '' );
		$bind['background']     = JRequest::getString( 'background', '' );
		$bind['description']    = JRequest::getString( 'description', '' );
		$bind['published']      = JRequest::getInt( 'published', 0 );
		$bind['allow_comments'] = JRequest::getInt( 'allow_comments', 1 );
		$bind['allow_votes']    = JRequest::getInt( 'allow_votes', 1 );
		$bind['ordering']       = JRequest::getInt( 'ordering', 1 );
		$cids                   = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cids, array(0) );
		if( count( $cids ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_CATEGORY_SAVE', true));
		}
		$bind['id'] = $cids[0];
		// handle bad data here
		if( strlen( $bind['name'] ) == 0 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_CATEGORY_NO_CATEGORY_NAME', true));
		}
		$row =& JTable::getInstance( 'categories', 'Table' );
		if( !$row->bind( $bind ) )
		{
			JError::raiseError( 500, $row->getError() );
		}
		if( !$row->check() )
		{
			JError::raiseError( 500, $row->getError() );
		}
		if( !$row->id )
		{
			$row->ordering = $row->getNextOrder();
		}
		if( !$row->store() )
		{
			JError::raiseError(500, $row->getError() );
		}
		$row->checkin();
		$appl->redirect('index.php?option=com_jmylife&view=categories&controller=categories'.($apply ? '&task=edit&cid='.$bind['id'] : ''), JText::_('COM_JMYLIFE_CATEGORY_SAVED'));
	}
	// since 1.0.5
	function unallowcomments()
	{
		$this->allowcomments( 0 );
	}
	function allowcomments( $allow=1 )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// Initialize variables
		$database =& JFactory::getDBO();
		$user     =& JFactory::getUser();
		$uid      =  $user->get( 'id' );
		$action   =  strtoupper($allow ? 'en' : 'dis');
		$cid      =  JRequest::getVar( 'cid', array(0), '', 'array' );
		$count    =  count( $cid );
		JArrayHelper::toInteger( $cid, array(0) );
		if( $count < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_CATEGORY_'.$action.'ABLE_COMMENTS', true));
		}
		$cids = implode( ',', $cid );
		$query = 'UPDATE #__jmylife_categories'
		       . ' SET allow_comments = '.(int)$allow
		       . ' WHERE id IN ( '.$cids.' )'
		;
		$database->setQuery( $query );
		if( !$database->query() )
		{
			JError::raiseError( 500, $database->getErrorMsg() );
		}
		if( $count == 1 )
		{
			$row =& JTable::getInstance( 'categories', 'Table' );
			$row->checkin( $cid[0] );
		}
		$appl->redirect( 'index.php?option=com_jmylife&view=categories' );
	}
	// since 1.0.5
	function unallowvotes()
	{
		$this->allowvotes( 0 );
	}
	function allowvotes( $allow=1 )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// Initialize variables
		$database =& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$uid	= $user->get( 'id' );
		$action = strtoupper($allow ? 'en' : 'dis');
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );

		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_CATEGORY_'.$action.'ABLE_COMMENTS', true));
		}
		
		$cids = implode( ',', $cid );
		
		$query = 'UPDATE #__jmylife_categories'
		       . ' SET allow_votes = '.(int)$allow
		       . ' WHERE id IN ( '.$cids.' )'
		;
		
		$database->setQuery( $query );
		if( !$database->query() )
		{
			JError::raiseError( 500, $database->getErrorMsg() );
		}
		$appl->redirect( 'index.php?option=com_jmylife&view=categories' );
	}
	
	// category ordering
	function orderup()
	{
		$this->orderCategory( -1 );
	}
	function orderdown()
	{
		$this->orderCategory( 1 );
	}
	function orderCategory( $direction )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		// J!1.6 doesn't use mainframe
		$appl     =& JFactory::getApplication();
		// Initialize variables
		$database =& JFactory::getDBO();
		$cid      =  JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );
		if( isset( $cid[0] ) )
		{
			$row = & JTable::getInstance('categories', 'Table');
			$row->load( (int)$cid[0] );
			$row->move( $direction );
			// TODO: actually use cache ;)
			$cache = & JFactory::getCache('com_jmylife');
			$cache->clean();
		}
		$appl->redirect('index.php?option=com_jmylife&view=categories');
	}
	function saveOrder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		// Initialize variables
		$appl       =& JFactory::getApplication();
		$db         =& JFactory::getDBO();
		$cid        =  JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order      =  JRequest::getVar( 'order', array(0), 'post', 'array' );
		$total      =  count( $cid );
		$conditions =  array();
		JArrayHelper::toInteger( $cid, array(0) );
		JArrayHelper::toInteger( $order, array(0) );
		$row        =& JTable::getInstance('categories', 'Table');
		// Update the ordering for items in the cid array
		for( $i = 0; $i < $total; $i++ )
		{
			$row->load( (int)$cid[$i] );
			if( $row->ordering != $order[$i] )
			{
				$row->ordering = $order[$i];
				if( !$row->store() )
				{
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
			}
		}
		$row->reorder();
		// TODO: implement cache
		$cache = & JFactory::getCache('com_jmylife');
		$cache->clean();
		$appl->redirect('index.php?option=com_jmylife&view=categories', JText::_('COM_JMYLIFE_CATEGORY_ORDERING'));
	}
}