<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/controllers/comments.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.controller' );

/**
 * JMyLife Component Comments Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerComments extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct( $default=array() )
	{
		parent::__construct( $default );
		// don't allow adding from backend for now...
		//$this->registerTask( 'add', 'edit' );
	}

	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		parent::display();
	}
	
	function remove()
	{
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$database =& JFactory::getDBO();
		$cid 		  = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );
		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_COMMENT_DELETE', true));
		}
		$cids = implode( ',', $cid );
		
		$query = 'DELETE FROM #__jmylife_comments'
		       . ' WHERE id IN ( '.$cids.' )'
		;
		$database->setQuery( $query );
		if( !$database->query() )
		{
			JError::raiseError( 500, $database->getErrorMsg() );
		}
		// we're not deleting warnings, as we may want to track somehow later
		$appl->redirect( 'index.php?option=com_jmylife&view=comments' );
	}
	
	function unpublish()
	{
		$this->publish( 0 );
	}
	function publish( $publish=1 )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		// Initialize variables
		$user   =& JFactory::getUser();
		$uid    =  $user->get( 'id' );
		$action =  strtoupper($publish ? 'publish' : 'unpublish');
		$cid    =  JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );

		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_COMMENT_'.strtoupper($action), true));
		}
		
		$cids = implode( ',', $cid );
		
		$query = 'UPDATE #__jmylife_comments'
		       . ' SET published = '.(int)$publish
		       . ' WHERE id IN ( '.$cids.' )'
		;
		
		$_JMLConfig->db->setQuery( $query );
		if( !$_JMLConfig->db->query() )
		{
			JError::raiseError( 500, $_JMLConfig->db->getErrorMsg() );
		}
		// trigger stuff that needs to run on publish
		if( 1 == $publish )
		{
			// since 1.0.9, send notification to user if all settings allow for it
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$mailer->commentSubscribers( $cids );
			// add to JomSocial activity stream, if enabled
			if( $_JMLConfig->allow->jomsocial )
			{
				$points = false;
				$userpoints = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'userpoints.php';
				// handle points
				if( JFile::exists( $userpoints ) )
				{
					include_once( $userpoints );
					$points = true;
				}
				$query = 'SELECT c.`id`, c.`author_id`, s.`user_id` FROM `#__jmylife_comments` AS c LEFT JOIN `#__jmylife_stories` AS s ON ( s.`id` = c.`sid` ) WHERE c.`id` IN ( '.$cids.' ) GROUP BY c.`id`';
				$_JMLConfig->db->setQuery( $query );
				if( $rows = $_JMLConfig->db->loadObjectList() )
				{
					foreach( $rows as $row )
					{
						if( $points )
						{
							CuserPoints::assignPoint('jmylife.story.comment', $row->user_id );
							CuserPoints::assignPoint('jmylife.comment.publish', $row->author_id );
						}
						if( $_JMLConfig->getInt('jomsocial_activities_comments',0) )
						{
							JmylifeCommon::updateJomSocialActivity( 'comment.published', $row->id, $row->author_id );
						}
					}
				}
			}
		}
		// all done!
		$appl->redirect( 'index.php?option=com_jmylife&view=comments' );
	}
	function edit()
	{
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );
		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_COMMENT_EDIT', true));
		}
		JRequest::setVar( 'cid', $cid[0] );
		JRequest::setVar( 'view', 'comments' );
		JRequest::setVar( 'layout', 'form' );
		JRequest::setVar( 'hidemainmenu', 1 );
		parent::display();
	}
	function cancel()
	{
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$appl->redirect( 'index.php?option=com_jmylife&view=comments' );
	}
	function apply()
	{
		$this->save( true );
	}
	function save( $apply=false )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		// initialize variables
		$uid       = JRequest::getInt( 'author_id', 0 );
		$alias     = JRequest::getString( 'author' );
		$sid       = JRequest::getInt( 'sid', 0 );
		$message   = JRequest::getString( 'message' );
		$published = JRequest::getInt( 'published', 0 );
		$time      = JRequest::getInt( 'time', time() );
		$cids      = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cids, array(0) );
		if( count( $cids ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_COMMENT_SAVE', true));
		}
		$cid = $cids[0];
		// handle bad data here
		if( strlen( $alias ) == 0 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_COMMENT_UNDEFINEDALIAS', true));
		}
		if( $sid == 0 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_COMMENT_STORYID', true));
		}
		if( strlen( $message ) == 0 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_COMMENT_NOTEXT', true));
		}
		// before saving - grab old value of `published`
		// that way we can send email notifications & update jomsocial
		$query = 'SELECT `published` FROM `#__jmylife_comments` WHERE `id` = '.$cid;
		$_JMLConfig->db->setQuery( $query );
		$pub = intval( $_JMLConfig->db->loadResult() );
		if( 0 == $pub && 1 == $published )
		{
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$mailer->commentSubscribers( $cid );
			if( $_JMLConfig->allow->jomsocial )
			{
				// handle jomsocial points
				$userpoints = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'userpoints.php';
				if( JFile::exists( $userpoints ) )
				{
					include_once( $userpoints );
					CuserPoints::assignPoint('jmylife.comment.publish',$uid);
					// get author id
					$_JMLConfig->db->setQuery( 'SELECT `user_id` FROM `#__jmylife_stories` WHERE `id`='.$sid );
					if( $author = $_JMLConfig->db->loadResult() )
						CuserPoints::assignPoint('jmylife.story.comment', $author );
				}
				// add to JomSocial activity stream, if enabled
				if( $_JMLConfig->getInt('jomsocial_activities_comments',0) )
				{
					JmylifeCommon::updateJomSocialActivity( 'comment.published', $cid, $uid );
				}
			}
		}
		// insert/update
		// NOTE: isn't this redundant? comments cannot be created in backend...
		if( $cid == 0 )
		{
			// save new record
			$query = 'INSERT INTO `#__jmylife_comments` ( '
			       . '`sid`, `time`, `message`, `published`, `author_id`, `author`'
			       . ') VALUES ( '
			       . $sid.', '.$time.', '.$_JMLConfig->db->Quote( $message ).', '.$published.', '.$uid.', '.$_JMLConfig->db->Quote( $alias ).' '
			       . ')'
			       ;
			$_JMLConfig->db->setQuery( $query );
			$_JMLConfig->db->query();
			$cid = $_JMLConfig->db->insertid();
		}
		else
		{
			$query = 'UPDATE `#__jmylife_comments` SET '
			       . '`sid`        = '.$sid.', '
			       . '`time`       = '.$time.', '
			       . '`message`    = '.$_JMLConfig->db->Quote( $message ).', '
			       . '`published`  = '.$published.', '
			       . '`author_id`  = '.$uid.', '
			       . '`author`     = '.$_JMLConfig->db->Quote( $alias ).' '
			       . 'WHERE `id` = '.$cid.' LIMIT 1'
			       ;
			$_JMLConfig->db->setQuery( $query );
			$_JMLConfig->db->query();
		}
		$appl->redirect('index.php?option=com_jmylife&view=comments&controller=comments'.($apply ? '&task=edit&cid='.$cid : ''), JText::_('COM_JMYLIFE_COMMENT_SAVED'));
	}
}