<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/controllers/configuration.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.controller' );
jimport('joomla.filesystem.file');

/**
 * JMyLife Component Configuration Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerConfiguration extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct( $default=array() )
	{
		parent::__construct( $default );
	}

	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		parent::display();
	}
	function reload()
	{
		$appl =& JFactory::getApplication();
		$appl->redirect('index.php?option=com_jmylife&view=configuration');
	}

	function save()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// build query
		$query = 'SELECT '
		       . '* '
		       . 'FROM `#__jmylife_configuration` '
		       ;
		$_JMLConfig->db->setQuery( $query );
		// get configs
		$configs = $_JMLConfig->db->loadObjectList();
		// what's changed
		foreach( $configs as $config )
		{
			$key = $config->key;
			$value = $config->value;
			// what function do we parse with?
			switch( $config->type )
			{
				case 'radio':
				case 'int':
					$newval = JRequest::getInt( $key );
					$dbquot = false;
					break;
				case 'usergroup':
				case 'menuitem':
					$newval = (int)$_REQUEST[$key][0];
					$dbquot = false;
					break;
				case 'editor':
					$newval = JRequest::getVar( $key, '', 'post', 'string', JREQUEST_ALLOWRAW );
					break;
				case 'color':
				case 'text':
				case 'textarea':
				default:
					$newval = JRequest::getString( $key );
					$dbquot = true;
					break;
			}
			// check if it's in request & changed, then push
			if( $newval !== $val )
			{
				$table = $_JMLConfig->isLang( $key ) ? 'language' : 'configuration';
				$query = 'UPDATE `#__jmylife_'.$table.'` SET `value`='
				       . ( $dbquot ? $_JMLConfig->db->quote( $newval ) : ''.$newval.'' )
				       . ' WHERE `key` = "'.$key.'"'
				       ;
				$_JMLConfig->db->setQuery( $query );
				$_JMLConfig->db->query();
			}
		}
		// check custom css
		$css = JRequest::getVar('css_file_contents');
		$cssfile = JRequest::getVar('css_custom_styles');
		$cssfile = JFile::makeSafe( $cssfile );
		$cssfile = realpath( JPATH_SITE.DS.'components'.DS.'com_jmylife'.DS.'assets'.DS.'css'.DS.'custom'.DS.$cssfile );
		if( JFile::exists( $cssfile ) && preg_match( '`[^\?]*\.css$`', $cssfile ) )
		{
			JFile::write( $cssfile, $css );
		}
		// update cbextra view
		$cbextra = JRequest::getVar( 'cbextra' );
		$query = 'DROP VIEW IF EXISTS cbextraview';
		if( count( $cbextra ) > 0 && $_JMLConfig->has->cb )
		{
			$query = 'CREATE OR REPLACE VIEW cbextraview AS ';
			foreach( $cbextra as $extrafield )
			{
				$query .= ( preg_match( '`SELECT`', $query ) ? 'UNION ALL (' : '(' )
				       .  'SELECT DISTINCT '
				       .  'vcb.`user_id`, vf.`ordering`, CAST( CONCAT( vf.`title`, ": ", vcb.'.$_JMLConfig->db->nameQuote( $extrafield ).' ) AS CHAR ) AS data '
				       .  'FROM `#__comprofiler` AS vcb '
				       .  'LEFT JOIN `#__comprofiler_fields` AS vf'
				       .  ' ON ( vf.`name` = '.$_JMLConfig->db->quote( $extrafield ).' ) '
				       .  'WHERE vcb.'.$_JMLConfig->db->nameQuote( $extrafield ).' IS NOT NULL '
				       .  'AND vcb.'.$_JMLConfig->db->nameQuote( $extrafield ).' <> "" '
				       .  ') '
				       ;
			}
			$query .= 'ORDER BY `ordering` ASC';
		}
		$_JMLConfig->db->setQuery( $query );
		$_JMLConfig->db->query();
		$_JMLConfig->db->setQuery( 'UPDATE `#__jmylife_configuration` SET `value` = '.$_JMLConfig->db->quote( serialize( $cbextra ) ).' WHERE `key` = "cbextra"' );
		$_JMLConfig->db->query();

		// lower case for 1.6
		$appl->enqueuemessage(JText::_('COM_JMYLIFE_CONFIGURATION_SAVED'));
		$appl->redirect( 'index.php?option=com_jmylife&view=configuration' );
	}

	/**
	 * function to load contents of css file
	 * @since 1.0.9
	 */
	function loadcss()
	{
		$cssfile = JFile::makeSafe( JRequest::getVar('file') );
		$cssfile = realpath( JPATH_SITE.DS.'components'.DS.'com_jmylife'.DS.'assets'.DS.'css'.DS.'custom'.DS.$cssfile );
		header( 'Content-type: text/css' );
		die( JFile::read( $cssfile ) );
	}

	/**
	 * function to show preview in iframe for custom css
	 * @since 1.0.9
	 */
	function preview()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$itembg = $_JMLConfig->get( 'story_background', 'efefef' );
		if( strlen( $itembg ) == 0 ) $itembg = 'efefef';
		$jmlStyle = ".comJMyLifeItem,.comJMyLifeComment{background:#{$itembg};}";
		// get file
		$file = JRequest::getVar('file');
		if( $file )
		{
			$file = JFile::makeSafe( $file );
			$file = JURI::root().'components/com_jmylife/assets/css/custom/'.$file.'?ck='.time();
		}
		$ieroundie = '';
		if( $_JMLConfig->getInt( 'site_roundies', 1 ) == 1 )
		{
			// get/set roundies
			$radius = $_JMLConfig->getInt( 'roundies_radius', 4 );
			if( $radius > 0 )
			{
				$jmlStyle .= ".jmylifeRound{-webkit-border-radius:{$radius}px;-moz-border-radius:{$radius}px;-khtml-border-radius:{$radius}px;border-radius:{$radius}px;}";
				// roundies for IE
				if( isset( $_SERVER['HTTP_USER_AGENT'] ) && ( strpos( $_SERVER['HTTP_USER_AGENT'], 'MSIE' ) !== false ) && intval( $_JMLConfig->get( 'ie_roundies' ) ) == 1 )
				{
					$ieroundie = '<script type="text/javascript" src="'.$assetPath.'js/DD_roundies_0.0.2a-min.js"></script>';
					$jmlStyle .= "DD_roundies.addRule( '.jmylifeRound', '{$radius}px' );";
				}
			}
		}
		// send a dummy html for iframe preview
		?><html>
<head>
	<link rel="stylesheet" href="<?php echo JURI::base().'templates/system/css/system.css'; ?>" type="text/css" />
	<link rel="stylesheet" href="<?php echo JURI::root().'components/com_jmylife/assets/css/styles.css'; ?>" type="text/css" />
	<style type="text/css">
		<?php echo $jmlStyle; ?>
	</style>
<?php if( $file ): ?>
	<link rel="stylesheet" href="<?php echo $file; ?>" type="text/css" />
<?php endif; ?>
<?php if( strlen( $ieroundie ) > 0 ) echo $ieroundie; ?>
</head>
<body>
	<h3>div.comJMyLifeItem.jmylifeRound</h3>
	<div class="comJMyLifeItem jmylifeRound">
		<div class="comJMyLifeItemTitle">
				<a href="#">.comJMyLifeItemTitle a</a>
		</div>
		<div class="comJMyLifeItemText">div.comJMyLifeItemText
			<span class="comJMyLifeItemPretext">span.comJMyLifeItemPretext</span>
			div.comJMyLifeItemText
			<span class="comJMyLifeItemPosttext">span.comJMyLifeItemPosttext</span>
		</div>
		<div class="comJMyLifeItemReadComments">
			<a href="#"># (0)</a>
		</div>
		<div class="comJMyLifeItemInfo">
			<div class="comJMyLifeItemVote">
				div.comJMyLifeItemInfo div.comJMyLifeItemVote
			</div>
			<div class="comJMyLifeItemAuthor">
			<?php
				$catlink = '<a href="#">div.comJMyLifeItemAuthor a</a>';
				echo JText::sprintf( 'STORYINFOFORMAT', date( JText::_( 'STORYDATEFORMAT' ), time() ), date( JText::_( 'STORYTIMEFORMAT' ), time() ), $catlink, 'Howard Moon' );
			?>
			</div>
		</div>
		<div class="comJMyLifeItemResponse">
			div.comJMyLifeItemResponse
		</div>
		<div class="comJMyLifeItemFooter">
			div.comJMyLifeItemFooter
		</div>
	</div>
</body>
</html>
<?php
		die();
	}

	/**
	 * function to fetch API key for Disqus
	 * @since 1.0.11
	 */
	function fetchdisqusapikey()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		echo JmylifeCommon::getRemoteData( 'http://disqus.com/api/get_my_key/', array() );
		die();
	}

	/**
	 * function to fetch forum key for Disqus
	 * @since 1.0.11
	 */
	function fetchdisqusforumkey()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$key = JRequest::getString( 'apikey' );
		$shortname = JRequest::getString( 'shortname' );
		$rawdata = JmylifeCommon::getRemoteData( 'http://disqus.com/api/get_forum_list?user_api_key='.$key, array() );
		$jsondata = @json_decode( $rawdata );
		// only continue if array is present
		if( $jsondata->code == 'ok' && is_array( $jsondata->message ) )
		{
			$forumid = '';
			foreach( $jsondata->message as $forum )
			{
				if( $forum->shortname == $shortname )
				{
					// found forum, get forum key
					$rawforumdata = JmylifeCommon::getRemoteData( 'http://disqus.com/api/get_forum_api_key?user_api_key='.$key.'&forum_id='.$forum->id, array() );
					$forumjsondata = @json_decode( $rawforumdata );
					if( $forumjsondata->code == 'ok' )
					{
						echo $forumjsondata->message;
					}
					// found forum, break out of loop
					break;
				}
			}
		}
		die();
	}

}