<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/controllers/integrations.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.12
 */
// No direct access
defined('_JEXEC') or die('Restricted access');
// imports
jimport( 'joomla.application.component.controller' );
JLoader::import('components.com_jmylife.helpers.extensions', JPATH_ADMINISTRATOR, '');

/**
 * JMyLife Component Integrations Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerIntegrations extends JController
{
	var $installer;
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct( $default=array() )
	{
		$this->installer = JmylifeExtensionsHelper::getInstance();
		parent::__construct( $default );
	}

	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		parent::display();
	}

	function install( $pkgtype )
	{
		$appl =& JFactory::getApplication();
		$msg = JText::_('COM_JMYLIFE_ERROR_INTEGRATIONS_COULDNOTINSTALL');
		$return = JRoute::_('index.php?option=com_jmylife&view=integrations',false);
		$count = 0;
		$installed = 0;
		$pkgs = $this->installer->packages();
		if( isset( $pkgs[$pkgtype] ) )
		{
			$count = count( $pkgs[$pkgtype] );
			if( $count )
			{
				foreach( $pkgs[$pkgtype] as $pkg => $data )
				{
					switch( $pkgtype )
					{
						case 'jomsocial':
							if( $this->installer->installJomSocialPlugin( $pkg, $data ) ) $installed++;
							break;
						case 'cb':
							if( $this->installer->installCommunityBuilderPlugin( $pkg, $data ) ) $installed++;
							break;
						case 'joomlacomment':
							if( $this->installer->installJoomlaCommentPlugin() ) $installed++;
							break;
						case 'xmap':
							if( $this->installer->installXmapPlugin() ) $installed++;
							break;
					}
				}
			}
		}
		if( 0 == $count ) $appl->redirect( $return, JText::_('COM_JMYLIFE_ERROR_INTEGRATIONS_NONEFOUND') );
		if( 0 < $count && 0 < $installed )
		{
			if( $count == $installed ) $msg = JText::_('COM_JMYLIFE_INTEGRATIONS_ALLINSTALLED');
			else $msg = JText::_('COM_JMYLIFE_ERROR_INTEGRATIONS_SOMEINSTALLED');
		}
		$appl->redirect( $return, $msg );

	}

	function cb()
	{
		$this->install( 'cb' );
	}

	function jomsocial()
	{
		$this->install( 'jomsocial' );
	}

	function joomlacomment()
	{
		$this->install( 'joomlacomment' );
	}

	function xmap() {
		$this->install('xmap');
	}
}