<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/controllers/moderate.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.controller' );

/**
 * JMyLife Component Moderate Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerModerate extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct( $default=array() )
	{
		parent::__construct( $default );
		$this->registerTask( 'add', 'edit' );
	}

	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		parent::display();
	}
	
	function remove()
	{
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$database =& JFactory::getDBO();
		$cid 		  = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );
		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_DELETE', true));
		}
		$cids = implode( ',', $cid );
		
		$query = 'DELETE FROM #__jmylife_stories'
		       . ' WHERE id IN ( '.$cids.' )'
		;
		
		$database->setQuery( $query );
		if( !$database->query() )
		{
			JError::raiseError( 500, $database->getErrorMsg() );
		}
		$appl->redirect('index.php?option=com_jmylife&view=moderate', JText::_('COM_JMYLIFE_STORY_DELETED'));
	}
	
	function unpublish()
	{
		$this->publish( 0 );
	}
	function publish( $publish=1 )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$action = $publish ? 'publish' : 'unpublish';
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );

		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_'.strtoupper($action), true));
		}
		
		$cids = implode( ',', $cid );
		
		$query = 'UPDATE #__jmylife_stories'
		       . ' SET published = '.(int)$publish
		       . ' WHERE id IN ( '.$cids.' )'
		;
		
		$_JMLConfig->db->setQuery( $query );
		if( !$_JMLConfig->db->query() )
		{
			JError::raiseError( 500, $_JMLConfig->db->getErrorMsg() );
		}
		// since 1.0.9, send notification to user if all settings allow for it
		if( $publish == 1 )
		{
			// get email(s) from db
			$query = 'SELECT
jml.`id`, jml.`user_alias`, jml.`user_id`, jml.`user_email`, jml.`fulltext`, jml.`title`, u.`email`
FROM `#__jmylife_stories` AS jml
LEFT JOIN `#__users` AS u ON jml.`user_id` = u.`id`
WHERE jml.`id` IN ( '.$cids.' )';
			$_JMLConfig->db->setQuery( $query );
			if( $rows = $_JMLConfig->db->loadObjectList() )
			{
				// loop recipents, send to "proper" mail
				foreach( $rows as $row )
				{
					if( $_JMLConfig->getInt( 'notify_author_stories', 0 ) == 1 )
					{
						$email = '';
						// user email takes precedence, then comes story email
						if( strlen( $row->email.'' ) > 0 ) $email = $row->email;
						else if( strlen( $row->user_email.'' ) > 0 ) $email = $row->user_email;
						// no need to continue if the email is invalid (meaning: anonymous stories with no email)
						else break;
						// TODO: validate email somehow?
						JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
						$mailer = JmylifeEmailHelper::getInstance();
						$mailer->authorPublished( $row->id, $email );
					}

					if( $_JMLConfig->allow->jomsocial )
					{
						// handle points
						$userpoints = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'userpoints.php';
						if( JFile::exists( $userpoints ) )
						{
							include_once( $userpoints );
							CuserPoints::assignPoint('jmylife.story.publish', $row->user_id);
						}
						// add to JomSocial activity stream, if enabled
						if( $_JMLConfig->getInt('jomsocial_activities_stories',0) )
						{
							if( $user->id > 0 || $_JMLConfig->getInt('jomsocial_activities_stories_guest',0) )
								JmylifeCommon::updateJomSocialActivity( 'story.published', $row->id, $row->user_id );
						}
					}
				}
			}
		}
		$appl->redirect( 'index.php?option=com_jmylife&view=moderate' );
	}
	function edit()
	{
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );
		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_EDIT', true));
		}
		JRequest::setVar( 'cid', $cid[0] );
		JRequest::setVar( 'view', 'moderate' );
		JRequest::setVar( 'layout', 'form' );
		JRequest::setVar( 'hidemainmenu', 1 );
		parent::display();
	}
	function cancel()
	{
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$appl->redirect( 'index.php?option=com_jmylife&view=moderate' );
	}
	function apply()
	{
		$this->save( true );
	}
	function save($apply=false) {
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		// initialize variables
		$uid          = JRequest::getInt( 'user_id', 0 );
		$alias        = JRequest::getString( 'user_alias' );
		$email        = JRequest::getString( 'user_email' ); // since 1.0.9
		$catid        = JRequest::getInt( 'catid', 0 );
		$fulltext     = JRequest::getString( 'fulltext' );
		$admintext    = JRequest::getString( 'admin_fulltext', '' ); // since 1.0.5
		$title        = JRequest::getString( 'title', '' ); // since 1.0.5
		$allowcomment = JRequest::getInt( 'allow_comments', 1 ); // since 1.0.5
		$allowvotes   = JRequest::getInt( 'allow_votes', 1 ); // since 1.0.5
		$published    = JRequest::getInt( 'published', 0 );
		$time         = JRequest::getInt( 'time', time() );
		$cids         = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cids, array(0) );
		if (1 != count($cids)) {
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_SAVE', true));
		}
		$cid = $cids[0];
		// handle bad data here
		if (0 == strlen($alias)) {
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_UNDEFINEDALIAS', true));
		}
		if (0 == $catid) {
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_NOCATEGORY', true));
		}
		if (0 == strlen($fulltext)) {
			// BUGFIX: only raise error if blanks aren't allowed
			if (0 == $_JMLConfig->getInt('allow_attachment_blankstory') && $_JMLConfig->getInt('allow_storyattachment')) {
				JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_NOTEXT', true));
			}
		}
		// truncate fulltext if necessary
		if ($limit = $_JMLConfig->getInt('editor_length', 0)) {
			JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
			$string = JmylifeStringHelper::getInstance();
			$fulltext = $string->shorten($fulltext, $limit, false);
		}
		// only check title if required
		if (0 == strlen($title) && $_JMLConfig->getInt('allow_titles') && $_JMLConfig->getInt('require_titles')) {
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_NOTITLE', true));
		}
		// insert/update
		$data = array(
			'catid'          => $catid,
			'time'           => $time,
			'fulltext'       => $_JMLConfig->db->Quote( $fulltext ),
			'published'      => $published,
			'user_id'        => $uid,
			'user_alias'     => $_JMLConfig->db->Quote( $alias ),
			'user_email'     => $_JMLConfig->db->Quote( $email ),
			'allow_comments' => $allowcomment,
			'allow_votes'    => $allowvotes,
			'admin_fulltext' => $_JMLConfig->db->Quote( $admintext ),
			'title'          => $_JMLConfig->db->Quote( $title )
		);
		// since 1.0.10, fix for notifications
		// check current publish status
		$_JMLConfig->db->setQuery('SELECT `published` FROM `#__jmylife_stories` WHERE `id` = '.$cid);
		$pub = intval($_JMLConfig->db->loadResult());
		if (0 < $cid && 0 == $pub && $published) {
			// get email(s) from db
			$query = 'SELECT
jml.`id`, jml.`user_alias`, jml.`user_id`, jml.`user_email`, jml.`fulltext`, jml.`title`, u.`email`
FROM `#__jmylife_stories` AS jml
LEFT JOIN `#__users` AS u ON jml.`user_id` = u.`id`
WHERE jml.`id` = '.$cid;
			$_JMLConfig->db->setQuery($query);
			if ($rows = $_JMLConfig->db->loadObjectList()) {
				// loop recipents, send to "proper" mail
				foreach ($rows as $row) {
					if ($_JMLConfig->getInt('notify_author_stories', 0)) {
						$email = '';
						// user email takes precedence, then comes story email
						if (strlen($row->email.'')) {
							$email = $row->email;
						}
						else if (strlen($row->user_email.'')) {
							$email = $row->user_email;
						}
						// no need to continue if the email is invalid (meaning: anonymous stories with no email)
						else break;
						// TODO: validate email somehow?
						JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
						$mailer = JmylifeEmailHelper::getInstance();
						$mailer->authorPublished($row->id, $email);
					}
					if ($_JMLConfig->allow->jomsocial) {
						// handle points
						$userpoints = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'userpoints.php';
						if (JFile::exists($userpoints)) {
							include_once ($userpoints);
							CuserPoints::assignPoint('jmylife.story.publish', $row->user_id);
						}
						// add to JomSocial activity stream, if enabled
						if ($_JMLConfig->getInt('jomsocial_activities_stories',0)) {
							if (0 < $user->id || $_JMLConfig->getInt('jomsocial_activities_stories_guest',0)) {
								JmylifeCommon::updateJomSocialActivity('story.published', $row->id, $row->user_id);
							}
						}
					}
				}
			}
		}
		if (0 == $cid) {
			// use current admin id for user_id
			$user =& JFactory::getUser();
			$data['user_id'] = $user->id;
			// save new record
			$query = 'INSERT INTO `#__jmylife_stories` ( '
			       . '`'.implode( '`, `', array_keys( $data ) ).'`'
			       . ' ) VALUES ( '
			       . implode( ', ', $data ).' '
			       . ' )'
			       ;
			$_JMLConfig->db->setQuery($query);
			$_JMLConfig->db->query();
			$cid = $_JMLConfig->db->insertid();
			// add to JomSocial activity stream, if enabled
			if ($_JMLConfig->allow->jomsocial) {
				// handle points
				$userpoints = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'userpoints.php';
				if (JFile::exists($userpoints)) {
					include_once ($userpoints);
					CuserPoints::assignPoint('jmylife.story.publish', $data['user_id']);
				}
				// add to JomSocial activity stream, if enabled
				if ($_JMLConfig->getInt('jomsocial_activities_stories',0)) {
					if (0 < $user->id || $_JMLConfig->getInt('jomsocial_activities_stories_guest',0)) {
						JmylifeCommon::updateJomSocialActivity('story.published', $cid, $user->id);
					}
				}
			}
		} else {
			// don't reset time if saving old data
			unset ($data['time']);
			// since this is an update, save a copy of the current data to the versions table
			// but only do so if the source is different
			$backupKeys = array('catid', 'fulltext', 'user_id', 'user_alias', 'user_email', 'title');
			$user = JFactory::getUser();
			$uid = $user->id;
			$oldQuery = "SELECT NULL AS id, `id` AS sid, `catid`, `fulltext`, `user_id`, `user_alias`, `user_email`, `title`, NOW() AS changed, {$uid} AS edited_by FROM #__jmylife_stories WHERE id = {$cid}";
			$_JMLConfig->db->setQuery($oldQuery);
			if ($oldStory = $_JMLConfig->db->loadObject()) {
				// check this one vs the old one
				$diff = false;
				foreach ($backupKeys as $key) {
					if (@$data[$key] == (in_array($key, array('catid', 'user_id')) ? intval($oldStory->{$key}) : $_JMLConfig->db->Quote($oldStory->{$key}))) {
						continue;
					}
					$diff = true;
				}
				if ($diff) {
					$query = "INSERT INTO #__jmylife_stories_versions ({$oldQuery})";
					$_JMLConfig->db->setQuery($query);
					$_JMLConfig->db->query();
				}
			}
			$vals = array();
			foreach ($data as $key => $val) {
				$vals[] = "`$key` = $val";
			}
			$query = 'UPDATE `#__jmylife_stories` SET '.implode(',', $vals)
			       . ' WHERE `id` = '.$cid.' LIMIT 1'
			       ;
			$_JMLConfig->db->setQuery($query);
			$_JMLConfig->db->query();
		}
		$appl->redirect('index.php?option=com_jmylife&view=moderate&controller=moderate'.($apply ? '&task=edit&cid='.$cid : ''), JText::_('COM_JMYLIFE_STORY_SAVED'));
	}
	// since 1.0.5
	function unallowcomments()
	{
		$this->allowcomments( 0 );
	}
	function allowcomments( $allow=1 )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// Initialize variables
		$database =& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$uid	= $user->get( 'id' );
		$action = $allow ? 'en' : 'dis';
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );

		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_'.strtoupper($action).'ABLE_COMMENTS', true ) );
		}
		
		$cids = implode( ',', $cid );
		
		$query = 'UPDATE #__jmylife_stories'
		       . ' SET allow_comments = '.(int)$allow
		       . ' WHERE id IN ( '.$cids.' )'
		;
		
		$database->setQuery( $query );
		if( !$database->query() )
		{
			JError::raiseError( 500, $database->getErrorMsg() );
		}
		$appl->redirect( 'index.php?option=com_jmylife&view=moderate' );
	}
	// since 1.0.5
	function unallowvotes()
	{
		$this->allowvotes( 0 );
	}
	function allowvotes( $allow=1 )
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// Initialize variables
		$database =& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$uid	= $user->get( 'id' );
		$action = $allow ? 'en' : 'dis';
		$cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger( $cid, array(0) );

		if( count( $cid ) < 1 )
		{
			JError::raiseError(500, JText::_('COM_JMYLIFE_ERROR_STORY_'.strtoupper($action).'ABLE_VOTES', true));
		}
		
		$cids = implode( ',', $cid );
		
		$query = 'UPDATE #__jmylife_stories'
		       . ' SET allow_votes = '.(int)$allow
		       . ' WHERE id IN ( '.$cids.' )'
		;
		
		$database->setQuery( $query );
		if( !$database->query() )
		{
			JError::raiseError( 500, $database->getErrorMsg() );
		}
		$appl->redirect( 'index.php?option=com_jmylife&view=moderate' );
	}
}