<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/elements/color.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since      1.0.11
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// get config class
jimport('joomla.filesystem.file');
if( !class_exists( 'JmylifeConfiguration' ) )
{
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if( JFile::exists( $configfile ) ) require_once( $configfile );
}

/**
 * Color element class for the JMyLife Component
 *
 * @package    JMyLife
 */
class JElementColor extends JElement
{
	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		  string
	 */
	var	$_name = 'Color';

	function fetchElement($name, $value, &$node, $control_name, $isArray=true, $clear=false)
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$fieldName  = $isArray ? $control_name.'['.$name.']' : $name;
		// load necessary scripts
		$libPath = JURI::root().'components/com_jmylife/libraries/';
		$document = JFactory::getDocument();
		$document->addScript(JURI::root().'index.php?option=com_jmylife&controller=ajax&task=jQuery');
		$document->addScript($libPath.'jquery/colorpicker/js/colorpicker.js');
		$document->addStyleSheet($libPath.'jquery/colorpicker/css/colorpicker.css');
		$document->addScriptDeclaration( '/* colorpicker */
jmlWYSIWYGColorPickerVisible = false;
(function($){
	$(document).ready(function() {
		var cPicker = $(\'<div id="'.$name.'-rainbow"></div>\');
		var cPickerButton = $(\'#'.$name.'-preview\').css({\'background\':\'#'.$value.'\'});
		cPickerButton.after(cPicker);
		cPicker.css({position:\'absolute\',left:cPickerButton.position().left}).hide().ColorPicker({
			flat: true,
			color: \''.$value.'\',
			onShow: function(colpkr) {
				cPicker.height(173);
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function(colpkr) {
				$(colpkr).fadeOut(500, function(){
					cPicker.height(0);
				});
				return false;
			},
			onSubmit: function(hsb, hex, rgb, el) {
				cPicker.height(0);
				var newColor = hex.toString().toUpperCase();
				$(\'#'.$name.'-input\').val(newColor);
				$(\'#'.$name.'-preview\').css({\'background\':\'#\'+newColor});
				cPickerButton.trigger(\'click\');
			}
		});
		cPickerButton.click(function() {
			if (jmlWYSIWYGColorPickerVisible) {
				cPicker.stop().fadeOut(500, function(){
					cPicker.height(0);
				});
			} else {
				cPicker.height(173).stop().fadeIn(500);
			}
			jmlWYSIWYGColorPickerVisible = !jmlWYSIWYGColorPickerVisible;
		});'.
( !$clear ? '' : '
		$(\'#'.$name.'-clear\').click(function() {
			document.getElementById(\''.$name.'-input\').value = \'\';
			$(\'#'.$name.'-preview\').css({\'background\':\'none\'});
		});'
).'
	});
})(window.jml.jQuery);' );
		// build html
		$html = ' <!-- colorpicker -->
<span id="'.$name.'-rainbow" style="vertical-align:bottom;line-height:18px;">
	<strong>#</strong>
	<label>
		<input id="'.$name.'-input" name="'.$fieldName.'" type="text" size="6" value="'.$value.'" />
	</label>
	<span id="'.$name.'-preview" style="border:1px solid black;">
		<img src="'.JURI::root().'components/com_jmylife/libraries/jquery/colorpicker/images/blank.gif" alt="" width="15" height="14" />
	</span>
</span>'.
( !$clear ? '' : '<span id="'.$name.'-clear" style="cursor:pointer;vertical-align:bottom;line-height:18px;padding-left:5px;">
		<img src="'.JURI::root().'components/com_jmylife/assets/images/no.png" alt="" width="16" height="16" />
	</span>' );
		// build & return select
		return $html;
	}
}