<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * libraries/joomlacomment/com_jmylife/josc_com_jmylife.class.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since      1.0.9
 */
// No direct access
defined('_JEXEC') or die('Restricted access');

class JOSC_com_jmylife extends JOSC_component
{
	private $id;
	private $catid;
	public function __construct( $component, &$row, &$list )
	{
		$this->id = isset( $row->id ) ? $row->id : 0;
		$this->catid = isset( $row->catid ) ? $row->catid : 0;
		$this->setRowDatas( $row );
		//$this->JOSC_component( $component, 0, $this->id );
		$this->_component="com_jmylife";
		parent::__construct($component, 0, $this->id);
	}
	function setRowDatas(&$row)
	{
		/* for optimization reason, do not save row. save just needed parameters */

		//$this->_specific_data	= isset($row->specific) ? $row->specific : '';
	}

	/*
	 * This function is executed to check
	 * if section/category of the row are authorized or not (exclude/include from the setting)
	 * return : true for authorized / false for excluded
	 */
	function checkSectionCategory( &$row, $include, $sections=array(), $catids=array(), $contentids=array() )
	{
		if( in_array( ( ( $row->id == 0 ) ? -1 : $row->id ), $contentids ) ) return false;
		$result = in_array( ( ( $row->catid == 0) ? -1 : $row->catid ), $sections );
		if( ( $include && !$result ) || ( !$include && $result ) ) return false;
		return true;
	}

	/*
	 * Condition to active or not the display of the post and input form
	 * If the return is false, show readon will be executed.
	 */
	function checkVisual( $contentId=0 )
	{
		global $option, $task;
		return ( $option == 'com_jmylife' /*&& $task == 'item'*/ );
	}

	/*
	 * This function will active or deactivate the show readon display
	 */
	function setShowReadon( &$row, &$params, &$config )
	{
		$show_readon = $config->_show_readon;
		return $show_readon;
	}

	public function getPageId()
	{
		return $this->id;
	}

	private function getData( $id )
	{
		$database = JFactory::getDBO();
		$query = "SELECT s.id AS alias, s.catid, c.name as catalias FROM #__jmylife_stories AS s "
		       . ' LEFT JOIN #__jmylife_categories as c ON s.catid = c.id'
	         . ' WHERE s.id = '.$id
	         ;
		$database->setQuery( $query );
		return $database->loadObject();
	}

	/*
	 * construct the link to the content item
	 * (and also direct to the comment if commentId set)
	 */
	function linkToContent( $contentId, $commentId='' )
	{
		$url = JRoute::_('index.php?option=com_jmylife&view=item&id='.$contentId ).($commentId ? "#josc$commentId" : "");
		return $url;
	}

	function createFeed() {
		require_once(JPATH_SITE.DS."includes".DS."feedcreator.class.php");
		require_once(JPATH_SITE.DS."components".DS."com_jmylife".DS."libraries".DS."configuration.php");
		require_once(JPATH_SITE.DS."components".DS."com_jmylife".DS."libraries".DS."common.php");
		$contentid = JRequest::getInt('contentid','','GET');
		$component = 'com_jmylife';
		$language =& JFactory::getLanguage();
		$language->load('com_jmylife', JPATH_SITE);
		$database = JFactory::getDBO();
		/*
		$database->setQuery("SELECT * FROM #__jmylife_stories WHERE id='$contentid'");
		$content = $database->loadObject();
		*/
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$story = JmylifeStoryHelper::getInstance();
		$database->setQuery($story->buildQuery(array('view' => 'item', 'id' => $contentid)));
		$content = $database->loadObject();
		if ($content) {
			JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
			$html = JmylifeHtmlHelper::getInstance();
			$content = $html->unclean($story->prepare($content, 'item'));
		}
		$rss = new UniversalFeedCreator();
		$folderPath = JPATH_SITE . DS .'media'.DS. 'com_jmylife'.DS.'rss'.DS .$component;
		$folderExists = JFolder::exists($folderPath);
		if(!$folderExists) {
			JFolder::create($folderPath);
		}
		$rss->useCached("RSS2.0", $folderPath.DS.'joscfeed'.$contentid.'.xml');
		// TODO: make proper titles here

		$title = $content->title;
		if (0 == strlen($title)) {
			$title = JText::sprintf('COM_JMYLIFE_COMPOJOOMCOMMENT_TITLE', $content->user_alias);
		}
		$rss->title = "{$title} - comments";
		$rss->description = $content->fulltext;
		$rss->link = JURI :: base();
		$database->setQuery("SELECT *, UNIX_TIMESTAMP( date ) AS rss_date FROM #__comment WHERE contentid='$contentid' AND component='$component' AND published='1' ORDER BY id DESC", '', 100);
		$data = $database->loadAssocList();
		if ($data != null) {
			foreach($data as $item) {
				$rss_item = new FeedItem();
				$rss_item->author = $item['name'];
				if(strcmp($item['title'],'')) {
					$rss_item->title = stripslashes($item['title']);
				}else {
					$rss_item->title = JText::_('COM_JMYLIFE_COMPOJOOMCOMMENT_NOTITLE');
				}
				$rss_item->link = $content->fullstorylink.'#josc'.$item['id'];
				$rss_item->description = stripslashes($item['comment']);
				$rss_item->date = date('r', $item['rss_date']);
				$rss->addItem($rss_item);
			}
		}
		$rss->cssStyleSheet = "http://www.w3.org/2000/08/w3c-synd/style.css";
		$rss->saveFeed("RSS2.0", $folderPath.DS.'joscfeed'.$contentid.'.xml');
	}

	/*
	 * clean the cache of the component when comments are inserted/modified...
	 * (if cache is active)
	 */
	function cleanComponentCache()
	{
		$cache =& JFactory::getCache( 'com_jmylife' );
		$cache->clean( 'com_jmylife' );
	}

	/*----------------------------------------------------------------------------------
	 *  F U N C T I O N S   F O R   A D M I N   P A R T
	 *----------------------------------------------------------------------------------
	 */

	/*
	 * section option list used to display the include/exclude section list in setting
	 * must return an array of objects (id,title)
	 */
	function getSectionsIdOption()
	{
		return array();
	}

	/*
	 * categories option list used to display the include/exclude category list in setting
	 * must return an array of objects (id,title)
	 */
	function getCategoriesIdOption()
	{
		$database = JFactory::getDBO();
		$catoptions = array();
		$query 	= "SELECT id, name AS title"
				. "\n FROM #__jmylife_categories"
				. "\n WHERE published = 1"
				. "\n ORDER BY title"
				;
		$database->setQuery( $query );
		$catoptions = $database->loadObjectList();
		return $catoptions;
	}

	/*
	 * content items list (or single) for new and edit comment
	 * must return an array of objects (id,title)
	 */
	function getObjectIdOption( $id=0, $select=true )
	{
		$database = JFactory::getDBO();
		$content = array();
		$query 	= "SELECT id, title"
				. "\n FROM #__jmylife_stories "
				. ($id ? "\n WHERE id = $id":"")
				. "\n ORDER BY time DESC"
				;
		$database->setQuery( $query );
		$content = $database->loadObjectList();
		$language =& JFactory::getLanguage();
		$language->load('com_jmylife', JPATH_SITE);
		if( !$id && $select && count( $content ) > 0 )
		{
			array_unshift( $content, mosHTML::makeOption( '0', JText::_('COM_JMYLIFE_COMPOJOOMCOMMENT_SELECT'), 'id', 'title' ) );
		}

		return $content;
	}
	function getViewTitleField()
	{
		$title = 'title';
		return $title;
	}
	function getViewJoinQuery( $alias, $contentid )
	{
		$leftjoin	= "\n LEFT JOIN #__jmylife_stories AS $alias ON $alias.id = $contentid ";
		return $leftjoin;
	}

	/*----------------------------------------------------------------------------------
	 *  F U N C T I O N S   F O R   MOD_COMMENTS   M O D U L E
	 *----------------------------------------------------------------------------------
	 */
	function mod_commentsGetMostCommentedQuery( $secids, $catids, $maxlines )
	{
		$database = JFactory::getDBO();
		$component = $this->_component;
		$limit = $maxlines>=0 ? " limit $maxlines " : "";

		$where = array();
		if ($secids)
			$where[] = "cat.id IN ($secids)";

	    /*
	     * Count comment id group by contentid
   	 	 * TODO: restrict according to user rights, dates and category/secitons published and dates...
	     */
	    $query = "SELECT COUNT(c.id) AS countid, ct.id, CONCAT('Story By ',ct.user_alias) AS title "
	           . "\n FROM `#__comment` AS c "
	           . "\n INNER JOIN `#__jmylife_stories` AS ct ON ct.id = c.contentid "
	           . "\n INNER JOIN `#__jmylife_categories` AS cat ON cat.id = ct.catid "
	           . "\n WHERE c.published='1' "
	           . "\n   AND c.component='$component' "
	           . "\n ". (count($where) ? (" AND ".implode(" AND ", $where)) : "")
	           . "\n GROUP BY c.contentid"
	           . "\n ORDER BY countid DESC"
	           . "\n $limit"
	           ;
		$database->SetQuery($query);
		$rows = $database->loadAssocList();

		return $rows;
	}

	function mod_commentsGetOthersQuery($secids, $catids, $maxlines, $orderby)
	{
		$database = JFactory::getDBO();

		$component = $this->_component;

		$limit = $maxlines>=0 ? " limit $maxlines " : "";

		$where = array();
		if ($secids)
			$where[] = "cat.id IN ($secids)";

		if ($orderby=='mostrated') {
			$mostrated =  ", (c.voting_yes-c.voting_no)/2 AS mostrated";
			$where[]  = "(c.voting_yes > 0 OR c.voting_no > 0)";
		} else {
			$mostrated = "";
			$orderby = "c.$orderby";
		}

    	/*
   	 	 * TODO: restrict according to user rights, dates and category/secitons published and dates...
   	 	 */
		$query 	=  "SELECT c.*, CONCAT('Story By ',ct.user_alias) AS ctitle $mostrated "
				.  "\n FROM `#__comment`    AS c "
				.  "\n INNER JOIN `#__jmylife_stories`    AS ct  ON ct.id = c.contentid "
     		.  "\n INNER JOIN `#__jmylife_categories` AS cat ON cat.id = ct.catid "
				.  "\n WHERE c.published='1' "
				.	"\n  AND c.component='$component' "
				.  "\n ". (count($where) ? (" AND ".implode(" AND ", $where)) : "")
				.  "\n ORDER BY $orderby DESC "
				.  "\n $limit"
				;
		$database->SetQuery($query);
		$rows = $database->loadAssocList();

		return $rows;
	}

}