<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/extensions/xmap/com_jmylife.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined('_JEXEC') or die('Restricted access');
// get core
jimport('joomla.filesystem.file');
if (!class_exists('JmylifeConfiguration')) {
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if (JFile::exists($configfile)) {
		require_once($configfile);
	}
}

class xmap_com_jmylife {
	function prepareMenuItem(&$node,&$params) {
		$cfg = JmylifeConfiguration::getInstance();
		$link_query = parse_url($node->link);
		parse_str(html_entity_decode($link_query['query']), $link_vars);
		$view = JArrayHelper::getValue($link_vars, 'view', '');
		$id = intval(JArrayHelper::getValue($link_vars, 'id', 0));
		$layout = JArrayHelper::getValue($link_vars, 'layout', '');
		switch ($view) {
			case 'category':
				$node->uid = 'com_jmylife' . $id;
				$node->expandible = true;
				break;
			case 'item':
				$node->expandible = false;
				if ($id) {
					$node->uid = 'com_jmylifes' . $id;
					$cfg->db->setQuery(
						"SELECT UNIX_TIMESTAMP(time) as modified, "
						. "UNIX_TIMESTAMP(time) as created, "
						. "`fulltext` "
						. "FROM #__jmylife_stories WHERE id=" . $id
					);
					$item = $cfg->db->loadObject();
					if (!$item->modified) {
						$item->modified = $item->created;
					}
					$node->modified = $item->modified;
					$node->expandible = false;
			}
		}
	}

	function getTree(&$xmap, &$parent, &$params) {
		$result = null;
		$link_query = parse_url($parent->link);
		parse_str(html_entity_decode($link_query['query']), $link_vars);
		$view = JArrayHelper::getValue($link_vars, 'view', '');
		$layout = JArrayHelper::getValue($link_vars, 'layout', '');
		$id = intval(JArrayHelper::getValue($link_vars, 'id', 0));
		$menu = & JSite::getMenu();
		$menuparams = $menu->getParams($parent->id);
		//----- Set expand_categories param
		$expand_categories = JArrayHelper::getValue($params, 'expand_categories', 1);
		$expand_categories = ( $expand_categories == 1
			|| ( $expand_categories == 2 && $xmap->view == 'xml')
			|| ( $expand_categories == 3 && $xmap->view == 'html')
			|| $xmap->view == 'navigator');
		$params['expand_categories'] = $expand_categories;
		//----- Set cat_priority and cat_changefreq params
		$priority = JArrayHelper::getValue($params, 'cat_priority', $parent->priority);
		$changefreq = JArrayHelper::getValue($params, 'cat_changefreq', $parent->changefreq);
		if ($priority == '-1')
			$priority = $parent->priority;
		if ($changefreq == '-1')
			$changefreq = $parent->changefreq;
		$params['cat_priority'] = $priority;
		$params['cat_changefreq'] = $changefreq;
		//----- Set story_priority and story_changefreq params
		$priority = JArrayHelper::getValue($params, 'story_priority', $parent->priority);
		$changefreq = JArrayHelper::getValue($params, 'story_changefreq', $parent->changefreq);
		if ($priority == '-1')
			$priority = $parent->priority;
		if ($changefreq == '-1')
			$changefreq = $parent->changefreq;
		$params['story_priority'] = $priority;
		$params['story_changefreq'] = $changefreq;
		$params['keywords'] = JArrayHelper::getValue($params, 'keywords', 'metakey');
		switch ($view) {
			case 'list':
				if ($params['expand_categories']) {
					xmap_com_jmylife::getJmylifeCategory($xmap, $parent, $id, $params, $menuparams);
				}
				break;
		}
		return true;
	}
   function getJmylifeCategory(&$xmap, &$parent, $catid, &$params, &$menuparams) {
		$query =
			"SELECT a.id, a.title, a.user_alias, UNIX_TIMESTAMP(a.time) as modified, UNIX_TIMESTAMP(a.time) as `created`, a.catid" .
			',c.name as category' .
			', a.fulltext' .
			"\n FROM #__jmylife_stories AS a,#__jmylife_categories AS c" .
			"\n WHERE a.catid=c.id" .
			(0 < $catid ? "\n AND a.catid=(" . $catid . ")" : '') .
			"\n AND a.published='1' " .
			"\n ORDER BY a.time DESC"
		;
		return xmap_com_jmylife::showStories($xmap, $parent, $params, $query);
	}
	function showStories(&$xmap, &$parent, $params, $query) {
		$language =& JFactory::getLanguage();
		$language->load('com_jmylife', JPATH_SITE);
		$db = & JFactory::getDBO();
		$db->setQuery($query);
		$db->getQuery();
		$items = $db->loadObjectList();
		static $urlBase;
		if (count($items) > 0) {
			$xmap->changeLevel(1);
			foreach ($items as $item) {
				// Ignore old items for news sitemap
				if ($xmap->isNews && $item->time < ($xmap->now - (2 * 86400))) {
					continue;
				}
				$subnodes = array();
				$node = new stdclass();
				$node->id = $parent->id;
				$node->uid = $parent->uid . 'a' . $item->id;
				$node->browserNav = $parent->browserNav;
				$node->priority = $params['story_priority'];
				$node->changefreq = $params['story_changefreq'];
				$title = $item->title;
				if (0 == strlen($title)) {
					$title = JText::sprintf('COM_JMYLIFE_XMAP_STORYBY', $item->user_alias);
				}
				$node->name = $title;
				$node->expandible = false;
				$node->newsItem = 1;
				// For the google news we should use te publication date instead
				// the last modification date. See
				$node->modified = (@$item->modified ? $item->modified : $item->created);
				JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
				$itemid = JmylifeItemidHelper::getInstance();
				$node->link = JRoute::_('index.php?option=com_jmylife&view=item&id='.$item->id.'&Itemid='.$itemid->story($item->id));
				// Add images to the article
				$text = @$item->fulltext;
				if ($xmap->printNode($node) && $node->expandible) {
					$xmap->changeLevel(1);
					foreach ($subnodes as $subnode) {
						$subnode->id = $parent->id;
						$subnode->browserNav = $parent->browserNav;
						$subnode->priority = $params['story_priority'];
						$subnode->changefreq = $params['story_changefreq'];
						$subnode->access = $item->access;
						$xmap->printNode($subnode);
					}
					$xmap->changeLevel(-1);
				}
			}
			$xmap->changeLevel(-1);
		}
		return true;
	}
}