<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/helpers/captcha.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.14
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
if (!class_exists('JmylifeConfiguration')) {
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if( JFile::exists( $configfile ) ) require_once( $configfile );
}
JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');

class JmylifeCaptchaHelper
{
	private static $_instance;
	var $cfg;
	var $url;

	function __construct() {
		$this->cfg = JmylifeConfiguration::getInstance();
		$this->url = JmylifeUrlHelper::getInstance();
	}

	function getInstance() {
		if (!self::$_instance) {
			self::$_instance = new JmylifeCaptchaHelper();
		}
		return self::$_instance;
	}

	/**
	 * reload
	 * @return string
	 */
	function reload() {
		if (1 == $this->cfg->getInt('captcha_engine', 0)) {
			return '<script type="text/javascript">
// <!--
document.getElementById("jml_recaptcha_challenge_field").value = "";
document.getElementById("jml_recaptcha_response_field").value = "";
document.getElementById("comJMyLifeRecaptchaIframe").contentWindow.Recaptcha.reload();
// -->
</script>';
		}
		return '';
	}

	/**
	 * recaptchascript
	 * @return string
	 */
	function recaptchascript() {
		$publickey = $this->cfg->get('recaptcha_public_key');
		if (0 < strlen($publickey)) {
			return "(function($){
	$(document).ready( function(){
		Recaptcha.create('{$publickey}', 'recaptcha_div', {theme: '".$this->cfg->get('recaptcha_theme','red')."' });
	});
})(window.jml.jQuery);";
		}
		else return '';
	}

	/**
	 * display
	 * @return string
	 */
	function display() {
		$document =& JFactory::getDocument();
		$recaptcha = '';
		switch ($this->cfg->getInt('captcha_engine', 0)) {
			case 1:
				return '<!-- recaptcha iframe -->
<input type="hidden" name="recaptcha_challenge_field" id="jml_recaptcha_challenge_field" />
<input type="hidden" name="recaptcha_response_field" id="jml_recaptcha_response_field" />
<iframe id="comJMyLifeRecaptchaIframe" scrolling="no" border="0" frameborder="0" style="border:0;overflow:hidden;" src="'.$this->url->clean(JURI::root().'/index.php?option=com_jmylife&controller=ajax&task=recaptcha').'"></iframe>
';
				break;
			case 2:
				// get count from Bigo
				$this->cfg->db->setQuery('SELECT `params` FROM `#__plugins` WHERE `element` = "bigocaptcha" AND `published` = 1');
				if ($bigoparams = $this->cfg->db->loadResult()) {
					$bigocount = intval(preg_replace('`.*word_len\=([0-9]{1,}).*`', '$1', $bigoparams));
					$recaptcha = '<p>'.JText::_('COM_JMYLIFE_CAPTCHA_DESCRIPTION').'<br />'
					           . '<img src="'.JRoute::_('index.php?option=com_jmylife&controller=ajax&task=displaycaptcha').'" alt="'.JText::_('CAPTCHADISPLAY').'" />'
					           . '<br /><input type="text" name="word" size="'.$bigocount.'" />'
					           . '</p>'
					           ;
				}
				break;
			case 3:
				$captchas = $this->captchasnet();
				if ($captchas) {
					$recaptcha = '<p>'.JText::_('COM_JMYLIFE_CAPTCHA_DESCRIPTION').'<br />'
					           . '<input type="hidden" name="random" value="'.$captchas->random().'" />'
					           . $captchas->image()
					           . '<br /><input type="text" name="password" size="'.$this->cfg->get('captchasnet_count', '6').'" />'
					           . '</p>'
					           ;
				}
				break;
		}
		return $recaptcha;
	}

	/**
	 * captchasnet
	 * @return  object
	 */
	function captchasnet() {
		$captcha = false;
		$client  = $this->cfg->get('captchasnet_client', '');
		$secret  = $this->cfg->get('captchasnet_secret', '');
		$path    = JPATH_ROOT.DS.'tmp'.DS.'captchasnet-random-strings';
		if (!JFolder::exists($path)) {
			JFolder::create($path);
		}
		if (strlen($client.$secret)) {
			if (!class_exists("CaptchasDotNet")) {
				require_once (JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'CaptchasDotNet.php');
			}
			$captcha = new CaptchasDotNet(
				$client,
				$secret,
				JPATH_ROOT.DS.'tmp'.DS.'captchasnet-random-strings',
				'3600',
				'abcdefghkmnopqrstuvwxyz',
				$this->cfg->get('captchasnet_count', '6'),
				$this->cfg->get('captchasnet_width', '240'),
				$this->cfg->get('captchasnet_height', '80')
			);
		}
		return $captcha;
	}

}