<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/helpers/comment.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.14
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
if (!class_exists('JmylifeConfiguration')) {
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if( JFile::exists( $configfile ) ) require_once( $configfile );
}
JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');

class JmylifeCommentHelper
{
	private static $_instance;
	var $cfg;
	var $html;
	var $itemid;
	var $_string;
	var $url;

	function __construct() {
		$this->cfg = JmylifeConfiguration::getInstance();
		$this->html = JmylifeHtmlHelper::getInstance();
		$this->_string = JmylifeStringHelper::getInstance();
	}

	function getInstance() {
		if (!self::$_instance) {
			self::$_instance = new JmylifeCommentHelper();
		}
		return self::$_instance;
	}

	/**
	 * buildQuery
	 * @param   int
	 * @param   int
	 * @return  string
	 */
	function buildQuery($id, $published=1, $latest=false) {
		$blankquery = 'SELECT 1';
		$query = $blankquery;
		// build query based on comment engine
		// PLEASE NOTE: this query should ONLY be used for comment balloons,
		// and NOT for anything else!!!
		// since 1.0.13
		// Ignoring my previous note ;)
		// using this in link layout header
		switch ($this->cfg->getInt('comment_engine', 0)) {
			// Disqus
			// instead of hacking the getlatestcomments() task just "fake" it with a string query
			case 3:
				$key = $this->cfg->get('disqus_api_key', '');
				$forumkey = $this->cfg->get('disqus_forum_key', '');
				if (0 < strlen($forumkey)) {
					$rawdata = JmylifeCommon::getRemoteData("http://disqus.com/api/get_thread_list?user_api_key=$key&forum_api_key=$forumkey", array());
					$data = @json_decode($rawdata);
					if ('ok' == @$data->code && is_array(@$data->message) && 0 < count(@$data->message)) {
						$query = '';
						foreach (@$data->message as $d) {
							$cid = intval(preg_replace('`.*?[\&|\?]id\=([0-9]{1,}).*?`', '$1', $d->url));
							if ($cid == $id) {
								$rawthreaddata = JmylifeCommon::getRemoteData("http://disqus.com/api/get_thread_posts?user_api_key=$key&forum_api_key=$forumkey&thread_id={$d->id}", array() );
								$threaddata = @json_decode($rawthreaddata);
								if ('ok' == @$threaddata->code && is_array(@$threaddata->message) && 0 < count(@$threaddata->message)) {
									foreach (@$threaddata->message as $thread) {
										if ($thread->shown) {
											$query .= (preg_match('`SELECT`', $query) ? ' UNION SELECT ' : 'SELECT '). $this->cfg->db->Quote(@$thread->message).' AS message';
										}
									}
								}
							}
						}
					}
				}
				if (0 == strlen($query)) {
					$query = $blankquery;
				}
				break;
			// !joomlacomments
			case 2:
				$query = 'SELECT `comment` AS message FROM `#__comment` WHERE `component` = "com_jmylife" AND `contentid` = '.intval($id);
				if ($published >= 0) {
					$query .= ' AND `published` = '.intval($published);
				}
				break;
			// jcomments
			case 1:
				$query = 'SELECT `comment` AS message FROM `#__jcomments` WHERE `object_group` = "com_jmylife" AND `object_id` = '.intval($id);
				if ($published >= 0) {
					$query .= ' AND `published` = '.intval($published);
				}
				break;
			// jomcomment
			case 4:
				$query = 'SELECT `comment` AS message FROM `#__jomcomment` WHERE `option` = "com_jmylife" AND `contentid` = '.intval($id);
				if ($published >= 0) {
					$query .= ' AND `published` = '.intval($published);
				}
				break;
			// core
			case 0:
				// var init
				$join = 'LEFT JOIN `#__jmylife_comments_warnings` AS w'
				      . ' ON ( c.`id` = w.`cid` ) '
				      . 'LEFT JOIN `#__users` AS u'
				      . ' ON ( c.`author_id` = u.`id` ) '
				      ;
				$group = ' GROUP BY c.`id` ';
				$fields = array('c.*', 'COUNT( w.`ip` ) AS warninglevel', 'u.`username`');
				$wheres = array('c.`sid`='.intval($id));
				if ($published >= 0) {
					$wheres[] = 'c.`published` = '.intval($published);
				}
				if ($this->cfg->getInt('show_comment_avatar', 0)) {
					if ($this->cfg->allow->cb) {
						// add extra fields
						$fields[] = 'cb.`avatar` AS avatar';
						// change query to join
						$join.= 'LEFT JOIN `#__comprofiler` AS cb'
							. ' ON ( c.`author_id` = cb.`user_id` ) '
							;
					}
					else if ($this->cfg->allow->jomsocial) {
						// add extra fields
						$fields[] = 'js.`thumb` AS avatar';
						// change query to join
						$join.= 'LEFT JOIN `#__community_users` AS js'
							. ' ON ( c.`author_id` = js.`userid` ) '
							;
					}
				}

				// build query
				$query = 'SELECT '
				       . implode(', ', $fields).' '
				       . 'FROM `#__jmylife_comments` AS c '
				       . $join
				       . 'WHERE ( '.implode(' ) AND ( ', $wheres).' ) '
				       . $group
							 . 'ORDER BY c.`id` '.($latest ? 'DESC' : 'ASC')
				       ;
				break;
		}
		return $query;
	}

	/**
	 * buildQueryById
	 * @param   int
	 * @return  string
	 *
	 * PLEASE NOTE this only works on Core comments for now
	 */
	function buildQueryById($id) {
		$join = 'LEFT JOIN `#__jmylife_comments_warnings` AS w'
		      . ' ON ( c.`id` = w.`cid` ) '
		      . 'LEFT JOIN `#__users` AS u'
		      . ' ON ( c.`author_id` = u.`id` ) '
		;
		$group = ' GROUP BY c.`id`, c.`sid` ';
		$fields = array(
			'c.*',
			'COUNT( w.`ip` ) AS warninglevel',
			'u.`username`'
		);
		$wheres = array( 'c.`id`='.intval( $id ) );
		if( $this->cfg->getInt( 'show_comment_avatar', 0 ) == 1 )
		{
			if( $this->cfg->allow->cb )
			{
				// add extra fields
				$fields[] = 'cb.`avatar` AS avatar';
				// change query to join
				$join .= 'LEFT JOIN `#__comprofiler` AS cb'
					. ' ON ( c.`author_id` = cb.`user_id` ) '
				;
			}
			else if( $this->cfg->allow->jomsocial )
			{
				// add extra fields
				$fields[] = 'js.`thumb` AS avatar';
				// change query to join
				$join .= 'LEFT JOIN `#__community_users` AS js'
					. ' ON ( c.`author_id` = js.`userid` ) '
				;
			}
		}

		// build query
		$query = 'SELECT '
		       . implode( ', ', $fields ).' '
		       . 'FROM `#__jmylife_comments` AS c '
		       . $join
		       . 'WHERE ( '.implode( ' ) AND ( ', $wheres ).' ) '
		       . $group
		       . 'LIMIT 1'
		;
		return $query;
	}

	/**
	 * prepare
	 * @param   object
	 * @param   string
	 * @return  object
	 */
	function prepare($object, $view='') {
		@$object->message = nl2br($this->html->clean(@$object->message));
		@$object->author  = $this->html->clean(@$object->author);
		if ($this->cfg->getInt('comment_username')) {
			@$object->author = $this->html->clean(@$object->username);
		}
		if ($this->cfg->getInt('break_long_words')) {
			@$object->message = $this->_string->breakLongWords(@$object->message);
			@$object->author  = $this->_string->breakLongWords(@$object->author);
		}
		// process final avatar image
		@$object->avatar_image = JmylifeCommon::buildAvatarPath(@$object->avatar);
		// process profile link
		@$object->profile_path = JmylifeCommon::buildProfilePath(@$object->author_id);
		return $object;
	}

	/**
	 * prepareList
	 * @param   array
	 * @param   string
	 * @return  array
	 */
	function prepareList($list, $view='') {
		for ($i=0; $i<count($list); $i++) {
			@$list[$i] = $this->prepare(@$list[$i], $view);
		}
		return $list;
	}

}