<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/helpers/extensions.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.12
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.installer.installer');
jimport('joomla.installer.helper');
if( !class_exists( 'JmylifeConfiguration' ) )
{
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if( JFile::exists( $configfile ) ) require_once( $configfile );
}

$JMLCore = JmylifeConfiguration::getInstance();
// load cb stuff, if available
if( $JMLCore->has->cb )
{
	require_once( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_comprofiler'.DS.'plugin.class.php' );
	require_once( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_comprofiler'.DS.'plugin.foundation.php' );
	require_once( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_comprofiler'.DS.'comprofiler.class.php' );
	cbimport( 'cb.installer' );
}

class JmylifeExtensionsHelper
{
	private static $_jmlinstaller_instance;
	private $_message;
	private $_packages;
	var $packageroot;
	var $cbinstallpath;
	var $jomsocialinstallpath;
	var $joomlacommentinstallpath;
	var $installer;
	var $cbinstaller;
	var $cfg;

	function __construct()
	{
		// static packages, jik
		$this->_packages = array(
			'core' => array(
				'mod_jmylifecategorymenu.zip'         => JText::_('COM_JMYLIFE_EXTENSIONS_MOD_CATEGORYMENU'),
				'mod_jmylifedatepicker.zip'           => JText::_('COM_JMYLIFE_EXTENSIONS_MOD_DATEPICKER'),
				'mod_jmylifesubmit.zip'               => JText::_('COM_JMYLIFE_EXTENSIONS_MOD_SUBMIT'),
				'mod_jmylifelatest.zip'               => JText::_('COM_JMYLIFE_EXTENSIONS_MOD_LATEST'),
				'mod_jmylifelatestcomments.zip'       => JText::_('COM_JMYLIFE_EXTENSIONS_MOD_LATESTCOMMENTS'),
				'mod_jmylifetopauthors.zip'           => JText::_('COM_JMYLIFE_EXTENSIONS_MOD_TOPAUTHORS'),
				'mod_jmylifefeed.zip'                 => JText::_('COM_JMYLIFE_EXTENSIONS_MOD_FEED'),
				'plg_search_jmylifesearch.zip'        => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_SEARCH'),
				'plg_system_jmylifesearchavatars.zip' => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_SEARCHAVATARS'),
				'plg_system_jmylifemenucounts.zip'    => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_MENUCOUNTS')
			),
			'cb' => array(
				'plug_cbjmylifefavorites.zip' => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_CB_FAVORITES'),
				'plug_cbjmylifestories.zip'   => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_CB_STORIES'),
				'plug_cbjmylifetoolbar.zip'   => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_CB_TOOLBAR')
			),
			'jomsocial' => array(
				'plg_community_jmylifestories.zip'   => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_JS_STORIES'),
				'plg_community_jmylifefavorites.zip' => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_JS_FAVORITES'),
				'plg_community_jmylifetoolbar.zip'   => JText::_('COM_JMYLIFE_EXTENSIONS_PLG_JS_TOOLBAR')
			),
			'joomlacomment' => array(''),
			'xmap' => array('')
		);
		// the rest
		$this->installer = new JInstaller();
		$this->installer->setOverwrite(true);
		$this->_message = '';
		$this->cfg = JmylifeConfiguration::getInstance();
		$this->packageroot = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jmylife'.DS.'extensions'.DS;
		$this->cbinstallpath = JPATH_ROOT.DS.'components'.DS.'com_comprofiler'.DS.'plugin'.DS.'user'.DS;
		$this->jomsocialinstallpath = JPATH_ROOT.DS.'plugins'.DS.'community'.DS;
		$this->joomlacommentinstallpath = JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_comment'.DS.'plugin'.DS;
		$this->xmapinstallpath = JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_xmap'.DS.'extensions'.DS;
		$this->cbinstaller = false;
		if (class_exists('cbInstallerPlugin')) {
			$this->cbinstaller = new cbInstallerPlugin();
		}
	}

	function getInstance() {
		if (!self::$_jmlinstaller_instance) {
			self::$_jmlinstaller_instance = new JmylifeExtensionsHelper();
		}
		return self::$_jmlinstaller_instance;
	}

	function packages() {
		return $this->_packages;
	}

	function message() {
		return $this->_message;
	}

	function install($file, $name, $unlink=false) {
		$this->_message = '';
		$packageFile = $this->packageroot . $file;
		if (!JFile::exists($packageFile)) {
			$this->_message = JText::sprintf('COM_JMYLIFE_ERROR_INTEGRATIONS_PACKAGE_NOT_FOUND', $packageFile);
			return false;
		}
		$package = JInstallerHelper::unpack($packageFile);
		$installResult = $this->installer->install($package['dir']);
		$this->recursiveDelete($package['dir']);
		if ($unlink) @unlink($packageFile);
		return $installResult;
	}

	function installJomSocialPlugin($file, $name) {
		return $this->install('jomsocial'.DS.$file, $name);
	}

	function installJoomlaCommentPlugin($path=false) {
		if (!$path) $path = $this->packageroot.DS.'joomlacomment'.DS;
		if (JFolder::exists($this->joomlacommentinstallpath) && $this->cfg->has->joomlacomment) {
			if (JFolder::copy($path, $this->joomlacommentinstallpath, '', true)) {
				// only insert if not already there...
				$this->cfg->db->setQuery( 'SELECT id FROM '.$this->cfg->db->nameQuote( '#__comment_setting' ).' WHERE '.$this->cfg->db->nameQuote( 'set_component' ).' = "com_jmylife"' );
				if (!($this->cfg->db->loadResult())) {
					// params must be set, otherwise !JoomlaComment inserts a second record on first save?
					$this->cfg->db->setQuery( 'INSERT INTO '.$this->cfg->db->nameQuote( '#__comment_setting' ).' ( '.$this->cfg->db->nameQuote( 'set_name' ).', '.$this->cfg->db->nameQuote( 'set_component' ).', '.$this->cfg->db->nameQuote( 'set_sectionid' ).', '.$this->cfg->db->nameQuote( 'params' ).' ) VALUES ( "JMyLife", "com_jmylife", 0, "_complete_uninstall=0" )' );
					$this->cfg->db->query();
				}
				$this->_message = JText::_('COM_JMYLIFE_EXTENSIONS_COMPOJOOMCOMMENT_INSTALLED', true);
				return true;
			}
			$this->_message = JText::_('COM_JMYLIFE_ERROR_INTEGRATIONS_COMPOJOOMCOMMENT_INSTALLERROR');
			return false;
		}
		return false;
	}

	function installXmapPlugin($path=false) {
		if (!$path) {
			$path = $this->packageroot.DS.'xmap'.DS;
		}
		if (JFolder::exists($this->xmapinstallpath) && $this->cfg->has->xmap) {
			if (JFolder::copy($path, $this->xmapinstallpath, '', true)) {
				// only insert if not already there...
				$this->cfg->db->setQuery('SELECT id FROM '.$this->cfg->db->nameQuote('#__xmap_ext').' WHERE '.$this->cfg->db->nameQuote('extension').' = "com_jmylife"');
				if (!($this->cfg->db->loadResult())) {
					$this->cfg->db->Execute('INSERT INTO '.$this->cfg->db->nameQuote('#__xmap_ext').' ( '.$this->cfg->db->nameQuote('extension').', '.$this->cfg->db->nameQuote('published').', '.$this->cfg->db->nameQuote( 'params' ).' ) VALUES ( "com_jmylife", 1, "-1{}" )' );
				}
				$this->_message = JText::_('COM_JMYLIFE_EXTENSIONS_XMAP_INSTALLED');
				return true;
			}
			$this->_message = JText::_('COM_JMYLIFE_ERROR_INTEGRATIONS_XMAP_INSTALLERROR');
			return false;
		}
		return false;
	}

	function installCommunityBuilderPlugin($file, $name) {
		$packageName = basename( $file, ".zip" );
		$packageFile = JPath::clean( realpath( $this->packageroot.DS.'cb'.DS.$file ) );
		$packageDest = JPath::clean( $this->cbinstallpath.$packageName );
		if( !JFile::exists( $packageFile ) )
		{
			$this->_message = JText::sprintf('COM_JMYLIFE_ERROR_INTEGRATIONS_PACKAGE_NOT_FOUND', $packageFile);
			return false;
		}
		// make sure we found the installer class first
		if( !$this->cbinstaller )
		{
			$this->_message = JText::_('COM_JMYLIFE_ERROR_INTEGRATIONS_CBINSTALLER');
			return false;
		}
		// handle extraction
		$tmpdir = uniqid( 'install_' );
		$extractdir = JPath::clean( dirname( $packageFile ).DS.$tmpdir );
		// extract
		$result = JArchive::extract( $packageFile, $extractdir );
		if( $result === false )
		{
			$this->_message = JText::sprintf('COM_JMYLIFE_ERROR_INTEGRATIONS_EXTRACT', $file);
			return false;
		}
		// now that the archive is extracted & ready, try renaming old plugin folder to prevent errors if it exists
		// jml only uses 'user' type plugins so fuck it all finding the type ;)
		$oldinstall = false;
		if( JFolder::exists( $packageDest ) )
		{
			if( true !== JFolder::move( $packageDest, $packageDest.'_old' ) )
			{
				$this->_message = JText::sprintf('COM_JMYLIFE_ERROR_INTEGRATIONS_MOVE', $packageDest);
				$this->cleanPackageRoot('cb');
				return false;
			}
			$oldinstall = true;
		}
		// install file
		$installdir = JPath::clean( $extractdir.DS.$packageName.DS );
		if( !$this->cbinstaller->install( $installdir ) )
		{
			// couldn't install, move old back into place
			if( $oldinstall )
			{
				if( true !== JFolder::move( $packageDest.'_old', $packageDest ) )
				{
					$this->_message = JText::sprintf("COM_JMYLIFE_ERROR_INTEGRATIONS_RECOVERY", $file);
					$this->cleanPackageRoot('cb');
					return false;
				}
			}
			$this->_message = JText::sprintf("COM_JMYLIFE_ERROR_INTEGRATIONS_INSTALL", $file, $this->cbinstaller->error());
			$this->cleanPackageRoot('cb');
			return false;
		}
		// clean up old install
		if( $oldinstall )
		{
			if( !JFolder::delete( $packageDest.'_old' ) )
			{
				$this->_message = JText::sprintf("COM_JMYLIFE_ERROR_INTEGRATIONS_RECOVERYDELETE", $file, $packageDest.'_old');
				$this->cleanPackageRoot('cb');
				return false;
			}
		}
		$this->_message = JText::sprintf('COM_JMYLIFE_INTEGRATIONS_INSTALLED', $name);
		$this->cleanPackageRoot('cb');
		return true;
	}

	function cleanPackageRoot( $subdir='' )
	{
		if (strlen($subdir)) $subdir .= DS;
		// fix for opendir error in 1.6
		if (!JFolder::exists($this->packageroot.$subdir)) {
			return false;
		}
		$dh = opendir( $this->packageroot.$subdir );
		while( ( $file = readdir( $dh ) ) !== false )
		{
			if( preg_match( '`^install`', $file ) )
			{
				$this->recursiveDelete( $this->packageroot.$subdir.$file );
			}
		}
		closedir($dh);
	}
	// http://www.php.net/manual/en/function.unlink.php#94766
	function recursiveDelete( $str )
	{
		if( is_file( $str ) )
		{
			return @unlink( $str );
		}
		elseif( is_dir( $str ) )
		{
			$scan = glob( rtrim( $str, '/' ).'/*' );
			if( $scan )
			{
				foreach( $scan as $index => $path )
				{
					$this->recursiveDelete( $path );
				}
			}
			return @rmdir($str);
		}
	}
}