<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/helpers/version.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.14
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
if (!class_exists('JmylifeConfiguration')) {
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if( JFile::exists( $configfile ) ) require_once( $configfile );
}

class JmylifeVersionHelper
{
	private static $_instance;
	var $cfg;

	function __construct() {
		$this->cfg = JmylifeConfiguration::getInstance();
	}

	function getInstance() {
		if (!self::$_instance) {
			self::$_instance = new JmylifeVersionHelper();
		}
		return self::$_instance;
	}

	/**
	 * getCurrentVersion
	 * @return  bool
	 */
	function getCurrentVersion() {
		// fetch latest version from http://jeffchannell.com/jmylife-version.php
		return JmylifeCommon::getRemoteData('http://jeffchannell.com/jmylife-version.php', array());
	}

	/**
	 * getComparedVersions
	 * @return  int
	 */
	function getComparedVersions() {
		$installed  = $this->cfg->version->getFullVersion();
		$current    = $this->getCurrentVersion();
		return version_compare($installed, $current);
	}

	/**
	 * checkForUpdate
	 * @param   bool
	 * @return  bool
	 */
	function checkForUpdate($force=false) {
		$needs = $this->cfg->getInt('needs_update', 0);
		$last  = $this->cfg->getInt('last_update_check', 0);
		$now   = time();
		// since data is retrieved update db
		$this->cfg->db->setQuery('UPDATE `#__jmylife_configuration` SET `value` = '.$now.' WHERE `key` = "last_update_check"');
		$this->cfg->db->query();
		// if you need an update, don't bother checking again
		// 1.0.11 and future versions will set this to 0 then immediately check again
		if ($needs) {
			return true;
		}
		// check time, only check every 6 hours
		if ($now - $last > 21600 || $force) {
			// update db & return true if update is needed
			if (-1 == $this->getComparedVersions()) {
				$this->cfg->db->setQuery('UPDATE `#__jmylife_configuration` SET `value` = 1 WHERE `key` = "needs_update"');
				$this->cfg->db->query();
				return true;
			}
		}
		// no update needed if this is reached
		return false;
	}

	/**
	 * updateBar
	 * @return  string
	 */
	function updateBar() {
		if ($this->checkForUpdate('about' == JRequest::getCmd('view'))) {
			return '<div style="border-top:3px solid #f00;border-bottom:3px solid #f00;background:#f99;height:32px;line-height:32px;font-weight:bold;padding-left:50px;font-size:16px;">'.JText::_('COM_JMYLIFE_UPDATEBAR').'</div>';
		}
		return '';
	}

}