<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/install/tables.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined('_JEXEC') or die('Restricted access');
class JmylifeInstallerDefaultTables
{
	function get() {
		return array(
<<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_stories` (
	`id` int(11) NOT NULL auto_increment,
	`catid` int(11) NOT NULL,
	`time` int(255) NOT NULL,
	`fulltext` mediumtext NOT NULL,
	`published` tinyint(1) NOT NULL DEFAULT 0,
	`votes1` int(12) DEFAULT 0,
	`votes2` int(12) DEFAULT 0,
	`reported` INT(1) NOT NULL DEFAULT 0,
	`moderate1` INT(12) NOT NULL DEFAULT 0,
	`moderate2` INT(12) NOT NULL DEFAULT 0,
	`via` varchar(255) NOT NULL DEFAULT "",
	`user_id` int(11) NOT NULL,
	`user_alias` varchar(255) NOT NULL,
	`user_email` VARCHAR(255) NOT NULL DEFAULT "",
	`allow_votes` TINYINT(1) NOT NULL DEFAULT 1,
	`allow_comments` TINYINT(1) NOT NULL DEFAULT 1,
	`admin_fulltext` mediumtext NOT NULL DEFAULT "",
	`title` VARCHAR(255) NOT NULL DEFAULT "",
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0;
EOF
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_categories` (
	`id` int(11) NOT NULL auto_increment,
	`name` varchar(255) NOT NULL DEFAULT "",
	`published` tinyint(1) NOT NULL DEFAULT 0,
	`ordering` INT(11) NOT NULL DEFAULT 0,
	`color` VARCHAR(100) NOT NULL DEFAULT "",
	`background` VARCHAR(100) NOT NULL DEFAULT "",
	`allow_votes` TINYINT(1) NOT NULL DEFAULT 1,
	`allow_comments` TINYINT(1) NOT NULL DEFAULT 1,
	`description` MEDIUMTEXT NOT NULL DEFAULT "",
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0;
EOF
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_comments` (
	`id` int(11) NOT NULL auto_increment,
	`sid` int(11) NOT NULL,
	`author_id` int(11) NOT NULL,
	`author` varchar(255) NOT NULL,
	`time` int(255) NOT NULL,
	`message` mediumtext NOT NULL DEFAULT "",
	`published` tinyint(1) DEFAULT 0,
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0;
EOF
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_comments_warnings` (
	`ip` varchar(255) NOT NULL,
	`uid` int(11) NOT NULL,
	`cid` int(11) NOT NULL
) ENGINE=MyISAM;
EOF
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_configuration` (
	`key` varchar(100) NOT NULL,
	`value` varchar(255) NOT NULL,
	`group` varchar(50) NOT NULL DEFAULT "",
	`subgroup` varchar(50) NOT NULL DEFAULT "",
	`ordering` int(11) NOT NULL DEFAULT 0,
	`type` varchar(12) NOT NULL,
	`label` varchar(100) NOT NULL,
	`description` mediumtext NOT NULL,
	PRIMARY KEY  (`key`)
) ENGINE=MyISAM;
EOF
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_favorites` (
	`id` int(11) NOT NULL auto_increment,
	`uid` int(11) NOT NULL,
	`sid` int(11) NOT NULL,
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0;
EOF
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_language` (
	`key` varchar(100) NOT NULL,
	`value` mediumtext NOT NULL DEFAULT "",
	PRIMARY KEY  (`key`)
) ENGINE=MyISAM;
EOF
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_moderate` (
	`id` int(11) NOT NULL auto_increment,
	`ip` varchar(255) NOT NULL,
	`uid` int(11) NOT NULL,
	`sid` int(11) NOT NULL,
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0;
EOF
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_votes` (
	`id` int(11) NOT NULL auto_increment,
	`ip` varchar(255) NOT NULL,
	`uid` int(11) NOT NULL,
	`sid` int(11) NOT NULL,
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_stories` DEFAULT CHARACTER SET utf8;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_categories` DEFAULT CHARACTER SET utf8;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_comments` DEFAULT CHARACTER SET utf8;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_configuration` DEFAULT CHARACTER SET utf8;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_language` DEFAULT CHARACTER SET utf8;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_stories` CONVERT TO CHARACTER SET utf8;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_categories` CONVERT TO CHARACTER SET utf8;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_comments` CONVERT TO CHARACTER SET utf8;
EOF
, <<<EOF
ALTER TABLE `#__jmylife_configuration` CONVERT TO CHARACTER SET utf8;
EOF
// this was added in 1.0.9 to control who is subscribed to what stories
// take note a 0 value for uid will denote guest author
// and therefore any checks to this table should take that into account
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_stories_subscriptions` (
	`id` int(11) NOT NULL auto_increment,
	`sid` int(11) NOT NULL,
	`uid` int(11) NOT NULL,
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0;
EOF
// this table was added in 1.0.13 to add attachments to stories
// id is used as primary key and sid is not set unique to allow
// future releases to possibly support multiples for galleries
// "extra" can mean different things for different attachments
// for now it's only used for link attachments and is used to denote
// when the "no thumbnail" checkbox is selected so no thumbnails are
// shown during administrator editing sessions (so if extra=1 then
// no thumbnails are shown during initial load).
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_stories_attachments` (
	`id` int(11) NOT NULL auto_increment,
	`sid` int(11) NOT NULL,
	`type` VARCHAR( 10 ) NOT NULL DEFAULT "",
	`url` varchar(255) NOT NULL DEFAULT "",
	`title` varchar(255) NOT NULL DEFAULT "",
	`description` mediumtext NOT NULL DEFAULT "",
	`extra` tinyint(1) NOT NULL DEFAULT 0,
	`uuid` VARCHAR(32) NOT NULL DEFAULT "",
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARACTER SET utf8;
EOF
// versions table added in 1.0.14
// future versions may need to alter the data in this table, as the
// initial implementation saves full copies of each story
// it would be nice to only save generated diffs in the future
// this should be in place & working before committing any code to
// user edit features, as well as a more robust ACL
, <<<EOF
CREATE TABLE IF NOT EXISTS `#__jmylife_stories_versions` (
	`id` int(11) NOT NULL auto_increment,
	`sid` int(11) NOT NULL,
	`catid` int(11) NOT NULL,
	`fulltext` mediumtext NOT NULL,
	`user_id` int(11) NOT NULL,
	`user_alias` varchar(255) NOT NULL,
	`user_email` VARCHAR(255) NOT NULL DEFAULT "",
	`title` VARCHAR(255) NOT NULL DEFAULT "",
	`changed` DATETIME NOT NULL,
	`edited_by` int(11) NOT NULL,
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARACTER SET utf8;
EOF
		);
	}
}