<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/models/integrations.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.12
 */
// No direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
JLoader::import('components.com_jmylife.helpers.extensions', JPATH_ADMINISTRATOR, '');

// TODO: more robust checks (hit up the db?)

/**
 * Integrations Model
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeModelIntegrations extends JModel
{
	var $installer = null;

	/**
	 * contructor
	 */
	function __construct()
	{
		$this->installer = JmylifeExtensionsHelper::getInstance();
		parent::__construct();
	}

	/**
	 * returns 0 if cb not installed
	 * returns 1 if no plugins are installed
	 * returns 2 if only a few are installed
	 * returns 3 if all are installed
	 */
	function getCommunityBuilder()
	{
		if( !JFolder::exists( $this->installer->cbinstallpath ) ) return 0;
		// check for plugins
		$count = 0;
		$plugs = array( 'plug_cbjmylifefavorites', 'plug_cbjmylifestories' );
		foreach( $plugs as $plug )
		{
			if( JFolder::exists( $this->installer->cbinstallpath.$plug ) ) $count++;
		}
		return ( ( 0 == $count ) ? 1 : ( ( count( $plugs ) == $count ) ? 3 : 2 ) );
	}

	/**
	 * returns 0 if JomSocial not installed
	 * returns 1 if no plugins are installed
	 * returns 2 if only a few are installed
	 * returns 3 if all are installed
	 */
	function getJomSocial()
	{
		if( !JFolder::exists( $this->installer->jomsocialinstallpath ) ) return 0;
		// check for plugins
		$count = 0;
		$plugs = array( 'jmylifefavorites.php' );
		foreach( $plugs as $plug )
		{
			if( JFile::exists( $this->installer->jomsocialinstallpath.$plug ) ) $count++;
		}
		return ( ( 0 == $count ) ? 1 : ( ( count( $plugs ) == $count ) ? 3 : 2 ) );
	}

	/**
	 * returns 0 if JoomlaComment not installed
	 * returns 1 if plugin is not installed
	 *
	 * returns 3 if plugin is installed
	 */
	function getJoomlaComment()
	{
		if( !JFolder::exists( $this->installer->joomlacommentinstallpath ) ) return 0;
		// check for plugins
		$installed = JFolder::exists( $this->installer->joomlacommentinstallpath.'com_jmylife' );
		return $installed ? 3 : 1;
	}

	/**
	 * returns 0 if Xmap not installed
	 * returns 1 if plugin is not installed
	 *
	 * returns 3 if plugin is installed
	 */
	function getXmap()
	{
		if (!JFolder::exists($this->installer->xmapinstallpath)) return 0;
		// check for plugins
		$installed = (JFile::exists($this->installer->xmapinstallpath.'com_jmylife.php') && JFile::exists($this->installer->xmapinstallpath.'com_jmylife.xml'));
		return $installed ? 3 : 1;
	}
}