<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/views/categories/view.html.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.view' );
// color picker
if( !class_exists( 'JElementColor' ) )
{
	include_once( JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jmylife'.DS.'elements'.DS.'color.php' );
}

/**
 * HTML View Categories class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewCategories extends JView
{
	function display( $tpl = null )
	{
		$option = JRequest::getCmd('option', 'com_jmylife');
		$view = JRequest::getWord('view', 'categories');
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		switch( JRequest::getWord( 'task' ) )
		{
			case 'add':
			case 'edit':
				$item =& $this->get( 'Item' );
				// since 1.0.2 - check length of $item
				if( count( $item ) > 0 )
				{
					$item = $item[0];
					// TODO: check if we need to preprocess here...
				}
				else
				{
					// dummy item for new
					$item = new stdClass();
					$item->published      = 0;
					$item->name           = '';
					$item->id             = 0;
					$item->allow_comments = 0;
					$item->allow_votes    = 0;
				}
				// build published radio
				$pubopts = array(
					JHTML::_('select.option', '1', JText::_('COM_JMYLIFE_CONFIGURATION_OPTION_YES') ),
					JHTML::_('select.option', '0', JText::_('COM_JMYLIFE_CONFIGURATION_OPTION_NO') )
				);
				$publist = JHTML::_( 'select.radiolist', $pubopts, 'published', '', 'value', 'text', $item->published, 'published' );
				// since 1.0.5 comments optional
				$comopts = array(
					JHTML::_('select.option', '1', JText::_('COM_JMYLIFE_CONFIGURATION_OPTION_YES') ),
					JHTML::_('select.option', '0', JText::_('COM_JMYLIFE_CONFIGURATION_OPTION_NO') )
				);
				$comlist = JHTML::_( 'select.radiolist', $comopts, 'allow_comments', '', 'value', 'text', $item->allow_comments, 'allow_comments' );
				// since 1.0.5 voting optional
				$voteopts = array(
					JHTML::_('select.option', '1', JText::_('COM_JMYLIFE_CONFIGURATION_OPTION_YES') ),
					JHTML::_('select.option', '0', JText::_('COM_JMYLIFE_CONFIGURATION_OPTION_NO') )
				);
				$votelist = JHTML::_( 'select.radiolist', $voteopts, 'allow_votes', '', 'value', 'text', $item->allow_votes, 'allow_votes' );
				// assign refs
				$this->assignRef( 'item', $item );
				$this->assignRef( 'published', $publist );
				// since 1.0.5
				$this->assignRef( 'allow_comments', $comlist );
				$this->assignRef( 'allow_votes', $votelist );
				break;
			default:
				$items =& $this->get( 'Data' );
				// since 1.0.5 preprocess data before sending to template
				if( count( $items ) )
				{
					foreach( $items as $key => $item )
					{
						$items[$key]->name = htmlentities( $item->name, ENT_QUOTES, 'UTF-8' );
						// since 1.0.5
						if( (int)( $items[$key]->allow_comments ) == 1 )
						{
							$items[$key]->comment_toggle = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'.$key.'\',\'unallowcomments\')" title="'.JText::_('COM_JMYLIFE_CATEGORY_DISABLE_COMMENTS').'"><img src="images/tick.png" alt="'.JText::_('COM_JMYLIFE_CATEGORY_COMMENTS_ALLOWED').'" border="0"></a>';
						}
						else
						{
							$items[$key]->comment_toggle = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'.$key.'\',\'allowcomments\')" title="'.JText::_('COM_JMYLIFE_CATEGORY_ENABLE_COMMENTS').'"><img src="images/publish_x.png" alt="'.JText::_('COM_JMYLIFE_CATEGORY_COMMENTS_NOT_ALLOWED').'" border="0"></a>';
						}
						// since 1.0.5
						if( (int)( $items[$key]->allow_votes ) == 1 )
						{
							$items[$key]->votes_toggle = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'.$key.'\',\'unallowvotes\')" title="'.JText::_('COM_JMYLIFE_CATEGORY_DISABLE_VOTING').'"><img src="images/tick.png" alt="'.JText::_('COM_JMYLIFE_CATEGORY_VOTING_ALLOWED').'" border="0"></a>';
						}
						else
						{
							$items[$key]->votes_toggle = '<a href="javascript:void(0);" onclick="return listItemTask(\'cb'.$key.'\',\'allowvotes\')" title="'.JText::_('COM_JMYLIFE_CATEGORY_ENABLE_VOTING').'"><img src="images/publish_x.png" alt="'.JText::_('COM_JMYLIFE_CATEGORY_VOTING_NOT_ALLOWED').'" border="0"></a>';
						}
					}
				}
				// Table ordering.
				$lists['order']     = $appl->getUserStateFromRequest( $option.$view.'filter_order', 'filter_order', '`ordering`', 'cmd' );
				$lists['order_Dir'] = $appl->getUserStateFromRequest( $option.$view.'filter_order_Dir', 'filter_order_Dir', 'desc', 'word' );
				if( preg_match( '`^[cb?|s]\.`', $lists['order'] ) )
				{
					$lists['order'] = '`ordering`';
				}
				// pages
				$pagination =& $this->get( 'Pagination' );
				$this->assignRef( 'items', $items );
				$this->assignRef( 'lists', $lists );
				$this->assignRef( 'pagination', $pagination );
				break;
		}
		parent::display( $tpl );
	}
}

class JmylifeViewCategoriesDummy
{
	function get( $a )
	{
		return '';
	}
}