<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/views/comments/view.html.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.view' );
JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');

/**
 * HTML View Comments class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewComments extends JView
{
	function display( $tpl = null )
	{
		global $context;
		$option = JRequest::getCmd('option', 'com_jmylife');
		$view = JRequest::getCmd('view', 'comments');
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if (0 < $_JMLConfig->getInt('comment_engine')) {
			switch ($_JMLConfig->getInt('comment_engine')) {
				case 1: // JComments
					$enginename = JText::_('COM_JMYLIFE_CONFIGURATION_COMMENTOPTION_JCOMMENTS');
					break;
				case 2: // CompojoomComment
					$enginename = JText::_('COM_JMYLIFE_CONFIGURATION_COMMENTOPTION_COMPOJOOMCOMMENT');
					break;
				case 3: // Disqus
					$enginename = JText::_('COM_JMYLIFE_CONFIGURATION_COMMENTOPTION_DISQUS');
					break;
				case 4: // JomComment
					$enginename = JText::_('COM_JMYLIFE_CONFIGURATION_COMMENTOPTION_JOMCOMMENT');
					break;
			}
			if (isset($enginename)) {
				$this->assignRef('enginename', $enginename);
				parent::display('thirdparty');
				return;
			}
		}
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$html = JmylifeHtmlHelper::getInstance();
		switch( JRequest::getWord( 'task' ) )
		{
			case 'add':
			case 'edit':
				// get data from model
				$search =& $this->get( 'Search' );
				$item =& $this->get( 'Item' );
				$item = $item[0];
				// build published radio
				$pubopts = array(
					JHTML::_('select.option', '1', JText::_('COM_JMYLIFE_CONFIGURATION_OPTION_YES') ),
					JHTML::_('select.option', '0', JText::_('COM_JMYLIFE_CONFIGURATION_OPTION_NO') )
				);
				$publist = JHTML::_( 'select.radiolist', $pubopts, 'published', '', 'value', 'text', (int)$item->published, 'published' );
				// assign refs
				$this->assignRef( 'item', $item );
				$this->assignRef( 'published', $publist );
				break;
			default:
				$items =& $this->get( 'Data' );
				// since 1.0.5 preprocess data before sending to template
				if( count( $items ) )
				{
					JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
					$string = JmylifeStringHelper::getInstance();
					foreach( $items as $key => $item )
					{
						$items[$key]->message = $string->shorten($html->clean($item->message), 100);
						$items[$key]->author  = $html->clean($item->author);
					}
				}
				// Table ordering.
				$lists['order']     = $appl->getUserStateFromRequest( $option.$view.'filter_order', 'filter_order', 'c.`time`', 'cmd' );
				$lists['order_Dir'] = $appl->getUserStateFromRequest( $option.$view.'filter_order_Dir', 'filter_order_Dir', 'desc', 'word' );
				// pages
				$pagination =& $this->get( 'Pagination' );
				$this->assignRef( 'search', $search );
				$this->assignRef( 'items', $items );
				$this->assignRef( 'lists', $lists );
				$this->assignRef( 'pagination', $pagination );
				break;
		}
		$this->assignRef('html', $html);
		$this->assignRef('cparams', $_JMLConfig);
		parent::display( $tpl );
	}
}