<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/views/configuration/view.html.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.view' );
jimport( 'joomla.html.pane' );
jimport('joomla.html.parameter.element');
// this is for menu select
if (!class_exists('JElementMenuItem')) {
	include_once (JPATH_ROOT.DS.'libraries'.DS.'joomla'.DS.'html'.DS.'parameter'.DS.'element'.DS.'menuitem.php');
}
// permissions
if (!class_exists('JElementUserGroup')) {
	include_once (JPATH_ROOT.DS.'libraries'.DS.'joomla'.DS.'html'.DS.'parameter'.DS.'element'.DS.'usergroup.php');
}
// color picker
if (!class_exists('JElementColor')) {
	include_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jmylife'.DS.'elements'.DS.'color.php');
}
/**
 * HTML View Configuration class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewConfiguration extends JView
{
	function display( $tpl = null )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$document =& JFactory::getDocument();
		// since 1.0.9
		JHTML::_('behavior.keepalive');
		// push config to template
		$config =& $this->get( 'Config' );
		$this->assignRef( 'config', $config );
		// since 1.0.5
		$groups =& $this->get( 'Groups' );
		$this->assignRef( 'groups', $groups );
		$comment_engines =& $this->get( 'CommentEngines' );
		$this->assignRef( 'comment_engine', $comment_engines );
		// since 1.0.6
		$pane =& JPane::getInstance( 'tabs', array( 'useCookies' => true ) );
		$pane->useCookies = true;
		$this->assignRef( 'pane', $pane );
		// since 1.0.11
		$slider =& JPane::getInstance( 'sliders', array( 'useCookies' => false, 'allowAllClose' => true ) );
		$slider->useCookies = false;
		$slider->allowAllClose = true;
		$this->assignRef( 'slider', $slider );

		$editor =& JFactory::getEditor();
		$this->assignRef( 'editor', $editor );

		$captcha_engine =& $this->get( 'CaptchaEngines' );
		$this->assignRef( 'captcha_engine', $captcha_engine );
		$recaptcha_theme =& $this->get( 'RecaptchaThemes' );
		$this->assignRef( 'recaptcha_theme', $recaptcha_theme );

		$css_file_contents =& $this->get( 'CustomCss' );
		// load custom css, for new preview ;)
		$document->addStyleDeclaration( $css_file_contents );

		$itembg = $_JMLConfig->get( 'story_background', 'efefef' );
		if( strlen( $itembg ) == 0 ) $itembg = 'efefef';
		$document->addStyleDeclaration( ".comJMyLifeItem,.comJMyLifeComment{background:#{$itembg};}#jmlConfigTabContents label{clear:none !important;display:inline !important;float:none !important;}" );

		$this->assignRef( 'css_file_contents', $css_file_contents );
		$css_themes =& $this->get( 'CustomCssFiles' );
		$this->assignRef( 'css_themes', $css_themes );

		//storylink_header_logo
		$storylink_header_logo =& $this->get( 'StoryLinkImages' );
		$this->assignRef( 'storylink_header_logo', $storylink_header_logo );

		$graphical_voting_size = $this->get( 'GraphicalVotingSize' );
		$this->assignRef( 'graphical_voting_size', $graphical_voting_size );

		$social_engine = $this->get( 'SocialEngineFields' );
		$this->assignRef( 'social_engine', $social_engine );

		$cbextra = $this->get( 'CommunityBuilderFields' );
		$this->assignRef( 'cbextra', $cbextra );

		$sharethislayout = $this->get('ShareThisLayoutTypes');
		$this->assignRef( 'sharethislayout', $sharethislayout );

		$this->assignRef( 'params', $_JMLConfig );

		parent::display( $tpl );
	}
}

class JmylifeViewConfigurationDummy
{
	function get( $a )
	{
		return '';
	}
}