<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/integrations/view.html.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.12
 */
// No direct access
defined('_JEXEC') or die('Restricted access');
// imports
jimport( 'joomla.application.component.view' );
JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');

/**
 * HTML View Integrations class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewIntegrations extends JView
{
	function display( $tpl = null )
	{
		$url = JmylifeUrlHelper::getInstance();
		$cb = $this->get( 'CommunityBuilder' );
		$jomsocial = $this->get( 'JomSocial' );
		$joomlacomment = $this->get( 'JoomlaComment' );
		$xmap = $this->get('Xmap');
		// colors
		$colors = array( '#E0E0FF', '#FFD0D0', '#FFFF90', '#E0FFE0' );
		$this->assignRef( 'colors', $colors );
		// icons
		$warning = str_replace( 'administrator/', '', $url->clean( JURI::base().'/includes/js/ThemeOffice/warning.png' ) );
		$error = $url->clean( JURI::base().'/images/publish_x.png' );
		$ok = $url->clean( JURI::base().'/images/tick.png' );
		$icons = array( $warning, $error, $warning, $ok );
		$this->assignRef( 'icons', $icons );
		// texts
		$texts = array( JText::_('COM_JMYLIFE_INTEGRATIONS_NOCOMPONENT'),
			JText::_('COM_JMYLIFE_INTEGRATIONS_NOPLUGIN'),
			JText::_('COM_JMYLIFE_INTEGRATIONS_SOMEPLUGIN'),
			JText::_('COM_JMYLIFE_INTEGRATIONS_ALLPLUGIN')
		);
		$this->assignRef( 'texts', $texts );
		// installs
		$availableInstalls = array(
			array(
				'title'  => JText::_('COM_JMYLIFE_INTEGRATIONS_TITLE_JOMSOCIAL'),
				'value'  => $jomsocial,
				'url'    => JRoute::_('index.php?option=com_jmylife&view=integrations&controller=integrations&task=jomsocial', false),
				'button' => JText::_('COM_JMYLIFE_INTEGRATIONS_INSTALL_JOMSOCIAL')
			),
			array(
				'title'  => JText::_('COM_JMYLIFE_INTEGRATIONS_TITLE_CB'),
				'value'  => $cb,
				'url'    => JRoute::_('index.php?option=com_jmylife&view=integrations&controller=integrations&task=cb', false),
				'button' => JText::_('COM_JMYLIFE_INTEGRATIONS_INSTALL_CB')
			),
			array(
				'title'  => JText::_('COM_JMYLIFE_INTEGRATIONS_TITLE_COMPOJOOMCOMMENT'),
				'value'  => $joomlacomment,
				'url'    => JRoute::_('index.php?option=com_jmylife&view=integrations&controller=integrations&task=joomlacomment', false),
				'button' => JText::_('COM_JMYLIFE_INTEGRATIONS_INSTALL_COMPOJOOMCOMMENT')
			),
			array(
				'title'  => JText::_('COM_JMYLIFE_INTEGRATIONS_TITLE_XMAP'),
				'value'  => $xmap,
				'url'    => JRoute::_('index.php?option=com_jmylife&view=integrations&controller=integrations&task=xmap', false ),
				'button' => JText::_('COM_JMYLIFE_INTEGRATIONS_INSTALL_XMAP')
			)
		);
		$this->assignRef( 'available', $availableInstalls );
		parent::display( $tpl );
	}
}