<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/jmylife.install.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined('_JEXEC') or die('Restricted access');
define('JML_INSTALLER_VERSION', '1.0.16');
// imports
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.html.pane');
jimport('joomla.installer.helper');
jimport('joomla.utilities.simplexml');
// ignore notices
@error_reporting(E_ALL ^ E_NOTICE);
@ini_set('error_reporting', E_ALL ^ E_NOTICE);
// This opening section borrowed from CB, code cleaned up to match:
// Try extending time, as unziping/ftping took already quite some... :
@set_time_limit(240);
$memMax = trim(@ini_get('memory_limit'));
if ($memMax) {
	$last = strtolower($memMax{strlen($memMax) - 1});
	switch ($last) {
		case 'g':
			$memMax	*=	1024;
		case 'm':
			$memMax	*=	1024;
		case 'k':
			$memMax	*=	1024;
	}
	if ($memMax < 16000000) {
		@ini_set('memory_limit', '16M');
	}
	if ($memMax < 32000000) {
		@ini_set('memory_limit', '32M');
	}
	if ($memMax < 48000000) {
		@ini_set('memory_limit', '48M');
	}
}
ignore_user_abort(true);
// end borrowed cb
// since we need language before necessary classes are loaded
$language =& JFactory::getLanguage();
$language->load('com_jmylife', JPATH_ROOT);
$language->load('com_jmylife', JPATH_ADMINISTRATOR);
// for determining where the hell we are...
global $joomParent; $joomParent = $this->parent;

// begin install class
class com_jmylifeInstallerScript {
	private $_cfg;
	private $_config;
	private $_db;
	private $_installErrors;
	private $_err;
	private $_installer;
	private $_isUpgrade;
	private $_packages;
	private $_slider;
	private $_syserr;
	private $_tables;

	function __construct() {
		$this->_installErrors = array();
		$this->_err = '<ins class="jmlError">%s</ins>';
		$this->_isUpgrade = false;
		$this->_slider = JPane::getInstance('sliders', array('useCookies' => false, 'allowAllClose' => true));
		$this->_syserr = '<h2 style="color:red;">%s</h2>';
	}
	// called during install
	function postflight($type, $item) {
		if ('install' == $type) {
			$this->_install();
		}
	}
	// main install routine - very long :(
	private function _install() {
		global $joomParent;
		// system checks
		$this->_checkRemote();
		$this->_loadClass('JmylifeDatabaseHelper', 'admin'.DS.'helpers'.DS.'database.php', 'COM_JMYLIFE_ERROR_INSTALLATION_NODBHELPER');
		$this->_loadClass('JmylifeConfiguration', 'site'.DS.'libraries'.DS.'configuration.php', 'COM_JMYLIFE_ERROR_INSTALLATION_NOCONFIG');
		$this->_loadClass('JmylifeExtensionsHelper', 'admin'.DS.'helpers'.DS.'extensions.php', 'COM_JMYLIFE_ERROR_INSTALLATION_NOINSTALLER');
		$this->_loadClass('JmylifeInstallerDefaultTables', 'admin'.DS.'install'.DS.'tables.php', 'COM_JMYLIFE_ERROR_INSTALLATION_NOTABLES');
		$this->_loadClass('JmylifeInstallerDefaultConfiguration', 'admin'.DS.'install'.DS.'config.php', 'COM_JMYLIFE_ERROR_INSTALLATION_NODEFAULTCONFIG');
		$this->_loadClass('JmylifeInstallerDefaultPackages', 'admin'.DS.'install'.DS.'packages.php', 'COM_JMYLIFE_ERROR_INSTALLATION_NODEFAULTPACKAGES');
		// grab changelog
		$changelog = $joomParent->getPath('source').DS.'admin'.DS.'CHANGELOG.php';
		if (JFile::exists($changelog) && !defined('COM_JMYLIFE_CHANGELOG')) {
			require_once ($changelog);
		}
		if (!defined('COM_JMYLIFE_CHANGELOG')) {
			echo sprintf($this->_syserr, JText::_('COM_JMYLIFE_ERROR_INSTALLATION_NOCHANGELOG'));
		}
		// set for use later
		$this->_cfg = JmylifeConfiguration::getInstance();
		$this->_config = JmylifeInstallerDefaultConfiguration::get();
		$this->_db = JmylifeDatabaseHelper::getInstance();
		$this->_installer = JmylifeExtensionsHelper::getInstance();
		$this->_packages = JmylifeInstallerDefaultPackages::get();
		$this->_tables = JmylifeInstallerDefaultTables::get();
		// determine if this is an upgrade install
		$this->_db->setQuery('SHOW TABLES LIKE "%_jmylife_stories"');
		$this->_isUpgrade = (bool)($result = $this->_db->loadResult());
		// start output
?>
<table border="0" width="100%" cellpadding="0" cellspacing="5">
	<thead>
		<tr>
			<th colspan="2">
				<table border="0" width="100%" cellpadding="0" cellspacing="5">
					<tr>
						<td>
							<a href="<?php echo JRoute::_('index.php?option=com_jmylife'); ?>"><img src="http://i.jeffchannell.com/JMyLife.png?reason=install&version=pro" alt="JML" /></a>
						</td>
						<td><?php echo JText::sprintf('COM_JMYLIFE_INSTALLATION_INSTALLING', JML_INSTALLER_VERSION); ?></td>
						<td>
							<div class="jmlInstallerMenu">
								<p><?php echo JText::_('COM_JMYLIFE_INSTALLATION_GETSTARTED'); ?></p>
								<ul>
									<?php
										$items = array('control_panel' => 'cpanel', 'configuration', 'categories', 'stories' => 'moderate');
										$links = array();
										foreach ($items as $key => $val) {
											if (is_numeric($key)) {
												$key = $val;
											}
											$key = strtoupper($key);
											$key = JText::_("COM_JMYLIFE_MENU_{$key}");
											$val = "index.php?option=com_jmylife&view={$val}";
											$val = JRoute::_($val, true);
											$links[] = "<li><a href=\"{$val}\">{$key}</a></li>";
										}
										echo implode('', $links);
									?>
								</ul>
							</div>
						</td>
					</tr>
				</table>
			</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td valign="top" width="50%">
				<div id="jmlInstallDetails">
<?php
		// start install panes
		echo $this->_slider->startPane("install-pane");
		// database schema panel
		echo $this->_slider->startPanel(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGDATABASE'), "install-panel-schema");
		// handle core tables
		$this->_installErrors = array();
		foreach ($this->_tables as $table) {
			$this->_db->setQuery($table);
			if (!($this->_db->query())) {
				$this->_installErrors[] = JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_SQL', $table, $this->_db->getErrorMsg());
			}
		}
		if ($this->_isUpgrade) {
			$this->_upgradeTables();
		}
		if ($this->_cfg->has->j15()) {
			$query = 'SELECT %s FROM %s WHERE %s';
			$field = $this->_db->nameQuote('id');
			$table = $this->_db->nameQuote('#__components');
			$where = $this->_db->nameQuote('link').' = "option=com_jmylife"';
			$this->_db->setQuery(sprintf($query, $field, $table, $where));
			$newid = $this->_db->loadResult();
			$this->_db->exec('UPDATE '.$this->_db->nameQuote('#__menu').' SET '.$this->_db->nameQuote('componentid').' = '.$newid.' WHERE '.$this->_db->nameQuote('link').' LIKE "index.php?option=com_jmylife%" AND '.$this->_db->nameQuote('type').' = "component"');
		}
		if (count($this->_installErrors)) {
			foreach ($this->_installErrors as $err) {
				$this->_msg(sprintf($this->_err, $err), '#FFD0D0', 'publish_x.png');
			}
		} else {
			$this->_msg(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGDATABASESUCCESS'));
		}
		$this->_installErrors = array();
		echo $this->_slider->endPanel();

		// configuration panel
		echo $this->_slider->startPanel(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCONFIGURATION'), "install-panel-configuration");
		// it would be nice to be able to use the class method for this instead
		// of duplicating code, but the menu counts plugin prevents this if enabled.
		$isLang = array(
			'jmylife_desc',
			'story_pretext',
			'story_posttext',
			'default_admin_response',
			'submission_pretext',
			'submission_posttext',
			'badwords_filter',
			'moderation_howto',
			'emailtext_submissionapproved_subject',
			'emailtext_submissionapproved_body',
			'emailtext_submissionpending_subject',
			'emailtext_submissionpending_body',
			'emailtext_commentsubscriber_subject',
			'emailtext_commentsubscriber_body'
		);
		foreach ($this->_config as $cfg) {
			list ($key, $val, $group, $subgroup, $order, $type, $label, $desc) = $cfg;
			if ($this->_isUpgrade) {
				if ('social_engine' == $key) {
					$query = 'SELECT '.$this->_db->nameQuote('key').' FROM '.$this->_db->nameQuote('#__jmylife_configuration').' WHERE '.$this->_db->nameQuote('key').' = "cbsupport"';
					$this->_db->setQuery($query);
					if ($result = $this->_db->loadResult()) {
						// found old value, change default & erase old
						$val = $result;
						$query = 'DELETE FROM '.$this->_db->nameQuote('#__jmylife_configuration').' WHERE '.$this->_db->nameQuote('key').' = "cbsupport"';
						$this->_db->exec($query);
					}
				}
			}
			// since 1.0.11 - move language keys to language db if not already present
			// this is done pre-key insert for upgrading pre-1.0.11 installs by porting
			// current configuration value to the new table
			if (in_array($key, $isLang)) {
				$query = 'SELECT '.$this->_db->nameQuote('key').' FROM '.$this->_db->nameQuote('#__jmylife_language').' WHERE '.$this->_db->nameQuote('key').' = '.$this->_db->Quote($key);
				$this->_db->setQuery($query);
				if (!($result = $this->_db->loadResult())) {
					// check if there's a value in the main configuration table, and insert
					// otherwise insert default value
					$langvalue = $val;
					$query = 'SELECT '.$this->_db->nameQuote('value').' FROM '.$this->_db->nameQuote('#__jmylife_configuration').' WHERE '.$this->_db->nameQuote('key').' = '.$this->_db->Quote($key);
					$this->_db->setQuery($query);
					if ($result = $this->_db->loadResult()) {
						$langvalue = $result;
					}
					$query = 'INSERT INTO '.$this->_db->nameQuote('#__jmylife_language').' ( '.$this->_db->nameQuote('key').', '.$this->_db->nameQuote('value').' ) VALUES ( '.$this->_db->Quote($key).', '.$this->_db->Quote($langvalue).' )';
					$this->_db->setQuery($query);
					if (!($this->_db->query())) {
						$this->_installErrors[] = JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_LANGUAGEKEY', $key, $query);
					}
				}
			}
			// check if value is set
			$query = 'SELECT '.$this->_db->nameQuote('key').' FROM '.$this->_db->nameQuote('#__jmylife_configuration').' WHERE '.$this->_db->nameQuote('key').' = '.$this->_db->Quote($key);
			$this->_db->setQuery($query);
			if (!($result = $this->_db->loadResult())) {
				$query = 'INSERT INTO '.$this->_db->nameQuote('#__jmylife_configuration').' ('.
					$this->_db->nameQuote('key').', '.
					$this->_db->nameQuote('value').', '.
					$this->_db->nameQuote('group').', '.
					$this->_db->nameQuote('subgroup').', '.
					$this->_db->nameQuote('ordering').', '.
					$this->_db->nameQuote('type').', '.
					$this->_db->nameQuote('label').', '.
					$this->_db->nameQuote('description').
					') VALUES ("'.implode('", "', $cfg).'")'
				;
				$this->_db->setQuery($query);
				if (!($this->_db->query())) {
					$this->_installErrors[] = JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_CONFIGURATIONKEY', $key, $query);
				}
			}
			// since 1.0.4 - update key's group & ordering
			// I was going to make this smarter, but I'm just going to blast these in for now...
			// since 1.0.5 - works well enough, allows for re-ordering for each release ;)
			// since 1.0.8 - added "type" obliteration ;)
			// 1.0.11 also forcing label & description
			$query = 'UPDATE '.$this->_db->nameQuote('#__jmylife_configuration').' SET '
				. $this->_db->nameQuote('group').'='.$this->_db->Quote($group).', '
				. $this->_db->nameQuote('subgroup').'='.$this->_db->Quote($subgroup).', '
				. $this->_db->nameQuote('ordering').'='.$order.', '
				. $this->_db->nameQuote('type').'='.$this->_db->Quote($type).', '
				. $this->_db->nameQuote('label').'='.$this->_db->Quote($label).', '
				. $this->_db->nameQuote('description').'='.$this->_db->Quote($desc).' '
				. 'WHERE '.$this->_db->nameQuote('key').'='.$this->_db->Quote($key).' '
				. 'LIMIT 1'
			;
			$this->_db->setQuery($query);
			if (!($this->_db->query())) {
				$this->_installErrors[] = JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_CONFIGURATIONGROUP', $key, $query);
			}
		}
		if ($this->isUpgrade) {
			// "fix" colors, since 1.0.11
			// main story background
			$query = 'SELECT '
				. $this->_db->nameQuote('value').' '
				. 'FROM '.$this->_db->nameQuote('#__jmylife_configuration').' '
				. 'WHERE '.$this->_db->nameQuote('key').' = "story_background" '
				. 'AND '.$this->_db->nameQuote('key').' LIKE '.$this->_db->Quote('#%')
			;
			$this->_db->setQuery($query);
			if ($oldcolor = $this->_db->loadResult()) {
				$query = 'UPDATE '
					. $this->_db->nameQuote('#__jmylife_configuration').' '
					. 'SET '.$this->_db->nameQuote('value').' = '
					. $this->_db->Quote(preg_replace('`^\#`', '', $oldcolor)).' '
					. 'WHERE '.$this->_db->nameQuote('key').' = "story_background"'
				;
				$this->_db->exec($query);
			}
			// category colors
			$query = 'SELECT '
				. $this->_db->nameQuote('id').', '
				. $this->_db->nameQuote('background').', '
				. $this->_db->nameQuote('color').' '
				. 'FROM '.$this->_db->nameQuote('#__jmylife_categories').' '
				. 'WHERE '.$this->_db->nameQuote('background').' LIKE '.$this->_db->Quote('#%')
				. 'OR '.$this->_db->nameQuote('color').' LIKE '.$this->_db->Quote('#%')
			;
			$this->_db->setQuery($query);
			if ($oldcolors = $this->_db->loadObjectList()) {
				if (count($oldcolors)) {
					foreach ($oldcolors as $old) {
						$query = 'UPDATE '
							. $this->_db->nameQuote('#__jmylife_categories').' '
							. 'SET '.$this->_db->nameQuote('color').' = '
							. $this->_db->Quote(preg_replace('`^\#`', '', $old->color)).', '
							. $this->_db->nameQuote('background').' = '
							. $this->_db->Quote(preg_replace('`^\#`', '', $old->background)).' '
							. 'WHERE '.$this->_db->nameQuote('id').' = '.$old->id
						;
						$this->_db->exec($query);
					}
				}
			}
			// no need for this anymore
			$this->_db->exec('DELETE FROM '.$this->_db->nameQuote('#__jmylife_configuration').' WHERE '.$this->_db->nameQuote('key').'='.$this->_db->quote('load_jquery'));
			// quietly clean up any leftovers from 1.0.9alpha/beta builds
			$this->_db->exec('DELETE FROM '.$this->_db->nameQuote('#__jmylife_configuration').' WHERE '.$this->_db->nameQuote('key').'="sendfriend_allow"');
		}
		// do update check
		$this->_db->exec('UPDATE '.$this->_db->nameQuote('#__jmylife_configuration').' SET '.$this->_db->nameQuote('value').' = 0 WHERE '.$this->_db->nameQuote('key').'="needs_update"');
		$installed  = $this->_cfg->version->getFullVersion();
		$current    = @file_get_contents('http://jeffchannell.com/jmylife-version.php');
		if ($current && -1 == version_compare($installed, $current)) {
			$this->_db->exec('UPDATE '.$this->_db->nameQuote('#__jmylife_configuration').' SET '.$this->_db->nameQuote('value').' = 1 WHERE '.$this->_db->nameQuote('key').'="needs_update"');
		}
		if (count($this->_installErrors)) {
			foreach ($this->_installErrors as $err) {
				$this->_msg(sprintf($this->_err, $err), '#FFD0D0', 'publish_x.png');
			}
		} else {
			$this->_msg(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCONFIGURATIONSUCCESS'));
		}
		$this->_installErrors = array();
		echo $this->_slider->endPanel();

		echo $this->_slider->startPanel(JText::_('COM_JMYLIFE_INSTALLATION_HELPERS'), "install-panel-helpers");
		foreach ($this->_packages as $pkg => $pkgname) {
			$pkgname = JText::_($pkgname);
			if ($this->_installer->install($pkg, $pkgname, true)) {
				$msgcolor = "#E0FFE0";
				$msgtext  = JText::sprintf('COM_JMYLIFE_INSTALLATION_HELPERSSUCCESS', $pkgname);
				$msgicon  = 'tick.png';
			} else {
				$msgcolor = "#FFD0D0";
				$msgtext  = sprintf($this->_err, JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_EXTENSIONFAILED', $pkgname));
				$msgicon  = 'publish_x.png';
			}
			$this->_msg($msgtext, $msgcolor, $msgicon);
		}
		// clean up extensions dir
		$this->_installer->cleanPackageRoot();
		$this->_installErrors = array();
		echo $this->_slider->endPanel();

		// social engines panel
		echo $this->_slider->startPanel(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGSOCIAL'), "install-panel-socialengines");
		if (!$this->_cfg->has->jomsocial) {
			$this->_msg(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGSOCIALJSNOTFOUND'), '#4a544a');
		} else {
			// set the filenames
			$this->_packages = JmylifeInstallerDefaultPackages::getjs();
			foreach ($this->_packages as $pkg => $pkgname) {
				$pkgname = JText::_($pkgname);
				if ($this->_installer->installJomSocialPlugin($pkg, $pkgname, false)) {
					$msgcolor = "#E0FFE0";
					$msgtext  = JText::sprintf('COM_JMYLIFE_INSTALLATION_HELPERSSUCCESS', $pkgname);
					$msgicon  = 'tick.png';
				} else {
					$msgcolor = "#FFD0D0";
					$msgtext  = sprintf($this->_err, JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_EXTENSIONFAILED', $pkgname));
					$msgicon  = 'publish_x.png';
				}
				$this->_msg($msgtext, $msgcolor, $msgicon);
			}
			// clean up extensions dir
			$this->_installer->cleanPackageRoot('jomsocial');
		}
		// since 1.0.9 add cb plugins
		// first, check if com_comprofiler is even there
		if (!($this->_cfg->has->cb && JFolder::exists($this->_installer->cbinstallpath))) {
			$this->_msg(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGSOCIALCBNOTFOUND'), '#4a544a');
		} else {
			$this->_packages = JmylifeInstallerDefaultPackages::getcb();
			foreach ($this->_packages as $plg => $plginfo) {
				$plginfo = JText::_($plginfo);
				if ($this->_installer->installCommunityBuilderPlugin($plg, $plginfo)) {
					$msgcolor = "#E0FFE0";
					$msgicon  = 'tick.png';
					$msgtext  = $this->_installer->message();
				} else {
					$msgcolor = "#FFD0D0";
					$msgicon  = 'publish_x.png';
					$msgtext  = sprintf($this->_err, $this->_installer->message());
				}
				$this->_msg($msgtext, $msgcolor, $msgicon);
			}
		}
		$this->_installer->cleanPackageRoot('cb');
		echo $this->_slider->endPanel();

		// 3rd party panel
		echo $this->_slider->startPanel(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGTHIRDPARTY'), "install-panel-thirdparty");
		// !joomlacomment has become compojoomcomment
		// Daniel might be interested in taking over the jml plugin on his side
		// TODO: update this!
		// compojoomcomment requires plugins to be placed in a specific place, attempt to move plugin files to their proper place
		$jmljcpath = $joomParent->getPath('source').DS.'admin'.DS.'extensions'.DS.'joomlacomment'.DS;
		// only bother if path exists ;)
		if (!(JFolder::exists($this->_installer->joomlacommentinstallpath) && $this->_cfg->has->joomlacomment)) {
			$this->_msg(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGTHIRDPARTYCOMPOJOOMCOMMENTNOTFOUND'), '#4a544a');
		} else {
			if ($this->_installer->installJoomlaCommentPlugin($jmljcpath)) {
				$msgcolor = "#E0FFE0";
				$msgicon  = 'tick.png';
				$msgtext  = $this->_installer->message();
			} else {
				$msgcolor = "#FFD0D0";
				$msgicon  = 'publish_x.png';
				$msgtext  = sprintf($this->_err, $this->_installer->message());
			}
			$this->_msg($msgtext, $msgcolor, $msgicon);
		}
		// xmap requires plugins to be placed in a specific place, attempt to move plugin files to their proper place
		$jmlxmappath = $joomParent->getPath('source').DS.'admin'.DS.'extensions'.DS.'xmap'.DS;
		// only bother if path exists ;)
		if (!(JFolder::exists($this->_installer->xmapinstallpath) && $this->_cfg->has->xmap)) {
			$this->_msg(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGTHIRDPARTYXMAPNOTFOUND'), '#4a544a');
		} else {
			if ($this->_installer->installXmapPlugin($jmlxmappath)) {
				$msgcolor = "#E0FFE0";
				$msgicon  = 'tick.png';
				$msgtext  = $this->_installer->message();
			} else {
				$msgcolor = "#FFD0D0";
				$msgicon  = 'publish_x.png';
				$msgtext  = sprintf($this->_err, $this->_installer->message());
			}
			$this->_msg($msgtext, $msgcolor, $msgicon);
		}
		// end third party
		echo $this->_slider->endPanel();

		// categories panel
		echo $this->_slider->startPanel(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCATEGORIES'), "install-panel-categories");
		$this->_db->setQuery('SELECT COUNT(id) AS c FROM '.$this->_db->nameQuote('#__jmylife_categories'));
		if (0 == intval($this->_db->loadResult())) {
			if ($this->_db->exec(
				'INSERT INTO '.$this->_db->nameQuote('#__jmylife_categories').' ( '.
					$this->_db->nameQuote('name').', '.
					$this->_db->nameQuote('published').', '.
					$this->_db->nameQuote('allow_comments').', '.
					$this->_db->nameQuote('allow_votes').' '.
				') VALUES ( '.$this->_db->Quote(JText::_('COM_JMYLIFE_INSTALLATION_DEFAULTCATEGORY')).', 1, 1, 1 )'
			)) {
				$msgcolor = "#E0FFE0";
				$msgtext  = JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCATEGORIESNONEFOUND');
				$msgicon  = 'tick.png';
			} else {
				$msgcolor = "#FFD0D0";
				$msgtext  = sprintf($this->_err, JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCATEGORIESNONEFOUNDCOULDNOTINSTALL'));
				$msgicon  = 'publish_x.png';
			}
		} else {
			$msgcolor = "#E0FFE0";
			$msgtext  = JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCATEGORIESFOUND');
			$msgicon  = 'tick.png';
		}
		$this->_msg($msgtext, $msgcolor, $msgicon);
		// end categories
		echo $this->_slider->endPanel();

		// story panel
		echo $this->_slider->startPanel(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGSTORIES'), "install-panel-stories");
		// check stories, install a default one if needed
		$this->_db->setQuery('SELECT COUNT(id) AS c FROM `#__jmylife_stories`');
		$msgcolor = "#E0FFE0";
		$msgtext  = JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGSTORIESFOUND');
		$msgicon  = 'tick.png';
		if (0 == intval($this->_db->loadResult())) {
			if ($this->_db->exec(
				'INSERT INTO '.$this->_db->nameQuote('#__jmylife_stories').' ( '.
					$this->_db->nameQuote('catid').', '.
					$this->_db->nameQuote('published').', '.
					$this->_db->nameQuote('time').', '.
					$this->_db->nameQuote('user_id').', '.
					$this->_db->nameQuote('fulltext').', '.
					$this->_db->nameQuote('user_alias').', '.
					$this->_db->nameQuote('title').' '.
				') VALUES ( 1, 1, '.time().', 0, '.
					$this->_db->Quote(JText::_('COM_JMYLIFE_INSTALLATION_DEFAULTSTORYTEXT')).', '.
					$this->_db->Quote(JText::_('COM_JMYLIFE_INSTALLATION_DEFAULTSTORYUSER')).', '.
					$this->_db->Quote(JText::_('COM_JMYLIFE_INSTALLATION_DEFAULTSTORYTITLE')).' '.
				')'
			)) {
				$msgcolor = "#E0FFE0";
				$msgtext  = JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGSTORIESNONEFOUND');
				$msgicon  = 'tick.png';
			} else {
				$msgcolor = "#FFD0D0";
				$msgtext  = sprintf($this->_err, JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGSTORIESNONEFOUNDCOULDNOTINSTALL'));
				$msgicon  = 'publish_x.png';
			}
		}
		$this->_msg($msgtext, $msgcolor, $msgicon);
		// end categories
		echo $this->_slider->endPanel();

		// css panel
		echo $this->_slider->startPanel(JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCUSTOMCSS'), "install-panel-css");
		$csspath = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'assets'.DS.'css'.DS.'custom'.DS;
		if (!JFolder::exists($csspath)) {
			// create folder?
		}
		// check for css files in css path
		$cssfiles = JFolder::files($csspath, '.css');
		$msgcolor = "#E0FFE0";
		$msgicon  = 'tick.png';
		$msgtext  = JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCUSTOMCSSFOUND');
		if (0 == count($cssfiles)) {
			$msgtext  = JText::_('COM_JMYLIFE_INSTALLATION_CHECKINGCUSTOMCSSNOTFOUND');
			$defaultCss = <<<EOF
/* sample css file for JMyLife */
* {}
EOF
			;
			// create css file
			if (!JFile::write($csspath.'sample.css', $defaultCss)) {
				$msgtext  = sprintf($this->_err, JText::_('COM_JMYLIFE_ERROR_INSTALLATION_CHECKINGCUSTOMCSSNOTCREATED'));
			}
		}
		$this->_msg($msgtext, $msgcolor, $msgicon);
		// end cssfiles
		echo $this->_slider->endPanel();

		// end panels
		echo $this->_slider->endPane();

		// all done!
		echo JText::_('COM_JMYLIFE_INSTALLATION_ALLDONE');

		// the rest of 2 column table
?>
				</div>
			</td>
			<td valign="top">
				<div id="jmlChangelog" style="font-family:monospace;overflow:scroll;border:1px solid #636363;padding:5px;margin:5px;"><?php
					echo COM_JMYLIFE_CHANGELOG_KEY;
					echo '<br /><br />';
					$_cl = ''.COM_JMYLIFE_CHANGELOG;
					foreach( explode( '+++', $_cl ) as $cl ) echo $cl;
				?></div>
			</td>
		</tr>
	</tbody>
</table>
<script type="text/javascript" src="../components/com_jmylife/libraries/jquery/jquery-1.4.2.min.js"></script>
<script type="text/javascript" src="../components/com_jmylife/libraries/jquery/jquery.noconflict.js"></script>
<script type="text/javascript">
// <!--
(function($) {
	$(document).ready(function(){
		$('#jmlChangelog').css({'height': $('#jmlInstallDetails').height() + 'px'});
		$('.jmlError').each(function() {
			$(this).closest('.panel').children('h3:first').first().css({color: '#f00'});
		});
	});
})(window.jml.jQuery);
// -->
</script>
<?php
		// fin
		return;
	}
	// for existing installs
	private function _upgradeTables() {
		// since 1.0.4 config params have had groups
		// to maintain backwards compat and upgradability
		// leave old queries intact and alter afterwards
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_configuration').' LIKE \'group\'',
			'group',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_configuration').' ADD '.$this->_db->nameQuote('group').' VARCHAR(50) NOT NULL DEFAULT "" AFTER '.$this->_db->nameQuote('value')
		);
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_configuration').' LIKE \'ordering\'',
			'ordering',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_configuration').' ADD '.$this->_db->nameQuote('ordering').' INT(11) NOT NULL DEFAULT 0 AFTER '.$this->_db->nameQuote('group')
		);
		// fix group length
		$query = 'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_configuration').' MODIFY '.$this->_db->nameQuote('group').' VARCHAR(50)';
		$this->_db->setQuery($query);
		if (!($this->_db->query())) {
			$this->_installErrors[] = JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_SQL', $query, $this->_db->getErrorMsg());
		}
		// fixed in 1.0.4: comment warnings had ip as primary key
		// NOTE: only works in MySQL 5
		$config = new JConfig();
		// this query had a typo - fixed in 1.0.7
		$this->showAlterTable('SELECT k.column_name
			FROM information_schema.table_constraints t
			JOIN information_schema.key_column_usage k
			USING(constraint_name,table_schema,table_name)
			WHERE t.constraint_type=\'PRIMARY KEY\'
			AND t.table_schema=\''.$config->db.'\'
			AND t.table_name=\''.$config->dbprefix.'jmylife_comments_warnings\'',
			'ip',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_comments_warnings').' DROP PRIMARY KEY',
			true
		);
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_comments').' LIKE \'warnings\'',
			'warnings',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_comments').' DROP COLUMN '.$this->_db->nameQuote('warnings'),
			true
		);
		// since 1.0.5 categories and stories can have comments and/or voting blocked
		// categories
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_categories').' LIKE \'allow_votes\'',
			'allow_votes',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_categories').' ADD '.$this->_db->nameQuote('allow_votes').' TINYINT(1) NOT NULL DEFAULT 1'
		);
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_categories').' LIKE \'allow_comments\'',
			'allow_comments',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_categories').' ADD '.$this->_db->nameQuote('allow_comments').' TINYINT(1) NOT NULL DEFAULT 1'
		);
		// stories
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'allow_votes\'',
			'allow_votes',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' ADD '.$this->_db->nameQuote('allow_votes').' TINYINT(1) NOT NULL DEFAULT 1'
		);
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'allow_comments\'',
			'allow_comments',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' ADD '.$this->_db->nameQuote('allow_comments').' TINYINT(1) NOT NULL DEFAULT 1'
		);
		// since 1.0.5 stories have an extra textarea only available to admins
		// this allows admins to place their own messages on stories that stand out from normal comments
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'admin_fulltext\'',
			'admin_fulltext',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' ADD '.$this->_db->nameQuote('admin_fulltext').' mediumtext NOT NULL DEFAULT ""'
		);
		// since 1.0.5 stories have optional titles
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'title\'',
			'title',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' ADD '.$this->_db->nameQuote('title').' VARCHAR(255) NOT NULL DEFAULT ""'
		);
		// since 1.0.8 categories have descriptions
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_categories').' LIKE \'description\'',
			'description',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_categories').' ADD '.$this->_db->nameQuote('description').' MEDIUMTEXT NOT NULL DEFAULT ""'
		);
		// since 1.0.9 guest submissions can capture emails
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'user_email\'',
			'user_email',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' ADD '.$this->_db->nameQuote('user_email').' VARCHAR(255) NOT NULL DEFAULT "" AFTER '.$this->_db->nameQuote('user_alias')
		);
		// 1.0.10 had queries leftover from moderation
		// remove old fields and replace with new ones
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'voteyes\'',
			'voteyes',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' DROP COLUMN '.$this->_db->nameQuote('voteyes'),
			true
		);
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'voteno\'',
			'voteno',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' DROP COLUMN '.$this->_db->nameQuote('voteno'),
			true
		);
		// since 1.0.11 stories also have moderation votes
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'moderate2\'',
			'moderate2',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' ADD '.$this->_db->nameQuote('moderate2').' INT(12) NOT NULL DEFAULT 0 AFTER '.$this->_db->nameQuote('votes2')
		);
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'moderate1\'',
			'moderate1',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' ADD '.$this->_db->nameQuote('moderate1').' INT(12) NOT NULL DEFAULT 0 AFTER '.$this->_db->nameQuote('votes2')
		);
		// since 1.0.11 add "reported" field to prevent multiple emails for reported stories
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_stories').' LIKE \'reported\'',
			'reported',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_stories').' ADD '.$this->_db->nameQuote('reported').' INT(1) NOT NULL DEFAULT 0 AFTER '.$this->_db->nameQuote('votes2')
		);
		// since 1.0.10 categories can have their own colors & backgrounds
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_categories').' LIKE \'background\'',
			'background',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_categories').' ADD '.$this->_db->nameQuote('background').' VARCHAR(100) NOT NULL DEFAULT "" AFTER '.$this->_db->nameQuote('published')
		);
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_categories').' LIKE \'color\'',
			'color',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_categories').' ADD '.$this->_db->nameQuote('color').' VARCHAR(20) NOT NULL DEFAULT "" AFTER '.$this->_db->nameQuote('published')
		);
		// not using the standard 'showAlterTable' function
		// because if the initial query executes the ordering needs to be set manually
		$this->_db->setQuery('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_categories').' LIKE \'ordering\'');
		if ('ordering' != $this->_db->loadResult('ordering')) {
			$query = 'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_categories').' ADD '.$this->_db->nameQuote('ordering').' INT(11) NOT NULL DEFAULT 0 AFTER '.$this->_db->nameQuote('published');
			$this->_db->setQuery( $query );
			if (!($this->_db->query())) {
				$this->_installErrors[] = JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_SQL', $query, $this->_db->getErrorMsg());
			} else {
				// get cats & set ordering
				$this->_db->setQuery('SELECT '.$this->_db->nameQuote('id').' FROM '.$this->_db->nameQuote('#__jmylife_categories').' ORDER BY '.$this->_db->nameQuote('name').' ASC');
				if ($rows = $this->_db->loadObjectList()) {
					if (count($rows)) {
						$count = 0;
						foreach ($rows as $row) {
							$this->_db->exec('UPDATE '.$this->_db->nameQuote('#__jmylife_categories').' SET '.$this->_db->nameQuote('ordering').' = '.(++$count).' WHERE '.$this->_db->nameQuote('id').' = '.$row->id);
						}
						unset($count);
					}
				}
			}
		}
		// in 1.0.11 Moderate & Categories views were added to mod_jmylifecategorymenu
		// this is to update the params to include these links in the sort order
		// defaults to appending to the end
		$query = 'SELECT '.$this->_db->nameQuote('id').', '.$this->_db->nameQuote('params').' FROM '.$this->_db->nameQuote('#__modules').' WHERE '.$this->_db->nameQuote('module').' = "mod_jmylifecategorymenu"';
		$this->_db->setQuery($query);
		if ($rows = $this->_db->loadObjectList()) {
			foreach ($rows as $row) {
				if (!preg_match('`linkorder=[^\n]*?4[^\n]*?\r?\n`s', $row->params)) {
					$modparam = preg_replace('`(linkorder=[^\n]*?)(\r?\n)`s', '$1,4$2', $row->params);
					$query = 'UPDATE '.$this->_db->nameQuote('#__modules').' SET '.$this->_db->nameQuote('params').' = '.$this->_db->quote($modparam).' WHERE '.$this->_db->nameQuote('id').' = '.$row->id;
					$this->_db->setQuery($query);
					if (!($this->_db->query())) {
						$this->_installErrors[] = JText::_('COM_JMYLIFE_ERROR_INSTALLATION_MODCATMENUMODERATELINK');
					}
				}
			}
		}
		$query = 'SELECT '.$this->_db->nameQuote('id').', '.$this->_db->nameQuote('params').' FROM '.$this->_db->nameQuote('#__modules').' WHERE '.$this->_db->nameQuote('module').' = "mod_jmylifecategorymenu"';
		$this->_db->setQuery($query);
		if ($rows = $this->_db->loadObjectList()) {
			foreach ($rows as $row) {
				if (!preg_match('`linkorder=[^\n]*?5[^\n]*?\r?\n`s', $row->params)) {
					$modparam = preg_replace('`(linkorder=[^\n]*?)(\r?\n)`s', '$1,5$2', $row->params);
					$query = 'UPDATE '.$this->_db->nameQuote('#__modules').' SET '.$this->_db->nameQuote('params').' = '.$this->_db->quote($modparam).' WHERE '.$this->_db->nameQuote('id').' = '.$row->id;
					$this->_db->setQuery($query);
					if (!($this->_db->query())) {
						$this->_installErrors[] = JText::_('COM_JMYLIFE_ERROR_INSTALLATION_MODCATMENUCATLINK');
					}
				}
			}
		}
		// fix for bug pre-1.0.11 in stories administrator form
		$query = 'SELECT '
			. $this->_db->nameQuote( 'id' )        .', '
			. $this->_db->nameQuote( 'fulltext' )  .', '
			. $this->_db->nameQuote( 'title' )     .', '
			. $this->_db->nameQuote( 'user_alias' ).'  '
			. 'FROM  '.$this->_db->nameQuote( '#__jmylife_stories' ).' '
			. 'WHERE '.$this->_db->nameQuote( 'fulltext' ).' LIKE "%E2%80%8B%" '
			. 'OR '.$this->_db->nameQuote( 'title' )      .' LIKE "%E2%80%8B%" '
			. 'OR '.$this->_db->nameQuote( 'user_alias' ) .' LIKE "%E2%80%8B%" '
		;
		$this->_db->setQuery( $query );
		if ($rows = $this->_db->loadObjectList()) {
			foreach ($rows as $row) {
				$query = 'UPDATE '
					. $this->_db->nameQuote( '#__jmylife_stories' ).' '
					. 'SET '.$this->_db->nameQuote( 'fulltext' )  .' = '.$this->_db->quote( str_replace( '%E2%80%8B', '', $row->fulltext.'' ) ).', '
					. 'SET '.$this->_db->nameQuote( 'title' )     .' = '.$this->_db->quote( str_replace( '%E2%80%8B', '', $row->title.'' ) ).', '
					. 'SET '.$this->_db->nameQuote( 'user_alias' ).' = '.$this->_db->quote( str_replace( '%E2%80%8B', '', $row->user_alias.'' ) ).' '
					. 'WHERE `id` = '.$row->id
				;
				$this->_db->exec($query);
			}
		}
		// 1.0.14 added subgroup to config
		$this->showAlterTable('SHOW COLUMNS FROM '.$this->_db->nameQuote('#__jmylife_configuration').' LIKE \'subgroup\'',
			'subgroup',
			'ALTER TABLE '.$this->_db->nameQuote('#__jmylife_configuration') .' ADD '.$this->_db->nameQuote('subgroup').' VARCHAR(50) NOT NULL DEFAULT "" AFTER '.$this->_db->nameQuote('group')
		);
		// all done with upgrade!
	}
	// for checking errors
	private function _checkErr($bool, $err) {
		if (!$bool) {
			echo sprintf($this->_syserr, JText::_($err));
		}
	}
	// can we connect to remote servers?
	private function _checkRemote() {
		$this->_checkErr((function_exists('curl_init') || @ini_get('allow_url_fopen')), 'COM_JMYLIFE_ERROR_INSTALLATION_NOREMOTE');
	}
	// for displaying messages in slider table
	private function _msg($msg, $color=false, $image=false) {
		if (!$color) $color = '#E0FFE0';
		if (!$image) $image = 'tick.png';?>
	<table bgcolor="<?php echo $color; ?>" width ="100%">
		<tr style="height:30px">
			<td width="50px"><img src="<?php echo JURI::base(); ?>/images/<?php echo $image; ?>" height="16px" width="16px"></td>
			<td><font size="2"><b><?php echo $msg; ?></b></font></td>
		</tr>
	</table>
<?php
		return;
	}
	// for loading files needed by install
	private function _loadClass($class, $file, $err, $root=false) {
		if (false === $root) {
			global $joomParent;
			$root = $joomParent->getPath('source');
		}
		$file = $root.DS.$file;
		if (JFile::exists($file) && !class_exists($class)) {
			@require_once ($file);
		}
		$this->_checkErr(class_exists($class), $err);
	}
	// for removing installer folders
	private function recursiveDelete($str) {
		if (is_file($str)) {
			return @unlink($str);
		}
		elseif (is_dir($str)) {
			$scan = glob(rtrim($str, '/').'/*');
			if ($scan) {
				foreach ($scan as $index => $path) {
					$this->recursiveDelete($path);
				}
			}
			return @rmdir($str);
		}
	}
	/**
	 * function showAlterTable
	 * @param  string   sql string
	 * @param  string   column name expected
	 * @param  string   sql string
	 * @param  bool
	 * @since 1.0.9
	 *
	 * helper function for upgrading tables
	 */
	function showAlterTable($show, $case, $alter, $eq=false) {
		$this->_db->setQuery($show);
		$bool = $eq ? $this->_db->loadResult() == $case : $this->_db->loadResult() != $case;
		if ($bool) {
			$this->_db->setQuery($alter);
			if (!($this->_db->query())) {
				$this->_installErrors[] = JText::sprintf('COM_JMYLIFE_ERROR_INSTALLATION_SQL', $alter, $this->_db->getErrorMsg());
			}
		}
	}
	/**
	 * UNINSTALL
	 */
	function uninstall() {
		// load required libs
		JLoader::import('components.com_jmylife.helpers.database', JPATH_ADMINISTRATOR, '');
		foreach (array('module', 'plugin') as $mod) {
			if (!class_exists('JInstaller'.ucwords($mod))) {
				require_once (JPATH_ROOT.DS.'libraries'.DS.'joomla'.DS.'installer'.DS.'adapters'.DS.$mod.'.php');
			}
		}
		// make sure db is set
		$this->_db = JmylifeDatabaseHelper::getInstance();

?>
<table border="0" width="100%" cellpadding="0" cellspacing="5">
	<thead>
		<tr>
			<th>
				<img src="http://i.jeffchannell.com/JMyLife.png?reason=uninstall&version=pro" alt="JML" style="float:left;padding-right:24px;" />
				<?php echo JText::_('COM_JMYLIFE_UNINSTALL_UNINSTALLING'); ?>
				<div style="clear:left;"><!-- --></div>
			</th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td>
				<h3><?php echo JText::_('COM_JMYLIFE_UNINSTALL_COMPLETE'); ?></h3>
			</td>
		</tr>
	</tfoot>
	<tbody>
		<tr>
			<td>
<?php
	$this->_db->setQuery('SELECT '.$this->_db->nameQuote('key').', '.$this->_db->nameQuote('value').' FROM '.$this->_db->nameQuote('#__jmylife_configuration').' WHERE '.$this->_db->nameQuote('key').' IN ("uninstall_droptables", "uninstall_removemodules", "uninstall_removeimages") AND '.$this->_db->nameQuote('value').' = 1');
	if ($rows = $this->_db->loadObjectList()) {
		foreach ($rows as $row) {
			switch ($row->key) {
				case 'uninstall_droptables':
					echo '<h3>'.JText::_('COM_JMYLIFE_UNINSTALL_DATABASE').'</h3>';
					$tables = array(
						'#__jmylife_stories',
						'#__jmylife_stories_attachments',
						'#__jmylife_stories_subscriptions',
						'#__jmylife_stories_versions',
						'#__jmylife_categories',
						'#__jmylife_comments',
						'#__jmylife_comments_warnings',
						'#__jmylife_configuration',
						'#__jmylife_language',
						'#__jmylife_favorites',
						'#__jmylife_votes'
					);
					foreach ($tables as $table) {
						$this->_db->setQuery('DROP TABLE IF EXISTS '.$this->_db->nameQuote($table));
						if ($this->_db->query()) {
							$msgcolor = "#E0FFE0";
							$msgtext  = JText::sprintf('COM_JMYLIFE_UNINSTALL_DATABASETABLEDROPPED', $table);
							$msgicon  = 'tick.png';
						} else {
							$msgcolor = "#FFD0D0";
							$msgtext  = JText::sprintf('COM_JMYLIFE_ERROR_UNINSTALL_DROPTABLE', $table);
							$msgicon  = 'publish_x.png';
						}
	?>
	<table bgcolor="<?php echo $msgcolor; ?>" width ="100%">
		<tr style="height:30px">
			<td width="50px"><img src="<?php echo JURI::base(); ?>/images/<?php echo $msgicon; ?>" height="16px" width="16px"></td>
			<td><font size="2"><b><?php echo $msgtext; ?></b></font></td>
		</tr>
	</table>
<?php
					}
					break;
				case 'uninstall_removemodules':
					echo '<h3>'.JText::_('COM_JMYLIFE_UNINSTALL_EXTENSIONS').'</h3>';
					$installer = new JInstaller();
					// get modules from db & run uninstall routine on them
					$this->_db->setQuery('SELECT `id`, `module` FROM `#__modules` WHERE `module` IN ("mod_jmylifecategorymenu", "mod_jmylifedatepicker", "mod_jmylifesubmit", "mod_jmylifelatest", "mod_jmylifelatestcomments", "mod_jmylifetopauthors", "mod_jmylifefeed") GROUP BY `module`');
					if ($mods = $this->_db->loadObjectList()) {
						$moduninstaller = new JInstallerModule($installer);
						foreach ($mods as $mod) {
							if ($moduninstaller->uninstall($mod->id, 0)) {
								$msgcolor = "#E0FFE0";
								$msgtext  = JText::sprintf('COM_JMYLIFE_UNINSTALL_EXTENSIONSREMOVED', $mod->module);
								$msgicon  = 'tick.png';
							} else {
								$msgcolor = "#FFD0D0";
								$msgtext  = JText::sprintf('COM_JMYLIFE_ERROR_UNINSTALL_REMOVEEXTENSION', $mod->module);
								$msgicon  = 'publish_x.png';
							}
	?>
	<table bgcolor="<?php echo $msgcolor; ?>" width ="100%">
		<tr style="height:30px">
			<td width="50px"><img src="<?php echo JURI::base(); ?>/images/<?php echo $msgicon; ?>" height="16px" width="16px"></td>
			<td><font size="2"><b><?php echo $msgtext; ?></b></font></td>
		</tr>
	</table>
<?php
						}
					}
					// now handle plugins
					$this->_db->setQuery('SELECT `id`, `element` FROM `#__plugins` WHERE `element` IN ("jmylifesearch", "jmylifesearchavatars", "jmylifemenucounts", "jmylifesubmit", "jmylifestories", "jmylifefavorites", "jmylifetoolbar")');
					if ($plugs = $this->_db->loadObjectList()) {
						$plguninstaller = new JInstallerPlugin($installer);
						foreach ($plugs as $plug) {
							if ($plguninstaller->uninstall($plug->id, 0)) {
								$msgcolor = "#E0FFE0";
								$msgtext  = JText::sprintf('COM_JMYLIFE_UNINSTALL_EXTENSIONSREMOVED', $plug->element);
								$msgicon  = 'tick.png';
							} else {
								$msgcolor = "#FFD0D0";
								$msgtext  = JText::sprintf('COM_JMYLIFE_ERROR_UNINSTALL_REMOVEEXTENSION', $plug->element);
								$msgicon  = 'publish_x.png';
							}
	?>
	<table bgcolor="<?php echo $msgcolor; ?>" width ="100%">
		<tr style="height:30px">
			<td width="50px"><img src="<?php echo JURI::base(); ?>/images/<?php echo $msgicon; ?>" height="16px" width="16px"></td>
			<td><font size="2"><b><?php echo $msgtext; ?></b></font></td>
		</tr>
	</table>
<?php
						}
					}
					break;
				case 'uninstall_removeimages':
					echo '<h3>'.JText::_('COM_JMYLIFE_UNINSTALL_IMAGES').'</h3>';
					$msgcolor = "#E0FFE0";
					$msgtext  = JText::sprintf('COM_JMYLIFE_UNINSTALL_IMAGESNONE', $path);
					$msgicon  = 'tick.png';
					$path = JPATH_ROOT.DS.'images'.DS.'jmylife';
					if (JFolder::exists($path)) {
						if (JFolder::delete($path)) {
							$msgtext  = JText::_('COM_JMYLIFE_UNINSTALL_IMAGESREMOVED');
						} else {
							$msgcolor = "#FFD0D0";
							$msgtext  = JText::sprintf('COM_JMYLIFE_ERROR_UNINSTALL_REMOVEIMAGES', $path);
							$msgicon  = 'publish_x.png';
						}
					}
	?>
	<table bgcolor="<?php echo $msgcolor; ?>" width ="100%">
		<tr style="height:30px">
			<td width="50px"><img src="<?php echo JURI::base(); ?>/images/<?php echo $msgicon; ?>" height="16px" width="16px"></td>
			<td><font size="2"><b><?php echo $msgtext; ?></b></font></td>
		</tr>
	</table>
<?php
					break;
			}
		}
	}
?>
			</td>
		</tr>
	</tbody>
</table>
<?php
		// end uninstall
	}
}
// J!1.5 doesn't use the install class, run manually
$v = new JVersion();
if ('1.5' == $v->RELEASE && !defined('COM_JMYLIFE_UNINSTALL')) {
	$installClass = new com_jmylifeInstallerScript();
	echo $installClass->postflight('install', null);
}