/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/assets/js/storyAttachment.js
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since      1.0.13
 */
(function($){
	$(document).ready(function(){
		$('#comJMyLifeAttachmentItem, .attachmentArea').hide();
		// attach event
		var _buttons = $('.attachButton');
		_buttons.click(function(){
			$('#comJMyLifeAttachmentItem').show();
			$('#comJMyLifeAttachmentButtons').hide();
			$('#jmlAttachUrlField').val( '' );
			$('#jmlAttachTypeField').val( '' );
			// change label
			var _label = $(this).val();
			$('#comJMyLifeAttachmentHeader .header').text( _label );
			// show appropriate area
			$('.attachmentArea').hide().empty().removeClass('jmylifeLoaded').addClass('jmylifeLoading');
			var _areaId = $(this).attr('id').toString().replace(/Button$/, 'Area');
			var _area = $('#'+_areaId).show().addClass('jmylifeLoaded').removeClass('jmylifeLoading');
			// load relevant attachment area
			if (_areaId.match(/Link/)) {
				// input field for link
				var _linkbox = $('<input type="text" />').appendTo(_area);
				// additional 'quickpaste' button for IE ;)
				if (document.all) {
					_area.append(
						$('<input type="button"/>').val(window.jml.Attachment.Text.paste).click(function(){
							_linkbox.focus();
							document.execCommand("Paste");
						})
					);
				}
				// attach button to trigger additional actions
				var _linkbtn = $('<input type="button" />').addClass('addLinkBtn').val(window.jml.Attachment.Text.attach).appendTo(_area).click(function() {
					var _val = _linkbox.val();
					// hide contents and add loading sequence
					_area.removeClass('jmylifeLoaded').addClass('jmylifeLoading').children().hide();
					// validate remotely
					$.ajax({
						type: "POST",
						url: window.jml.root,
						data: 'option=com_jmylife&controller=ajax&task=validatestorylink&extra='+window.jml.Attachment.Extra+'&cid='+window.jml.Attachment.Item+'&url='+encodeURIComponent(_val),
						success: function(data, textStatus, XMLHttpRequest) {
							// remove loading sequence
							_area.addClass('jmylifeLoaded').removeClass('jmylifeLoading');
							// get data
							try {
								_data = eval('('+data+')');
							} catch (err) {
								alert(err);
								return;
							}
							if ('error' == _data.status) {
								_area.children().show();
								$('<div></div>').addClass('jmlLoadError').text(_data.message).appendTo(_area);
								return;
							}
							// link data
							var _htext = 0 < window.jml.Attachment.Title.length ? window.jml.Attachment.Title : _data.data.title;
							var _stext = 0 < window.jml.Attachment.Description.length ? window.jml.Attachment.Description : _data.data.description;
							if (!window.jml.Attachment.DescriptionAllow) {
								_stext = '';
							}
							// set data in form
							$('#jmlAttachUrlField').val(_val);
							$('#jmlAttachTypeField').val('link');
							$('#jmlAttachTitleField').val(_htext);
							$('#jmlAttachDescriptionField').val(_stext);
							// create elements for link images
							var _thumbs = $('<div></div>').addClass('jmlAttachThumbs').css({
								'position' : 'relative'
							}).appendTo( _area );
							if (!window.jml.Attachment.AllowImages) {
								_thumbs.hide();
							}
							// create elements for link data
							$('<h4></h4>').appendTo(_area).append($('<span></span>').text(_htext).click(function(){
								if (!window.jml.Attachment.Editable) {
									return;
								}
								var _t = $(this);
								$('<input type="text"'+(0 < window.jml.Attachment.TitleLimit ? ' maxlength="'+window.jml.Attachment.TitleLimit+'"' : '')+' />').width('75%').val(_t.text()).appendTo(_t.hide().parent()).blur(function(){
									var _v = $(this).val();
									_t.text(_v).show();
									$('#jmlAttachTitleField').val(_v);
									window.jml.Attachment.Title = '';
									$(this).remove();
								}).focus();
							}));
							$('<p></p>').appendTo(_area).append($('<span></span>').text(_stext).click(function(){
								if (!window.jml.Attachment.Editable) {
									return;
								}
								var _t = $(this);
								$('<textarea></textarea>').width('75%').val(_t.text()).appendTo(_t.hide().parent()).blur(function(){
									var _v = $(this).val();
									_t.text(_v).show();
									$('#jmlAttachDescriptionField').val(_v);
									window.jml.Attachment.Description = '';
									$(this).remove();
								}).focus();
							}));
							if (window.jml.Attachment.AllowImages && 0 == window.jml.Attachment.Extra) {
								// start adding images
								var _img = null, _total = 0, i = 0, n, _first, _last;
								if (0 < window.jml.Attachment.Image.length) {
									_data.data.images = [ window.jml.Attachment.Image ];
									n = 1;
								} else {
									n = _data.data.images.length;
								}
								for (; n > i; i++) {
									_img = $('<img src="'+_data.data.images[i]+'" alt="" />' ).appendTo(_thumbs).css({
										'position' : 'absolute',
										'top' : 0,
										'left' : 0
									});
									// if there's no "first" make the first image "first"
									if ('undefined' == typeof _first) {
										_first = _img.addClass('active').addClass('first');
										$('#jmlAttachThumbField').val(_data.data.images[i]);
									} else {
										if (n - 1 == i) {
											_img.addClass('last');
										}
										_img.hide();
									}
									// resize images, but only in one direction
									var _w = _img.width();
									var _h = _img.height()
									if (_w > _h && 100 < _w) {
										_img.width(100);
									}
									else if (_h > _w && 100 < _h) {
										_img.height(100);
									}
									_img = null;
									_total++;
								}
								// only do the rest if there are images
								if (0 < _total) {
									var _linkctrl = $('#jmylifeAttachLinkArea');
									// don't do navigation buttons unless there's more than 1
									if (1 < _total) {
										// previous button
										$('<input type="button" class="pager pagerLeft disabled" value="&lt;" />').appendTo(_linkctrl);
										// next button
										$('<input type="button" class="pager pagerRight" value="&gt;" />').appendTo(_linkctrl);
										// add click events
										$('.pager').click(function() {
											if ($(this).hasClass('disabled')) {
												return false;
											}
											$('.disabled').removeClass('disabled');
											// different "next" depending on direction
											var _next;
											if ($(this).hasClass('pagerLeft')) {
												_next = $('img.active').prev('img');
											}
											if ($(this).hasClass('pagerRight')) {
												_next = $('img.active').next('img');
											}
											// next doesn't exist? die
											if (!_next) {
												return false;
											}
											// change class
											$('img.active').removeClass('active').hide();
											_next.addClass('active').show();
											if (_next.hasClass('first') || _next.hasClass('last')) {
												$(this).addClass('disabled');
											}
											// change value
											$('#jmlAttachThumbField').val(_next.attr('src'));
										});
									}
									// add 'no image' control
									$('<input id="jmlNoLinkImages" type="checkbox" />').change(function(){
										$('.pager').toggle();
										_thumbs.toggle();
										$('#jmlAttachUseThumbField').val(1 == parseInt($('#jmlAttachUseThumbField').val()) ? 0 : 1);
									}).appendTo(_linkctrl);
									// also add label
									$('<label for="jmlNoLinkImages"></label>').text(window.jml.Attachment.Text.nothumb).appendTo(_linkctrl);
									// add clearing element (ew)
									$('<div class="jmlClear"></div>').appendTo(_area);
								}
							}
						}
					});
				});
			}
			else if (_areaId.match(/Image/)) {
				_area.empty();
				var _src = window.jml.root+'/index.php?option=com_jmylife&view=submit&format=raw&layout=upload';
				if (window.jml.Attachment.Image.length) {
					_src = window.jml.root+'/index.php?option=com_jmylife&view=submit&format=raw&layout=attach&local=1&id='+window.jml.Attachment.Item;
				}
				// image upload is done in an iframe so we can push the image to the server & validate before sending form
				var _frame = $('<iframe src="'+_src+'" frameborder="0"></iframe>').css({'border':0, 'width':'100%'}).appendTo(_area).hide();
			}
			else if (_areaId.match(/Video/)) {
				_area.empty().text('make it video');
			}
		});
		// handle passed link
		if (0 < window.jml.Attachment.Link.length && "link" == window.jml.Attachment.Type) {
			// trigger click
			$('#jmylifeAttachLinkButton').trigger('click');
			// fill in the first input
			$('#jmylifeAttachLinkArea input[type="text"]').val(window.jml.Attachment.Link);
			$('#jmylifeAttachLinkArea .addLinkBtn').trigger('click');
		}
		else if (window.jml.Attachment.Image.length && 'image' == window.jml.Attachment.Type) {
			// trigger click
			$('#jmylifeAttachImageButton').trigger('click');
		}
		// if there's only one button go ahead and trigger it's click action
		// added to this conditional to prevent weirdness re: input + details showing at the same time
		else if (1 == _buttons.length) {
			_buttons.trigger('click');
		}

		// close event
		$('#attachClose').click(function() {
			window.jml.Attachment.Link="";
			window.jml.Attachment.Type="";
			window.jml.Attachment.Title="";
			window.jml.Attachment.Description="";
			window.jml.Attachment.Image="";
			var _buttons;
			var _data = 'option=com_jmylife&controller=ajax&task=closeattachment';
			// reset everything
			$('#comJMyLifeAttachmentButtons').show();
			$('#comJMyLifeAttachmentItem').hide();
			$('#jmlAttachUrlField').val('');
			$('#jmlAttachTypeField').val('');
			$('#jmlAttachTitleField').val('');
			$('#jmlAttachThumbField').val('');
			$('#jmlAttachUseThumbField').val('1');
			$('#jmlAttachDescriptionField').val('');
			$('.attachmentArea').empty();
			// send a call to the ajax controller to "clean up"
			$.ajax({
				type: "POST",
				url: window.jml.root,
				data: _data
			});
			// trigger action if only one button
			_buttons = $('.attachButton');
			if (1 == _buttons.length) {
				_buttons.trigger('click');
			}
		});
	});
})(window.jml.jQuery);