<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/controllers/ajax.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.controller' );

/**
 * JMyLife Component Ajax Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerAjax extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		// initialize view if needed
		if( ( $view =& JRequest::getString( 'view' ) ) == FALSE )
		{
			JRequest::setVar( 'view', 'list' );
		}
		parent::display();
	}

	/**
	 * Method to display the view
	 *
	 * @access    public
	 * @param $msg string
	 * @param $amsg string
	 * since 1.0.1
	 * @param $redirect string
	 * since 1.0.2
	 * @param $params array key-value pairs to append to redirect
	 */
	function handlemessage( $msg, $amsg='', $redirect='', $params=null )
	{
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$redirectParams = '';
		$redirectScript = '';
		// make messages the same
		if( strlen( $amsg ) == 0 ) $amsg = $msg;
		// build extra params for redirect
		if( $params != null && count( $params ) > 0 )
		{
			// fix
			array_walk( $params, 'urlencode' );
			$redirectParams = ( preg_match( '`\?`', $redirect ) ? '&' : '?' ).http_build_query( $params );
		}
		// handle message
		if( JRequest::getInt( 'ajax' ) != 1 )
		{
			// redirect... lower case for 1.6
			$appl->enqueuemessage( $msg );
			// TODO: rewrite this to handle sending data back?
			$appl->redirect( strlen( $redirect ) == 0 ? $_SERVER['HTTP_REFERER'] : $redirect );
		}
		else
		{
			if( strlen( $redirect ) != 0 )
			{
				$redirectScript = '<script type="text/javascript">
setTimeout( "window.location.href=\''.$redirect.'\';", 2000 );
</script>';
			}
			die( $amsg.$redirectScript.$redirectParams );
		}
	}

	/**
	 * Method to save a new story
	 *
	 * @access    public
	 */
	function addstory()
	{
		JLoader::import('components.com_jmylife.helpers.captcha', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$captcha = JmylifeCaptchaHelper::getInstance();
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$autopublish = $_JMLConfig->getBool('autopublish_stories', false);
		$insertid = 0;
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// get user
		$user =& JFactory::getUser();
		$uid  =  $user->id;
		if ($user->guest && $_JMLConfig->getBool('user_stories_only', false)) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_NOGUEST'));
		}
		$time = time();
		$catid = JRequest::getInt( 'catid', 0 );
		$fulltext = trim( JRequest::getString( 'fulltext', '' ) );
		$attach = JRequest::getVar( 'attachment', null, 'post', 'array' );
		// set alias
		$alias = JRequest::getString( 'nickname', '' );
		// handle if no alias given
		if ($_JMLConfig->getBool('force_user_name', false) && !$user->guest) {
			$alias = false === $_JMLConfig->getBool('force_user_username', false) ? $user->name : $user->username;
		} else {
			$alias = strlen( trim( $alias ) ) > 0 ? $alias : 'Anonymous';
		}
		$title = JRequest::getString( 'title', '' ); // since 1.0.5
		$email = JRequest::getVar( 'user_email' ); // since 1.0.9
		// build redirect params
		$params = JRequest::get('post');
		// check $catid
		if (0 >= $catid) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_NOCATEGORY'), $html->alert(JText::_('COM_JMYLIFE_ERROR_STORY_NOCATEGORY')).$captcha->reload());
		}
		// since 1.0.5 only check title if required
		if (0 == strlen($title) && $_JMLConfig->getBool('allow_titles', false) && $_JMLConfig->getBool('require_titles', false)) {
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_STORY_NOTITLE" ), $html->alert( JText::_( "COM_JMYLIFE_ERROR_STORY_NOTITLE" ) ).$captcha->reload() );
		}
		// check that raw fulltext has contents
		if (0 == strlen($fulltext)) {
			// allow_attachment_blankstory
			$allowBlank = $_JMLConfig->getBool('allow_attachment_blankstory', false);
			if ($allowBlank && !in_array(@$attach['type'], array('link', 'image', 'video'))) {
				$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_STORY_NOTEXT"), $html->alert(JText::_("COM_JMYLIFE_ERROR_STORY_NOTEXT")).$captcha->reload());
			}
		}
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$string = JmylifeStringHelper::getInstance();
		// check length of text & alert if there's an issue
		$limit = $_JMLConfig->getInt('editor_limit', 0);
		if (0 < $limit) {
			if (strlen($fulltext) > $limit) {
				$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_STORY_TOOLONG"), $html->alert(JText::_("COM_JMYLIFE_ERROR_STORY_TOOLONG")).$captcha->reload());
			}
			$fulltext = $string->shorten($fulltext, $limit, false);
		}
		// check captcha
		if( !$this->checkcaptcha() )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_CAPTCHA_INVALID" ), $html->alert( JText::_( "COM_JMYLIFE_ERROR_CAPTCHA_INVALID" ) ).$captcha->reload() );
		}
		// check token
		if( !JRequest::checkToken() )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ), $html->alert( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) ).$captcha->reload() );
		}
		// setup query
		$query = JText::sprintf( 'INSERT INTO #__jmylife_stories ( '
			. '`catid`, `time`, `fulltext`, `published`, `user_id`, `user_alias`, `title`, `user_email` '
			. ') VALUES ( %s, %s, %s, %s, %s, %s, %s, %s )',
			$catid,
			$time,
			$_JMLConfig->db->quote( $fulltext ),
			$autopublish ? 1 : 0,
			$uid,
			$_JMLConfig->db->quote( $alias ),
			$_JMLConfig->db->quote( $title ),
			$_JMLConfig->db->quote( $email )
		);
		// set query
		$_JMLConfig->db->setQuery( $query );
		// run it!
		if( $_JMLConfig->db->query() )
		{
			$insertid = $_JMLConfig->db->insertid();
			// do some extra handling here jik
			if ( !in_array( $attach['type'], array( 'image', 'link', 'video' ) ) )
			{
				$attach['type'] = 'none';
			}
			// these should never be set directly via frontend so force blank
			$attach['extra'] = 0;
			$attach['uuid']  = '';
			// only bother if allowed
			if ($_JMLConfig->getBool('allow_storyattachment', false)) {
				// set image path
				$path = JPATH_JMYLIFEIMAGEFILES.DS;
				if ( !JFolder::exists( $path ) ) JFolder::create( $path );
				JLoader::import('components.com_jmylife.helpers.image', JPATH_ADMINISTRATOR, '');
				$iHelper = JmylifeImageHelper::getInstance();
				// handle attachments a little differently based on type
				switch ( $attach['type'] )
				{
					case 'link':
						// don't bother if url isn't using thumbs
						if ( 0 == intval( $attach['usethumb'] ) )
						{
							$attach['thumb'] = '';
							//$attach['url']   = '';
							$attach['uuid']  = '';
							$attach['extra'] = 1;
							break;
						}
						// quick sanity check
						if ( 0 == strlen( $attach['thumb'] ) ) break;
						// no description allowed!
						if (!$_JMLConfig->getBool('storylink_desc_allow', true)) {
							$attach['description'] = '';
						}
						// load thumb url from remote host
						$imagedata = JmylifeCommon::getRemoteData( $attach['thumb'], null );
						// set uuid based on original data
						$attach['uuid'] = md5( $imagedata );
						// we have data but don't know what it is :(
						// create a new tmp image named after session
						//$img = $path.JmylifeCommon::getSessionId();
						$img = $path.md5( $_SERVER['HTTP_USER_AGENT'] . $_SERVER['REMOTE_ADDR'] );
						JFile::write( $img, $imagedata );
						// make sure the file is a file ;)
						$ext = $iHelper->validate( $img );
						// if this is false delete the file & gtfo
						if ( false === $ext || !JmylifeCommon::resizeLinkAttachmentThumb( $img, $ext ) )
						{
							JFile::delete( $img );
							break;
						}
						// okay, everything checks out... rename image
						// not using JFile::move because it didn't seem to work?
						JFile::write( $path.'attachment_'.$insertid.'.'.$ext, JFile::read( $img ) );
						JFile::delete( $img );
						break;
					case 'image':
						// image currently doesn't use url (though maybe allowing posts to external urls later?) or thumb
						$attach['url'] = '';
						$attach['thumb'] = '';
						//$img = $path.JmylifeCommon::getSessionId();
						$img = $path.md5( $_SERVER['HTTP_USER_AGENT'] . $_SERVER['REMOTE_ADDR'] );
						// get data from image & set uuid
						$attach['uuid'] = md5( JFile::read( $img ) );
						// make sure the file is a file (this shouldn't change but wtfe
						$ext = $iHelper->validate( $img );
						// first handle resizing full image
						// if this is false delete the file & gtfo
						if ( false === $ext || !JmylifeCommon::resizeImageAttachment( $img, $ext ) )
						{
							JFile::delete( $img );
							break;
						}
						// okay, everything checks out... rename image
						// not using JFile::move because it didn't seem to work?
						JFile::write( $path.'attachment_'.$insertid.'_full.'.$ext, JFile::read( $img ) );
						// resize again for thumbnail
						JmylifeCommon::resizeImageAttachmentThumb( $img, $ext );
						// make thumbnail
						JFile::write( $path.'attachment_'.$insertid.'.'.$ext, JFile::read( $img ) );
						JFile::delete( $img );
						break;
					case 'video':
						break;
				}
				// build query for attachment
				if ( 'none' != $attach['type'] )
				{
					// build query
					$query = JText::sprintf(
						'INSERT INTO `#__jmylife_stories_attachments` (`sid`, `type`, `url`, `title`, `description`, `extra`, `uuid`) VALUES ( %s, %s, %s, %s, %s, %s, %s )',
						$insertid,
						$_JMLConfig->db->Quote( $attach['type'] ),
						$_JMLConfig->db->Quote( $attach['url'] ),
						$_JMLConfig->db->Quote( $string->shorten($attach['title'], $_JMLConfig->getInt('storylink_title_limit',0), false) ),
						$_JMLConfig->db->Quote( $string->shorten($attach['description'], $_JMLConfig->getInt('storylink_title_limit',0), false) ),
						$attach['extra'],
						$_JMLConfig->db->Quote( $attach['uuid'] )
					);
					// exec
					$_JMLConfig->db->setQuery( $query );
					$_JMLConfig->db->query();
				}
			}
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			// since 1.0.5 message is conditional based on moderation status
			$msg = JText::_( false === $autopublish ? 'COM_JMYLIFE_STORY_THANKSFORTHEMODERATEDSTORY' : 'COM_JMYLIFE_STORY_THANKSFORTHESTORY' );
			if ($_JMLConfig->getBool('email_enabled', false) && $_JMLConfig->getBool('notify_stories', false)) {
				$mailer->send(
					$_JMLConfig->get( 'email_to' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_SUBMISSIONBODY' ), $insertid ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_SUBMISSIONSUBJECT' ), $insertid ),
					true
				);
			}
			// since 1.0.9 notify users if their story has been approved
			if ($_JMLConfig->getBool('notify_author_stories', false) && strlen($email)) {
				if ($autopublish) {
					$mailer->authorPending( $insertid, $email );
				} else {
					$mailer->authorPublished( $insertid, $email );
				}
			}
			// since 1.0.9 users are subscribed to their stories
			// since this is a new story there's no need to check against the db (afaik)
			if ($_JMLConfig->getBool('notify_author_comments', false)) {
				$query = "INSERT INTO `#__jmylife_stories_subscriptions` ( `uid`, `sid` ) VALUES ( {$uid}, {$insertid} )";
				$_JMLConfig->db->setQuery( $query );
				$_JMLConfig->db->query();
			}
			// add to JomSocial activity stream, if enabled
			if ($autopublish && $_JMLConfig->allow->jomsocial) {
				// handle points
				$userpoints = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'userpoints.php';
				if( JFile::exists( $userpoints ) )
				{
					include_once( $userpoints );
					CuserPoints::assignPoint('jmylife.story.publish', $uid);
				}
				if ($_JMLConfig->getBool('jomsocial_activities_stories', false)) {
					if( $uid > 0 || $_JMLConfig->getBool('jomsocial_activities_stories_guest', false))
						JmylifeCommon::updateJomSocialActivity( 'story.published', $insertid, $uid );
				}
			}
		}
		else
		{
			$msg = JText::_( 'COM_JMYLIFE_ERROR_STORY_CANNOTSAVE' );
		}
		// make sure form redirects to the right place
		$formsubmit = '<script type="text/javascript">
//<!--
%s
// -->
</script>';
		// script is dependent on submitted form
		$form = JRequest::getWord('form');
		$formsubmitscript = 'alert("'.$msg.'");window.jml.jQuery(\'#'.$form.'\').empty();';
		// handle either module or jomsocial form
		if ($form == 'modJMyLifeSubmitForm' || 1 == JRequest::getInt('rawoutput')) {
			// module - empty & hide
			$formsubmitscript = 'alert("'.$msg.'");window.jml.jQuery(\'.modJMyLifeSubmitModule\').css({\'height\':\'0px\',\'overflow\':\'hidden\'}).empty().remove();';
			$goto = JRequest::getInt('goto',0);
			// for module redirection
			if ($goto > 0) {
				/*
			<option value="1">Core Redirection</option>
			<option value="2">Main Listing</option>
			<option value="3">Relevant Category</option>
			<option value="4">Posted Story *</option>
			*/
				JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
				$itemid = JmylifeItemidHelper::getInstance();
				$href = '';
				$timeoutCode = '';
				switch( $goto )
				{
					case 2:
						$timeoutCode = "window.location.href='".JRoute::_('index.php?option=com_jmylife&view=list&Itemid='.$itemid->category( $catid ) )."';";
						break;
					case 3:
						$timeoutCode = "window.location.href='".JRoute::_('index.php?option=com_jmylife&view=list&catid='.$catid.'&Itemid='.$itemid->category( $catid ) )."';";
						break;
				}
				if( $_JMLConfig->getInt( 'submissionredirect', 0 ) > 0 && 1 == $goto )
				{
					// get menu item href for redirect
					$_JMLConfig->db->setQuery( 'SELECT `link` FROM `#__menu` WHERE `id` = '.$_JMLConfig->getInt( 'submissionredirect' ), 0, 1 );
					// fixed in 1.0.11 to append Itemid & run through JRoute
					if( !( $link = $_JMLConfig->db->loadResult() ) ) $link = JURI::base();
					else $link .= ( preg_match( '`\?`', $link ) ? '&' : '?' ) . 'Itemid='.$_JMLConfig->getInt( 'submissionredirect' );
					$link = JRoute::_( $link, false );
					$timeoutCode = "window.location.href='$link';";
				}
				if( $autopublish && 4 == $goto && 0 < $insertid )
				{
					// story won't have its own itemid!
					$timeoutCode = "window.location.href='".JRoute::_('index.php?option=com_jmylife&view=item&id='.$insertid.'&Itemid='.$itemid->category( $catid ) )."';";
				}
				$formsubmitscript .= 'setTimeout( "'.$timeoutCode.'", 1000 );';
			}
			// for jomsocial/cb form
			if( 1 == JRequest::getInt( 'rawoutput' ) )
			{
				$formsubmitscript .= 'try{top.cWindowHide();}catch(err){top.window.jml.jQuery.nyroModalRemove();}';
			}
			// don't "handle" message in this case - instead return
			die( JText::sprintf( $formsubmit, $formsubmitscript ) );
		}
		else
		{
			$timeoutCode = "window.location.href='".JURI::base()."';";
			if( $_JMLConfig->getInt( 'submissionredirect', 0 ) > 0 )
			{
				// get menu item href for redirect
				$_JMLConfig->db->setQuery( 'SELECT `link` FROM `#__menu` WHERE `id` = '.$_JMLConfig->getInt( 'submissionredirect' ), 0, 1 );
				// fixed in 1.0.11 to append Itemid & run through JRoute
				if( !( $link = $_JMLConfig->db->loadResult() ) ) $link = JURI::base();
				else $link .= ( preg_match( '`\?`', $link ) ? '&' : '?' ) . 'Itemid='.$_JMLConfig->getInt( 'submissionredirect' );
				$link = JRoute::_( $link, false );
				$timeoutCode = "window.location.href='$link';";
			}
			$formsubmitscript .= 'setTimeout( "'.$timeoutCode.'", 1000 );';
		}
		$formsubmit = JText::sprintf( $formsubmit, $formsubmitscript );
		// end
		$this->handlemessage( $msg, $formsubmit );
	}

	/**
	 * Method to save a comment
	 *
	 * @access    public
	 */
	function addcomment()
	{
		// check token
		if (!JRequest::checkToken()) {
			$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_INVALID_TOKEN"));
		}
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if (!$_JMLConfig->getInt('allow_comments',1)) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_COMMENT_NOTALLOWED'));
		}
		if (0 != $_JMLConfig->getInt('comment_engine',0)) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_COMMENT_COREDISABLED'));
		}
		// get user
		$user =& JFactory::getUser();
		$uid  =  $user->id;
		// is ajax?
		$ajax = JRequest::getInt('ajax');
		// only users can comment, sorry!
		if ($user->guest) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_COMMENT_NOGUEST'));
		}
		// insert params
		$sid = JRequest::getInt('sid');
		if (0 >= $sid) {
			$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_STORY_NOID"));
		}
		// no longer quoted in declaration - 1.0.9 email notification bugfix
		$fulltext = JRequest::getString('comment');
		// check that $fulltext has contents
		if (0 == strlen($fulltext)) {
			$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_COMMENT_BLANK"));
		}
		// leave in case we expand comments to anon
		// why does this matter? no need to tempt the voodoo gods now...
		$alias = strlen($user->name) ? $user->name : 'Anonymous';
		// setup query
		$query = 'INSERT INTO #__jmylife_comments ( '
		       . '`sid`, `message`, `author`, `author_id`, `time`, `published` '
		       . ') VALUES ( '
		       . $sid.', '.$_JMLConfig->db->quote( $fulltext ).', '.$_JMLConfig->db->quote( $alias ).', '.$uid.', '.time().', '.$_JMLConfig->getInt('autopublish_comments',0).' '
		       . ')'
		;
		// set query
		$_JMLConfig->db->setQuery( $query );
		// run it!
		if ($_JMLConfig->db->query()) {
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$cid = $_JMLConfig->db->insertid();
			$autopublish = (bool)$_JMLConfig->getInt('autopublish_comments',0);
			$msg = JText::_( $autopublish ? 'COM_JMYLIFE_COMMENT_THANKSFORTHECOMMENT' : 'COM_JMYLIFE_COMMENT_THANKSFORTHEMODERATEDCOMMENT' );
			// send email to admin
			if ($_JMLConfig->getInt('email_enabled', 0) && $_JMLConfig->getInt('notify_comments', 0)) {
				JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
				$string = JmylifeStringHelper::getInstance();
				// save myself the ctrl+c/ctrl+v action *wink to Bill*
				$mailer->send(
					$_JMLConfig->get( 'email_to' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_COMMENTBODY' ), $cid, 'comment' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_COMMENTSUBJECT' ), $cid, 'comment' ),
					true
				);
			}
			if ($autopublish) {
				// send email to subscribers
				$mailer->commentSubscribers($cid);
				// subscribe commenter to this story, if needed ;)
				$query = "SELECT `id` FROM `#__jmylife_stories_subscriptions` WHERE `uid` = {$uid} AND `sid` = {$sid}";
				$_JMLConfig->db->setQuery($query);
				if (1 > intval($_JMLConfig->db->loadResult())) {
					$query = "INSERT INTO `#__jmylife_stories_subscriptions` ( `uid`, `sid` ) VALUES ( {$uid}, {$sid} )";
					$_JMLConfig->db->setQuery( $query );
					$_JMLConfig->db->query();
				}
				if ($_JMLConfig->allow->jomsocial) {
					// handle points
					$userpoints = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'userpoints.php';
					if (JFile::exists($userpoints)) {
						include_once ($userpoints);
						CuserPoints::assignPoint('jmylife.comment.publish', $uid);
					}
					// add to JomSocial activity stream, if enabled
					if ($_JMLConfig->getInt('jomsocial_activities_comments',0)) {
						JmylifeCommon::updateJomSocialActivity('comment.published', $cid, $uid);
					}
				}
			}
		} else {
			$msg = JText::_( 'COM_JMYLIFE_ERROR_COMMENT_CANNOTSAVE' );
		}
		$formsubmit = '';
		// if we're autoposting comments, reload the page...
		if ($autopublish) {
			// handle redirection manually here (lame)...
			// TODO: load up an individual comment template
			$formsubmit = '<script type="text/javascript">
//<!--
	window.jml.jQuery(\'#'.JRequest::getString('form').'\').empty();
	setTimeout( "window.location.reload();", 1000 );
// -->
</script>';
		}
		// end
		$this->handlemessage( $msg, $html->alert( $msg ).$formsubmit );
		// end
		$this->handlemessage( $msg );
	}

	/**
	 * Method to display captcha
	 *
	 * @access    public
	 */
	function displaycaptcha()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$appl = JFactory::getApplication();
		$document =& JFactory::getDocument();
		$doc =& JDocument::getInstance('raw');
		// Swap the objects
		$document = $doc;
		// only show these engines, otherwise return nothing
		if( in_array( $_JMLConfig->getInt( 'captcha_engine', 0 ), array( 2 ) ) )
		{
			$appl->triggerEvent( 'onCaptcha_display', array() );
		}
	}

	/**
	 * Method to show reCAPTCHA in its own page
	 * done to work around JomComment's own use of reCAPTCHA
	 *
	 * @access    public
	 * @since     1.0.13
	 */
	function recaptcha()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// make sure recaptcha is the configured engine
		$engine = $_JMLConfig->getInt( 'captcha_engine', 0 );
		if ( 1 != $engine ) die();
		// get public key
		$publickey = $_JMLConfig->get( 'recaptcha_public_key', '' );
		if ( '' == $publickey ) die();
		// get theme
		$theme = $_JMLConfig->get('recaptcha_theme','red');

		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$url = JmylifeUrlHelper::getInstance();
		// render iframe contents
		?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="en-gb" xml:lang="en-gb">
<head>
	<style type="text/css">
		body { margin: 0px; padding: 0px; }
	</style>
	<script type="text/javascript" src="<?php
		echo $url->clean(JURI::root().'/components/com_jmylife/libraries/jquery/jquery-1.4.2.min.js');
	?>"></script>
	<script type="text/javascript" src="http://api.recaptcha.net/js/recaptcha_ajax.js"></script>
	<script type="text/javascript">
	// <!--
		(function($){
			$(document).ready( function(){
				// make sure page is within an iframe
				if ( parent.location == location ) return false;
				// create captcha
				Recaptcha.create( '<?php echo $publickey; ?>', 'recaptcha_div', { theme: '<?php echo $theme; ?>' });
				// this is done via a timeout to give Recaptcha.create() time to render the captcha
				setTimeout(function(){
					// set iframe sizing object
					var _size = {
						w: $('#recaptcha_area').width(),
						h: $('#recaptcha_area').height()
					};
					// make sure sizes are greater than 0
					if ( 0 >= _size.w ) { _size.w = 320; }
					if ( 0 >= _size.h ) { _size.h = 150; }
					// resize iframe
					$(parent.document.getElementById('comJMyLifeRecaptchaIframe')).width( _size.w ).height( _size.h );
					// apply change event to add captcha value to main form
					var _field = $('#recaptcha_response_field').change(function()
					{
						$(parent.document.getElementById('jml_recaptcha_response_field')).val( $(this).val() );
						$(parent.document.getElementById('jml_recaptcha_challenge_field')).val( $('#recaptcha_challenge_field').val() );
					});
				}, 500);
			});
		})(jQuery);
	// -->
	</script>
</head>
<body>
	<div id="recaptcha_div"></div>
</body>
</html><?php
		// just die so nothing else is shown
		die();
	}

	/**
	 * Method to check captcha
	 *
	 * @access    public
	 */
	function checkcaptcha()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		switch( $_JMLConfig->getInt( 'captcha_engine', 0 ) )
		{
			case 1: // reCAPTCHA
				$privatekey = $_JMLConfig->get( 'recaptcha_private_key' );
				$challenge = JRequest::getVar( "recaptcha_challenge_field" );
				$response  = JRequest::getVar( "recaptcha_response_field" );
				$resp = jml_recaptcha_check_answer( $privatekey, $_SERVER["REMOTE_ADDR"], $challenge, $response );
				return $resp->is_valid;
				break;
			case 2: // Bigo
				$return = false;
				$word = JRequest::getVar( 'word', false, '', 'CMD' );
				$appl =& JFactory::getApplication();
				$appl->triggerEvent( 'onCaptcha_confirm', array( $word, &$return ) );
				return $return;
				break;
			case 3: // captchas.net
				JLoader::import('components.com_jmylife.helpers.captcha', JPATH_ADMINISTRATOR, '');
				$captcha = JmylifeCaptchaHelper::getInstance();
				$captchas = $captcha->captchasnet();
				return ( $captchas && $captchas->validate( JRequest::getString( 'random' ) ) && $captchas->verify( JRequest::getString( 'password' ) ) );
				break;
			default:
				return true;
				break;
		}
		return true;
	}

	/**
	 * Methods to count votes
	 *
	 * @access    public
	 */
	function countvotes( $id, $dir )
	{
		// $dir will only be '1' or '2' so error on any others (not needed?)
		if( $dir != '1' && $dir != '2' )
		{
			JError::raiseError( 500, JText::_( "COM_JMYLIFE_ERROR_VOTING_BADINPUT" ) );
		}
		// set up database
		$database =& JFactory::getDBO();
		$query = 'SELECT `votes'.$dir.'` FROM `#__jmylife_stories` WHERE `id` = '.$id;
		$database->setQuery( $query );
		if( !( $result = $database->loadResult() ) )
		{
			// since 1.0.9 just return a 0
			return 0;
		}
		return intval( $result );
	}

	/**
	 * Methods to save votes
	 *
	 * @access    public
	 */
	function votegood()
	{
		$this->vote( '1' );
	}
	function votebad()
	{
		$this->vote( '2' );
	}
	function vote( $dir )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if( $_JMLConfig->getInt('allow_votes') == 0 )
		{
			$this->handlemessage( JText::_( 'COM_JMYLIFE_ERROR_VOTING_DISABLED' ) );
			exit();
		}
		// $dir will only be '1' or '2' so error on any others (not needed?)
		if( $dir != '1' && $dir != '2' )
		{
			$this->handlemessage( JText::_( 'COM_JMYLIFE_ERROR_VOTING_BADINPUT' ) );
			exit();
		}
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// get user
		$user =& JFactory::getUser();
		// guest vote check
		if ($user->guest && 0 == $_JMLConfig->getInt('allow_votes_guests', 1)) {
			$this->handlemessage( JText::_( 'COM_JMYLIFE_ERROR_VOTING_NOGUEST' ) );
			exit();
		}
		// vote params
		$sid = intval( JRequest::getInt( 'sid' ) );
		// check story id
		if( $sid <= 0 )
		{
			JError::raiseError( 404, JText::_( "COM_JMYLIFE_ERROR_STORY_NOID" ) );
		}
		// check token
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
			exit();
		}

		// update vote table so each person can only vote once
		// TODO: possibly match something else to allow for widespread use without abuse
		//       cookies are a possibility, but not something I'm a fan of...

		// first we gotta check
		// block_votes_by_ip added in 1.0.13 due to user request
		// if true, instead check cookies (ew)

		$allowVote = true;
		$ip = $_JMLConfig->db->quote( long2ip( ip2long( $_SERVER['REMOTE_ADDR'] ) ) );
		if (1 == $_JMLConfig->getInt('block_votes_by_ip', 1)) {
			// first we gotta check
			$query = 'SELECT `ip` FROM `#__jmylife_votes` WHERE `ip` = '.$ip.' AND `sid` = '.$sid;//.' AND `uid` = '.$user->id;
			// set query
			$_JMLConfig->db->setQuery($query);
			$votedIp = $_JMLConfig->db->loadObjectList();
			if (!empty($votedIp)) {
				$allowVote = false;
			}
		} else {
			// check cookie
			if (isset($_COOKIE["JmlVote{$sid}"])) {
				$allowVote = false;
			}
			setcookie("JmlVote{$sid}", 1);
		}
		// check number of rows found
		if( $allowVote )
		{
			// record vote
			$query = 'INSERT INTO `#__jmylife_votes` ( `ip`, `sid`, `uid` ) VALUES ( '.$ip.', '.$sid.', '.$user->id.' )';
			$_JMLConfig->db->Execute( $query );
			// update vote counter
			$query = 'UPDATE `#__jmylife_stories` SET votes'.$dir.' = votes'.$dir.'+1 WHERE id='.$sid;
			$_JMLConfig->db->Execute( $query );
		}
		else
		{
			$count = $this->countvotes( $sid, $dir );
			$graphicResponse = array( 'success' => false, 'msg' => JText::_( 'COM_JMYLIFE_ERROR_VOTING_ALREADYVOTED' ), 'count' => $count );
			$this->handlemessage( JText::_( 'COM_JMYLIFE_ERROR_VOTING_ALREADYVOTED' ), $_JMLConfig->getInt( 'graphical_voting', 0 ) == 1 ? json_encode( $graphicResponse ) : JText::_( 'COM_JMYLIFE_ERROR_VOTING_ALREADYVOTED' ).' ('.$count.')' );
		}
		// end
		$count = $this->countvotes( $sid, $dir );
		$msg = JText::_( 'COM_JMYLIFE_ERROR_YOUSHOULDNEVERSEETHIS' );
		// text changed to use database config since 1.0.4, still use lang file fallback
		if( $dir == '1' )
		{
			$responseText = $_JMLConfig->get('votegoodresponse_text');
			$msg = strlen( $responseText ) > 0 ? $responseText : JText::_( 'COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEGOODRESPONSE' );
		}
		else if( $dir == '2' )
		{
			$responseText = $_JMLConfig->get('votebadresponse_text');
			$msg = strlen( $responseText ) > 0 ? $responseText : JText::_( 'COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEBADRESPONSE' );
		}
		$graphicResponse = array( 'success' => true, 'msg' => $msg, 'count' => $count );
		$this->handlemessage( $msg, $_JMLConfig->getInt( 'graphical_voting', 0 ) == 1 ? json_encode( $graphicResponse ) : $msg.' ('.$count.')' );
	}

	/**
	 * Methods to add item to favorites
	 *
	 * @access    public
	 */
	function favorite()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$id = JRequest::getInt( 'sid' );
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// set initial return text
		$return = JText::_( 'COM_JMYLIFE_ERROR_STORY_ALREADYFAVORITE' );
		// get user
		$user =& JFactory::getUser();
		$uid = intval( $user->id );
		if( $user->guest )
		{
			JError::raiseError( 500, JText::_( 'COM_JMYLIFE_ERROR_STORY_NOGUESTFAVORITE' ) );
		}
		// check token
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
		}
		// set up database
		$database =& JFactory::getDBO();
		$query = 'SELECT `id` FROM `#__jmylife_favorites` WHERE `uid` = '.$uid.' AND `sid` = '.$id;
		$database->setQuery( $query );
		if( !( $result = $database->loadResult() ) )
		{
			$query = 'INSERT INTO `#__jmylife_favorites` ( `uid`, `sid` ) VALUES ( '.$uid.', '.$id.' )';
			$database->setQuery( $query );
			$database->query();
			$return = JText::_( 'COM_JMYLIFE_STORY_FAVORITEADDED' );
		}
		// add to JomSocial activity stream, if enabled
		if( $_JMLConfig->getInt('jomsocial_activities_favorites',0) && $_JMLConfig->allow->jomsocial )
		{
			JmylifeCommon::updateJomSocialActivity( 'favorite.added', $id, $uid );
		}
		$this->handlemessage( $return );
	}
	function unfavorite()
	{
		$id = JRequest::getInt( 'sid' );
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// set initial return text
		$return = JText::_( 'COM_JMYLIFE_ERROR_STORY_NOTAFAVORITE' );
		// get user
		$user =& JFactory::getUser();
		if( $user->guest )
		{
			JError::raiseError( 500, JText::_( 'COM_JMYLIFE_ERROR_STORY_NOGUESTFAVORITE' ) );
		}
		// check token
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
		}
		// set up database
		$database =& JFactory::getDBO();
		$query = 'SELECT `id` FROM `#__jmylife_favorites` WHERE `uid` = '.intval( $user->id ).' AND `sid` = '.intval( $id );
		$database->setQuery( $query );
		if( $result = $database->loadResult() )
		{
			$query = 'DELETE FROM `#__jmylife_favorites` WHERE `uid` = '.intval( $user->id ).' AND `sid` = '.intval( $id ).' ';
			$database->setQuery( $query );
			$database->query();
			$return = JText::_( 'COM_JMYLIFE_STORY_FAVORITEREMOVED' );
		}
		$this->handlemessage( $return );
	}


	/**
	 * Methods to report comments
	 *
	 * @access    public
	 */
	function report()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$user =& JFactory::getUser();
		$id = JRequest::getInt( 'cid' );
		// check token
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
		}
		// first we gotta check
		$ip = $_JMLConfig->db->quote( long2ip( ip2long( $_SERVER['REMOTE_ADDR'] ) ) );
		$query = 'SELECT `ip` FROM `#__jmylife_comments_warnings` WHERE `ip` = '.$ip.' AND `cid` = '.$id.' AND `uid` = '.$user->id;
		// set query
		$_JMLConfig->db->setQuery( $query );
		// run it
		$_JMLConfig->db->query();
		// check number of rows found
		if( $_JMLConfig->db->getNumRows() == 0 )
		{
			$query = 'INSERT INTO `#__jmylife_comments_warnings` ( `ip`, `cid`, `uid` ) VALUES ( '.$ip.', '.$id.', '.$user->id.' )';
			// set query
			$_JMLConfig->db->setQuery( $query );
			// run it
			$_JMLConfig->db->query();
			// notify, if set
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$string = JmylifeStringHelper::getInstance();
			if( $_JMLConfig->getInt('notify_any_warning') != 0 && $_JMLConfig->getInt( 'email_enabled' ) == 1 )
			{
				$mailer->send(
					$_JMLConfig->get( 'email_to' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_WARNANYBODY' ), $id, 'comment' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_WARNANYSUBJECT' ), $id, 'comment' ),
					true
				);
			}
			// check count and alert if needed...
			if( $_JMLConfig->getInt('notify_warning') != 0 )
			{
				$query = 'SELECT COUNT(ip) AS c FROM `#__jmylife_comments_warnings` WHERE `cid` = '.$id;
				$_JMLConfig->db->setQuery( $query );
				if( $count = $_JMLConfig->db->loadResult() )
				{
					if( $_JMLConfig->getInt( 'email_enabled' ) == 1 && (int)$count == $_JMLConfig->getInt('warning_level') )
					{
						// common lib ;)
						$mailer->send(
							$_JMLConfig->get( 'email_to' ),
							$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_WARNLEVELBODY' ), $id ),
							$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_WARNLEVELSUBJECT' ), $id ),
							true
						);
					}
				}
			}
			// update vote counter
			$this->handlemessage( JText::_( 'COM_JMYLIFE_COMMENT_THANKSFORTHEWARNING' ) );
		}
		else
		{
			$this->handlemessage( JText::_( 'COM_JMYLIFE_COMMENT_ALREADYREPORTED' ) );
		}
	}


	/**
	 * Methods to report comments
	 *
	 * @access    public
	 * @since     1.0.10
	 */
	function reportstory() {
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$story = JmylifeStoryHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$sid = JRequest::getInt('sid');
		// die if story id is 0
		if (0 >= $sid) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_NOID'));
		}
		// get story contents
		$_JMLConfig->db->setQuery($story->buildQuery(array('view' => 'item', 'id' => $sid)));
		// die if story cannot be found
		if (!($item = $_JMLConfig->db->loadObject())) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_NOID'));
		}
		$item = $story->prepare($item, 'item');
		if (0 == (int)$item->reported) {
			$this->handlemessage(JText::_('COM_JMYLIFE_STORY_ALREADYREPORTED'));
		}
		if ($_JMLConfig->getInt('email_enabled', 0) && strlen($_JMLConfig->get('email_to'))) {
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$string = JmylifeStringHelper::getInstance();
			// send mail
			$mailer->send(
				$_JMLConfig->get('email_to'),
				$string->stubs(JText::_('COM_JMYLIFE_MAIL_ADMIN_REPORTSTORYBODY'), $sid),
				$string->stubs(JText::_('COM_JMYLIFE_MAIL_ADMIN_REPORTSTORYSUBJECT'), $sid),
				true
			);
		}
		$_JMLConfig->db->setQuery('UPDATE `#__jmylife_stories` SET `reported` = 1 WHERE `id`='.$item->id);
		$_JMLConfig->db->query();
		$this->handlemessage(JText::_('COM_JMYLIFE_STORY_REPORTED'));
	}

	/**
	 * Method to return a comment
	 *
	 * @access    public
	 * @since     1.0.4
	 */
	function getcomment()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$id = JRequest::getInt( 'id' );
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
		}
		// var init
		$join = '';
		$group = '';
		$fields = array( 'c.*' );
		if( $_JMLConfig->getInt( 'show_comment_avatar', 0 ) == 1 )
		{
			// check for community builder support
			if( $_JMLConfig->allow->cb )
			{
				// add extra fields
				$fields[] = 'cb.`avatar` AS avatar';
				// change query to join
				$join.= 'LEFT JOIN `#__comprofiler` AS cb'
					. ' ON ( c.`author_id` = cb.`user_id` ) '
					;
				$group = 'GROUP BY c.`id` ';
			}
			// jomsocial support
			else if( $_JMLConfig->allow->jomsocial )
			{
				// add extra fields
				$fields[] = 'js.`thumb` AS avatar';
				// change query to join
				$join.= 'LEFT JOIN `#__community_users` AS js'
					. ' ON ( c.`author_id` = js.`userid` ) '
					;
				$group = 'GROUP BY c.`id` ';
			}
		}

		// build query
		$query = 'SELECT '
		       . implode( ', ', $fields ).' '
		       . 'FROM `#__jmylife_comments` AS c '
		       . $join
		       . 'WHERE c.`id`='.$id.' AND c.`published`=1 '
		       . $group
		       ;
		$_JMLConfig->db->setQuery( $query );
		$comment = $_JMLConfig->db->loadObject();
		if( count( $comment ) == 0 )
		{
			$comment = new stdClass();
			$comment->message = JText::_('COM_JMYLIFE_ERROR_COMMENT_NOTFOUND');
			$comment->id = 0;
			$comment->time = 0;
			$comment->author = '';
			$comment->author_id = 0;
		}
		die( json_encode( $comment ) );
	}

	/**
	 * function getlatestcomments()
	 * @since   1.0.10
	 */
	function getlatestcomments()
	{
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$comment = JmylifeCommentHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$output = '';
		$query = $comment->buildQuery( JRequest::getInt( 'id' ) ).' LIMIT '.$_JMLConfig->getInt( 'comment_balloon_count', 5 );
		$_JMLConfig->db->setQuery( $query );
		if( $rows = $_JMLConfig->db->loadObjectList() )
		{
			$rows = $comment->prepareList( $rows );
			if( count( $rows ) )
			{
				JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
				$string = JmylifeStringHelper::getInstance();
				foreach( $rows as $row )
				{
					$output .= '<p class="jmylifeBalloonItem">'
					        .  $string->shorten( $row->message, $_JMLConfig->getInt( 'comment_balloon_length', 200 ), false )
					        .  '</p>'
					        ;
				}
			}
		}
		$output .= '<div class="jmylifeBalloonFooter">'.JText::_('COM_JMYLIFE_COMMENT_CLICKTOCOMMENT').'</div>';
		die( $output );
	}

	/**
	 * function moderatestory
	 * @since   1.0.11
	 */
	function moderatestory()
	{
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$story = JmylifeStoryHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$nobuttons = '<script type="text/javascript">window.jml.jQuery(\'.jmlModButton\').hide();</script>';
		$appl =& JFactory::getApplication();
		// redirect if ajax isn't being used (they shouldn't get this far otherwise)
		if( JRequest::getInt( 'ajax' ) != 1 )
		{
			$appl->enqueuemessage( JText::_( 'COM_JMYLIFE_ERROR_MODERATION_NEEDSJS' ) );
			$appl->redirect( $_SERVER['HTTP_REFERER'] );
		}
		// die if moderation is disabled
		if( $_JMLConfig->getInt( 'allow_user_moderation', 0 ) == 0 ) die( JText::_('COM_JMYLIFE_ERROR_MODERATION_NOUSER').$nobuttons );
		// die if guest moderation is disabled and user is guest
		$user =& JFactory::getUser();
		if( $user->guest && $_JMLConfig->getInt( 'allow_guest_moderation', 0 ) == 0 ) die( JText::_('COM_JMYLIFE_ERROR_MODERATION_NOGUEST').$nobuttons );
		// check if story is being voted on
		$sid = JRequest::getInt( 'sid', 0 );
		$mod = JRequest::getWord( 'vote', '' );
		$report = JRequest::getInt( 'report', 0 );
		if( $sid != 0 )
		{
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$string = JmylifeStringHelper::getInstance();
			if( $report > 0 )
			{
				// check "reported" status
				$query = 'UPDATE `#__jmylife_stories` SET `reported` = 1 WHERE `reported` = 0 AND `id`='.$sid;
				$_JMLConfig->db->setQuery( $query );
				$_JMLConfig->db->query( $query );
				if( $_JMLConfig->db->getAffectedRows() )
				{
					if( $_JMLConfig->getInt( 'moderate_notify' ) == 1 && $_JMLConfig->getInt( 'email_enabled' ) == 1 && strlen( $_JMLConfig->get( 'email_to' ) ) > 0 )
					{
						$mailer->send(
							$_JMLConfig->get( 'email_to' ),
							$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_REPORTSTORYBODY' ), $sid ),
							$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_REPORTSTORYSUBJECT' ), $sid ),
							true
						);
					}
				}
			}
			// handle vote
			else if( $mod == 'modyes' || $mod == 'modno' )
			{
				// set dir
				$dir = $mod == 'modyes' ? 1 : 2;
				// first we gotta check
				$ip = $_JMLConfig->db->quote( long2ip( ip2long( $_SERVER['REMOTE_ADDR'] ) ) );
				$query = 'SELECT `ip` FROM `#__jmylife_moderate` WHERE `ip` = '.$ip.' AND `sid` = '.$sid;//.' AND `uid` = '.$user->id;
				// set query
				$_JMLConfig->db->setQuery( $query );
				// run it
				$_JMLConfig->db->query();
				// check number of rows found
				// only bother doing anything here if a user hasn't already voted on this one...
				if( $_JMLConfig->db->getNumRows() == 0 )
				{
					$query = 'INSERT INTO `#__jmylife_moderate` ( `ip`, `sid`, `uid` ) VALUES ( '.$ip.', '.$sid.', '.$user->id.' )';
					// set query
					$_JMLConfig->db->setQuery( $query );
					// run it
					$_JMLConfig->db->query();
					// update vote counter
					$query = 'UPDATE `#__jmylife_stories` SET moderate'.$dir.' = moderate'.$dir.'+1 WHERE id='.$sid;
					// set query
					$_JMLConfig->db->setQuery( $query );
					// run it!
					$_JMLConfig->db->query();
					// verify if a story has the exact number of votes needed to trigger an action
					$query = 'SELECT COUNT(`ip`) FROM `#__jmylife_moderate` WHERE `sid` = '.$sid;
					$_JMLConfig->db->setQuery( $query );
					if( intval( $_JMLConfig->db->loadResult() ) == $_JMLConfig->getInt( 'moderate_limit' ) && 1 == $dir )
					{
						$publishedEmail = JText::_( 'COM_JMYLIFE_MAIL_ADMIN_MODERATELIMITBODY' );
						// publish story
						if( $_JMLConfig->getInt( 'moderate_publish_on_limit' ) == 1 )
						{
							$query = 'UPDATE `#__jmylife_stories` SET `moderate1`=0, `moderate2`=0, `published`=1 WHERE id='.$sid;
							$_JMLConfig->db->setQuery( $query );
							$_JMLConfig->db->query();
							$query = 'DELETE FROM `#__jmylife_moderate` WHERE sid='.$sid;
							$_JMLConfig->db->setQuery( $query );
							$_JMLConfig->db->query();
							$publishedEmail = JText::_( 'COM_JMYLIFE_MAIL_ADMIN_MODERATELIMITPUBLISHEDBODY' );
						}
						// notify
						if( $_JMLConfig->getInt( 'moderate_notify' ) == 1 && $_JMLConfig->getInt( 'email_enabled' ) == 1 && strlen( $_JMLConfig->get( 'email_to' ) ) > 0 )
						{
							$mailer->send(
								$_JMLConfig->get( 'email_to' ),
								$string->stubs( $publishedEmail, $sid ),
								$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_MODERATELIMITSUBJECT' ), $sid ),
								true
							);
						}
						if( $_JMLConfig->allow->jomsocial )
						{
							$query = 'SELECT `user_id` FROM `#__jmylife_stories` WHERE `id` = '.$sid;
							$_JMLConfig->db->setQuery( $query );
							if( $uid = $_JMLConfig->db->loadResult() )
							{
								// handle points
								$userpoints = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'userpoints.php';
								if( JFile::exists( $userpoints ) )
								{
									include_once( $userpoints );
									CuserPoints::assignPoint('jmylife.story.publish', $uid);
								}
								// add to JomSocial activity stream, if enabled
								if( $_JMLConfig->getInt('jomsocial_activities_stories',0) )
								{
										if( $uid > 0 || $_JMLConfig->getInt('jomsocial_activities_stories_guest',0) )
											JmylifeCommon::updateJomSocialActivity( 'story.published', $sid, $uid );
								}
							}
						}
					}
				}
			}
		}
		// return new story
		$query = $story->buildQuery( array( 'view' => 'item', 'random' => 1, 'id' => 0 ), 0, 1 );
		$_JMLConfig->db->setQuery( $query );
		if( $row = $_JMLConfig->db->loadObject() ) :
			$row = $story->prepare( $row, 'item' );
			// build output
			die('<div class="jmlModStory">'.$row->fulltext.'</div><div class="jmlModFooter"><div class="jmlModInfo">'.$row->format_date.' '.$row->format_time.' - '.$row->catname.'</div><div class="jmlModReport"'.( $_JMLConfig->getInt('moderate_reportlink', 1 ) == 1 ? '' : ' style="display:none;"' ).'><a class="report_link" href="javascript:void(0);" onclick="return (function(){document.getElementById(\'jmylifeModerateReport\').value=1;window.jmlModeratingFunction();return false;})();">'.JText::_('COM_JMYLIFE_STORY_MODERATE_REPORT').'</a></div><div class="jmlClear">&nbsp;</div></div><input type="hidden" id="jmylifeModerateReport" name="report" value="0"/><script type="text/javascript">document.getElementById(\'jmylifeModerateID\').value="'.$row->id.'";</script>');
		else:
			die( JText::_('COM_JMYLIFE_ERROR_MODERATION_NOSTORIES').$nobuttons );
		endif;
	}

	/**
	 * function unsubscribe
	 * @since   1.0.9
	 */
	function unsubscribe()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$user =& JFactory::getUser();
		$uid  =  $user->id;
		$sid  = JRequest::getInt( 'sid' );
		// hmm, guests shouldn't be able to unsubscribe
		if( $user->guest )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_STORY_GUESTNOTSUBSCRIBED" ) );
		}
		// check token
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
		}
		// just blindly delete based on user id ;)
		$query = "DELETE FROM `#__jmylife_stories_subscriptions` WHERE uid = {$uid} AND sid = {$sid}";
		$_JMLConfig->db->setQuery( $query );
		if( $_JMLConfig->db->query() )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_STORY_UNSUBSCRIBESUCCESS" ) );
		}
		else
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_STORY_UNSUBSCRIBE" ) );
		}
	}

	/**
	 * function emailfriend
	 * @since   1.0.9
	 */
	function emailfriend()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$user  =& JFactory::getUser();
		$id    =  JRequest::getInt( 'id', 0 );
		$email =  JRequest::getString( 'email' );
		// some checks first...
		if( $id == 0 ) die( JText::_('COM_JMYLIFE_ERROR_STORY_NOID') );
		if( JRequest::getInt( 'ajax' ) != 1 ) $this->handlemessage( JText::_('COM_JMYLIFE_ERROR_STORY_SENDTOFRIEND_JS') );
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		if (0 == strlen(trim($email))) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_SENDTOFRIEND_JS'), $html->link('#', JText::_('COM_JMYLIFE_ERROR_STORY_SENDTOFRIEND_NOEMAIL'), array('class' => 'sendfriend_link')));
		}
		// try to send email
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$mailer = JmylifeEmailHelper::getInstance();
		$string = JmylifeStringHelper::getInstance();
		$mailer->send(
			$email,
			$string->stubs( $_JMLConfig->get('emailtext_sendfriend_body'), $id ),
			$string->stubs( $_JMLConfig->get('emailtext_sendfriend_subject'), $id ),
			true
		);
		die($html->link('#', JText::_('COM_JMYLIFE_STORY_SENDTOFRIENDSUCCESS'), array('class' => 'sendfriend_link')));
	}

	/**
	 * jQuery
	 */
	function jQuery() {
		header("Content-type: text/javascript");
		// defensive coding - jml libs should access window.jml.jQuery
		// this is so jml has its own jQuery, apart from everyone else's
		// hopefully, this prevents any kind of conflict anywhere
		echo <<<EOF
var oldQuery=false;
if ('undefined'!=typeof jQuery){
	oldQuery = jQuery;
}
EOF;
		echo @file_get_contents(JPATH_JMYLIFELIBS.DS.'jquery'.DS.'jquery-1.4.2.min.js')."\n";
		echo @file_get_contents(JPATH_JMYLIFELIBS.DS.'jquery'.DS.'jquery.noconflict.js')."\n";
		echo <<<EOF
if (oldQuery){
	jQuery = oldQuery;
}
EOF;
		echo "window.jml.root = '".JURI::root(false)."';\n";
		die();
	}

	/**
	 * function wysiwyg
	 * @since   1.0.11
	 */
	function wysiwyg() {
		$cfg = JmylifeConfiguration::getInstance();
		// TODO
		header( 'Content-type: text/javascript' );
		// add global vars
		echo "window.jmlWYSIWYGdata = {\n";
		echo "\tjq      : ( typeof window.jml.jQuery != \"undefined\" ),\n";
		echo "\tpath    : \"".JURI::base().'components/com_jmylife/libraries/wysiwyg/'."\",\n";
		echo "\tlinks   : ".$cfg->get( 'wysiwyg_links',  1 ).",\n";
		echo "\timages  : ".$cfg->get( 'wysiwyg_images', 1 ).",\n";
		echo "\tlist    : ".$cfg->get( 'wysiwyg_list',   1 ).",\n";
		echo "\tcolor   : ".$cfg->get( 'wysiwyg_color',  1 ).",\n";
		// language strings
		echo "\tstrings : {\n";
		echo "\t\tenterimageurl : \"".JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_IMAGEURL')."\",\n";
		echo "\t\tenterlinkurl  : \"".JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_LINKURL')."\",\n";
		echo "\t\tenterlinktext : \"".JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_LINKTEXT')."\",\n";
		echo "\t\tnoimage       : \"".JText::_('COM_JMYLIFE_ERROR_STORY_NOIMAGEADDED')."\",\n";
		echo "\t\tnourl         : \"".JText::_('COM_JMYLIFE_ERROR_STORY_NOURLADDED')."\",\n";
		echo "\t\tnoselect      : \"".JText::_('COM_JMYLIFE_ERROR_STORY_NOTEXTSELECTED')."\",\n";
		echo "\t\tmodalok       : \"".JText::_('COM_JMYLIFE_CORE_OK')."\"\n";
		echo "\t}\n};\n\n";
		$file = JPATH_COMPONENT.DS.'libraries'.DS.'wysiwyg'.DS.'editor-unpacked.js';
		if (JFile::exists($file)) {
			echo @file_get_contents($file);
		}
		die();
	}

	/**
	 * share
	 * @since   1.0.13
	 *
	 * output for 3rd party share functions
	 */
	function share() {
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$itemid = JmylifeItemidHelper::getInstance();
		$cfg = JmylifeConfiguration::getInstance();
		$spath = JPATH_COMPONENT.DS.'assets'.DS.'js'.DS.'share';
		$js = '';
		header('Content-type: text/javascript');
		$js .= "window.jml={";
		$js .=  "root:'".JURI::root(false)."',";
		$js .=  "action:'".JRoute::_('index.php?option=com_jmylife&view=submit&Itemid='.$itemid->view('submit'), false, -1)."',";
		$js .=  "img:'components/com_jmylife/assets/images/share-default.jpg'";
		$js .= "};";
		$js .= @file_get_contents($spath.DS.'helpers'.DS.'getElementsByClassName-1.0.1.js');
		$js .= @file_get_contents($spath.DS.'helpers'.DS.'makeDoubleDelegate.js');
		$js .= @file_get_contents($spath.DS.'share.js');
		$js = preg_replace('`\n|\r`', '', $js);
		if (!class_exists('JSMin')) {
			JLoader::import('jsmin.loader', JPATH_JMYLIFELIBS);
		}
		$js = JSMin::minify($js);
		echo $js;
		die();
	}

	/**
	 * function validatestorylink
	 * @since   1.0.13
	 */
	function validatestorylink() {
		$cfg = JmylifeConfiguration::getInstance();
		$url = JRequest::getString('url', '');
		$json = array(
			'status' => 'error',
			'message' => JText::_('COM_JMYLIFE_ERROR_STORY_LINKINVALIDURL'),
			'data' => array(
				'title' => '',
				'images' => array()
			)
		);
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		// validate
		if (!$helper->validate($url)) {
			$json['message'] = JText::_('COM_JMYLIFE_ERROR_STORY_LINKNOTHTTP');
			die(json_encode($json));
		}
		// ensure that this link is not associated with any other stories
		if ($cfg->getInt('storylink_unique')) {
			$query = 'SELECT `sid` FROM `#__jmylife_stories_attachments` WHERE `url` = '.$cfg->db->Quote($url).' LIMIT 1';
			$cfg->db->setQuery($query);
			if ($result = $cfg->db->loadResult()) {
				if (intval($result) != JRequest::getInt('cid') && 0 < $result) {
					$json['message'] = JText::_('COM_JMYLIFE_ERROR_STORY_LINKALREADYLINKED');
					die(json_encode($json));
				}
			}
		}
		// ensure link is valid by loading remote data
		if ($helper->isAvailable($url)) {
			// set status and message
			$json['status'] = 'success';
			$json['message'] = JText::_('COM_JMYLIFE_CORE_FNORD');
			// fetch remote data and parse title and images
			$json['data'] = JmylifeCommon::getStoryLinkPreviewData($url);
		}
		die(json_encode($json));
	}

	/**
	 * function uploadimage
	 * @since   1.0.13
	 * @from    http://docs.joomla.org/Creating_a_file_uploader_in_your_component
	 *          heavily modified
	 */
	function uploadimage()
	{
		// get application
		$appl =& JFactory::getApplication();
		// purge old image
		$appl->setUserState( "com_jmylife.new_image", '' );
		// check errors
		$fileError = $_FILES['image']['error'];
		if ( $fileError > 0 )
		{
			switch ($fileError)
			{
				case 1:
					echo JText::_( 'COM_JMYLIFE_ERROR_FILE_LARGERTHANPHPINIALLOWS' );
					die();
				case 2:
					echo JText::_( 'COM_JMYLIFE_ERROR_FILE_LARGERTHANHTMLFORMALLOWS' );
					die();
        case 3:
					echo JText::_( 'COM_JMYLIFE_ERROR_FILE_PARTIALUPLOAD' );
					die();
				case 4:
					echo JText::_( 'COM_JMYLIFE_ERROR_FILE_NOFILE' );
					die();
			}
		}
		// check filesize
		$fileSize = $_FILES['image']['size'];
		if( $fileSize > 2000000 )
		{
			echo JText::_( 'COM_JMYLIFE_ERROR_FILE_FILEBIGGERTHAN2MB' );
			die();
		}
		// get file names
		$fileName = $_FILES['image']['name'];
		$fileTemp = $_FILES['image']['tmp_name'];
		// check file extension
		if ( !preg_match( '`\.(jpe?g|png)$`', strtolower( $fileName ) ) )
		{
			echo JText::_( 'COM_JMYLIFE_ERROR_FILE_INVALIDEXTENSION' );
			die();
		}
		// check file type
		JLoader::import('components.com_jmylife.helpers.image', JPATH_ADMINISTRATOR, '');
		$image = JmylifeImageHelper::getInstance();
		$type = $image->validate( $fileTemp );
		if ( false === $type )
		{
			echo JText::_( 'COM_JMYLIFE_ERROR_FILE_INVALIDTYPE' );
			die();
		}
		// generate file name based on "immutable" identifiers
		// originally I was going to use session id,
		// but there were complications when used in admin backend
		// $fileName = JmylifeCommon::getSessionId();
		// now using md5 of IP and user agent (though neither is truly
		// "immutable" it's highly unlikely they will change between requests)
		// TODO: duh, uniqid... d'oh!
		$fileName = md5($_SERVER['HTTP_USER_AGENT'].$_SERVER['REMOTE_ADDR']);
		// build absolute path for images
		$path = JPATH_ROOT.DS.'images'.DS.'jmylife'.DS;
		if (!JFolder::exists($path)) {
			JFolder::create($path);
			if (!JFolder::exists($path)) {
				echo JText::_('COM_JMYLIFE_ERROR_FILE_CANNOTFINDIMAGEPATH');
				die();
			}
		}
		// move image to path
		if (!JFile::upload($fileTemp, $path.$fileName)) {
			echo JText::_('COM_JMYLIFE_ERROR_FILE_CANNOTMOVEFILE');
			die();
		}
		// resize image
		JmylifeCommon::resizeImageAttachment($path.$fileName, $type);
		// set web route to image
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$url = JmylifeUrlHelper::getInstance();
		$href = JURI::root().'/images/jmylife/'.$fileName;
		$href = $url->clean($href);
		// set new image location in session
		$appl->setUserState( "com_jmylife.new_image", $href );
		$appl->setUserState( "com_jmylife.new_image_file", $path.$fileName );
		// redirect to next page
		$appl->redirect(JRoute::_('index.php?option=com_jmylife&view=submit&format=raw&layout=attach', false));
	}

	/**
	 * function closeattachment
	 * @since   1.0.13
	 *
	 * cleans up any temporary residue from attachments
	 */
	function closeattachment()
	{
		$appl =& JFactory::getApplication();
		// get temp image path
		$img = $appl->getUserState( "com_jmylife.new_image_file", '' );
		if ( 0 < strlen( $img ) && JFile::exists( $img ) )
		{
			JFile::delete( $img );
		}
		$appl->setUserState( "com_jmylife.new_image", '' );
		$appl->setUserState( "com_jmylife.new_image_file", '' );
		// aaand that's it ;)
		die('ok');
	}

	/**
	 * function azrul_ajax
	 * @since   1.0.12
	 */
	function azrul_ajax() {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$url = JmylifeUrlHelper::getInstance();
		$JMLCore = JmylifeConfiguration::getInstance();
		$jaxtask = JRequest::getCmd('jaxtask');
		if ('rendersubmit' == $jaxtask) {
			$suburl = $url->clean(JURI::root().'index.php?option=com_jmylife&view=submit&no_html=1');
			// fetch sizes from plugin
			$plugin =& JPluginHelper::getPlugin('jmylifetoolbar', 'community');
			// Get the plugin parameters
			$pluginParams = new JParameter($plugin->params);
			$width = $pluginParams->get('modalsubmitwidth', 720);
			$height = $pluginParams->get('modalsubmitheight', 375);
			if (!strlen(''.$width)) {
				$width = 720;
			}
			if (!strlen(''.$height)) {
				$height = 375;
			}
		?>
(function($){
	var win = $('#cWindowContent').autogrow();
	var winPad = parseInt(win.css('padding-top').toString().replace(/px/,'')) + parseInt(win.css('padding-bottom').toString().replace(/px/,''));
	win.empty().append(
		$('<ifr' + 'ame src="<?php echo $suburl; ?>" width="100%" frameborder="0" border="0"></ifr' + 'ame>')
			.css({'border':'0px'})
			.width('100%')
			.height(<?php echo $height; ?> - winPad)
	);
	return [];
})(jQuery);
		<?php
		}
		die();
	}

}