<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/jmylife.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
@error_reporting( E_ALL ^ E_NOTICE );
@ini_set( 'error_reporting', E_ALL ^ E_NOTICE );
if( !defined( 'JPATH_JMYLIFE' ) ) define( 'JPATH_JMYLIFE', JPATH_ROOT.DS.'components'.DS.'com_jmylife' );
if( !defined( 'JPATH_JMYLIFELIBS' ) ) define( 'JPATH_JMYLIFELIBS', JPATH_JMYLIFE.DS.'libraries' );
require_once( JPATH_JMYLIFELIBS.DS.'common.php' );
require_once( JPATH_JMYLIFELIBS.DS.'configuration.php' );
// config
$_JMLConfig = JmylifeConfiguration::getInstance();
// require captcha, if needed...
switch ($_JMLConfig->getInt('captcha_engine', 0)) {
	case 1:
		if (!function_exists("recaptcha_get_html")) {
			require_once(JPATH_JMYLIFELIBS.DS.'recaptchalib.php');
		}
		break;
	case 3:
		if (!class_exists("CaptchasDotNet")) {
			require_once(JPATH_JMYLIFELIBS.DS.'CaptchasDotNet.php');
		}
		break;
}
// FIX: limit
JRequest::setVar( 'limit', $_JMLConfig->getInt( 'page_limit', 10 ) );
// build asset path
$assetPath = JURI::base().'components/com_jmylife/assets/';
// load language in order to determine RTL status
$lang =& JFactory::getLanguage();
// prepare document
$document =& JFactory::getDocument();
$document->setGenerator( 'JMyLife by Jeff Channell' );
$document->setDescription( $_JMLConfig->get( 'jmylife_desc' ) );
$document->setTitle( $_JMLConfig->get( 'jmylife_name' ) );
// version in 1.0.8 to ensure assets load properly
if ('feed' != JRequest::getVar('format')) {
	$cachekiller = substr(base64_encode($_JMLConfig->version->getFullVersion()),0,10);
	$document->addStyleSheet( $assetPath.'css/styles'.( $lang->isRTL() ? '_rtl' : '' ).'.css?v='.$cachekiller );
}
// J! 1.6 stylesheet added in 1.0.9
if( $_JMLConfig->has->jversion->RELEASE == '1.6' )
{
	$document->addStyleSheet( $assetPath.'css/styles16.css?v='.substr(base64_encode( $_JMLConfig->version->getFullVersion() ),0,5) );
}
// scripts & styles
$jmlStyle = '';
// load jQuery
$document->addScript(JRoute::_('index.php?option=com_jmylife&controller=ajax&task=jQuery', false));
$view = JRequest::getWord('view', 'list');
if (in_array($view, array('list','item','favorites'))) {
	// TODO: possibly have toggles for these...
	$document->addScript( $assetPath.'js/ajaxClick.js' );
	// are we toggling footer?
	if( $_JMLConfig->getInt( 'footer_toggle', 1 ) == 1 )
	{
		$document->addScript( $assetPath.'js/footerToggle.js' );
	}
	if( $_JMLConfig->getInt( 'show_comment_balloon' ) && 'item' != $view )
	{
		$document->addScript( $assetPath.'js/commentHover.js' );
		$document->addScriptDeclaration( 'commentHover( "'.JURI::base().'" );' );
	}
	if( $_JMLConfig->getInt( 'sharethislink', 0 ) == 1 && strlen( $_JMLConfig->get( 'sharethislinkcode' ) ) > 0 )
	{
		$document->addScript('http://w.sharethis.com/button/buttons.js');
		$document->addScriptDeclaration('stLight.options({publisher:"'.$_JMLConfig->get('sharethislinkcode').'"});');
	}
}
JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
$html = JmylifeHtmlHelper::getInstance();
$html->roundies();
// configurable background since 1.0.8
$itembg = $_JMLConfig->get( 'story_background', 'efefef' );
if( strlen( $itembg ) == 0 ) $itembg = 'efefef';
$jmlStyle .= ".comJMyLifeItem,.comJMyLifeComment{background:#{$itembg};}";
// add custom user styles, 1.0.9
$customcss = $_JMLConfig->get( 'css_custom_styles', '' );
if( strlen( $customcss ) > 0 && preg_match( '`\.css$`', $customcss ) && $_JMLConfig->getInt( 'css_custom_published', 0 ) == 1 )
{
	$document->addStyleSheet( $assetPath.'css/custom/'.$customcss );
}
// add comment balloon styles
$jmlStyle .= '.jmylifeBalloon{width:'.$_JMLConfig->getInt( 'comment_balloon_width', 400 ).'px;}';
// add the rest of the styles
if( strlen( $jmlStyle ) > 0 ) $document->addStyleDeclaration( $jmlStyle );

// Require the base controller
require_once (JPATH_JMYLIFE.DS.'controller.php');
// Require specific controller if requested, changed in 1.0.8
$path = JPATH_JMYLIFE.DS.'controllers'.DS.$view.'.php';
if (file_exists($path)) {
	$controller = $view;
	require_once $path;
} else {
	if ($controller = JRequest::getWord('controller')) {
		$path = JPATH_JMYLIFE.DS.'controllers'.DS.$controller.'.php';
		if(file_exists($path)) {
			require_once $path;
		}
	}
}
// pathway is added before controller is executed
// because we only add to pathway if controller is NOT "ajax"
if ('ajax' != $controller) {
	JmylifeCommon::handlepath();
}
// Create the controller
$classname = 'JmylifeController'.$controller;
$controller = new $classname();
// Perform the Request task
$controller->execute(JRequest::getCmd('task', 'display'));
// Redirect if set by the controller
$controller->redirect();
if ($_JMLConfig->getBool('powered_by', true)) echo $_JMLConfig->get('content');