<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/libraries/common.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// this is defined here to be universal ;)
if (!defined('JPATH_JMYLIFEIMAGEFILES')) define('JPATH_JMYLIFEIMAGEFILES', JPATH_ROOT.DS.'images'.DS.'jmylife');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

/**
 * HTML Common class JmylifeCommon
 *
 * @package    JMyLife
 */
class JmylifeCommon
{
	function votelinks( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$goodText = $_JMLConfig->get('votegood_text');
		$badText  = $_JMLConfig->get('votebad_text');
		$linkattr = array( 'class'=>"comJMyLifeItemVoteLink", 'rel'=>'nofollow' );
		$goodlink = $html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=votegood&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
			( strlen( $goodText ) > 0 ? $goodText : JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEGOOD') ).' ('.$item->votes1.')',
			array('class'=>"comJMyLifeItemVoteLink comJMyLifeItemVoteLinkGood", 'rel'=>'nofollow')
		);
		$badlink = $html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=votebad&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
			( strlen( $badText ) > 0 ? $badText : JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEBAD') ).' ('.$item->votes2.')',
			array('class'=>"comJMyLifeItemVoteLink comJMyLifeItemVoteLinkBad", 'rel'=>'nofollow')
		);
		return $goodlink.(0 == $_JMLConfig->get('good_votes_only', 0) ? ' - ' .$badlink : '');
	}
	function graphicvote( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$goodText = $_JMLConfig->get('votegood_text');
		$badText  = $_JMLConfig->get('votebad_text');
		$linkattr = array( 'class'=>"comJMyLifeItemGraphicVoteLink", 'rel'=>'nofollow' );
		return $html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=votegood&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
			'<img src="'.JURI::base().'components/com_jmylife/assets/images/voteup-'.$_JMLConfig->get('graphical_voting_size','48').'.png"/><span class="comJMyLifeItemGraphicVoteCount">'.$item->votes1.'</span><span class="comJMyLifeItemGraphicVoteText">'.( strlen( $goodText ) > 0 ? $goodText : JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEGOOD') ).'</span>',
			$linkattr ).( $_JMLConfig->get( 'good_votes_only', 0 ) == 0 ? ' - ' .
		$html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=votebad&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
			'<img src="'.JURI::base().'components/com_jmylife/assets/images/votedown-'.$_JMLConfig->get('graphical_voting_size','48').'.png"/><span class="comJMyLifeItemGraphicVoteCount">'.$item->votes2.'</span><span class="comJMyLifeItemGraphicVoteText">'.( strlen( $badText ) > 0 ? $badText : JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEBAD') ).'</span>',
			$linkattr ) : '' )
		;
	}
	function reportstorylink( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// this should only work if email is configured & enabled, so check first
		if( $_JMLConfig->getInt( 'email_enabled', 0 ) == 1 && strlen( $_JMLConfig->get( 'email_to' ) ) > 0 )
		{
			return $html->link(
				JRoute::_('index.php?option=com_jmylife&controller=ajax&task=reportstory&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
				JText::_('COM_JMYLIFE_STORY_REPORT'),
				array( 'class'=>"reportstory_link", 'rel'=>'nofollow' )
			);
		}
		return '';
	}
	function reportcommentlink( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=report&cid='.$item->id.'&'.JUtility::getToken().'=1', false),
			JText::_('COM_JMYLIFE_COMMENT_REPORT'),
			array( 'class'=>"report_link", 'rel'=>'nofollow' )
		);
	}
	function itemfooter( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if( $_JMLConfig->getInt( 'comment_engine', 0 ) == 4 && $_JMLConfig->getInt( 'jomcomment_tools', 0 ) == 1 )
		{
			$commentpath = JPATH_SITE.DS.'plugins'.DS.'content'.DS.'jom_comment_bot.php';
			if( file_exists( $commentpath ) )
			{
				require_once( $commentpath );
				// adapted from jomcomment mambots.php
				if( !defined( 'AzrulJXCachedTemplate' ) )
				{
					include_once( JPATH_SITE.DS.'plugins'.DS.'system'.DS.'pc_includes'.DS.'template.php' );
				}
				global $_JC_CONFIG, $_JOMCOMMENT;
				$show = array();
				$show['readmore']	= true;
				$show['comment']	= $item->show_comments;
				$show['hit']		= false;
				$link = array();
				$link['readmore']	= $item->storylink;
				$link['comment']	= $link['readmore'] . "#comments";
				$count = array ();
				$count['comment'] 	= $item->numcomments;
				$count['hit']		= 0;
				$tpl = new AzrulJXCachedTemplate('jmylife_' . $_SERVER['QUERY_STRING'] . $item->id);
				$tpl->set('show', $show);
				$tpl->set('link', $link);
				$tpl->set('count', $count);
				$tpl->set('debugview', false);
				$fdata = '';
				// include helpers
				include_once( JC_HELPER_PATH.DS.'minimal.helper.php');
				include_once( JC_HELPER_PATH.DS.'comments.helper.php');
				// optional, for when you're done setting things up
				if( $_JMLConfig->getInt( 'jomcomment_cache', 0 ) == 1 )
				{
					// Cache file exists, dont need to continue the block.
					// Return here.
					if( jcBlogViewTemplate( $tpl, $row, $link ) ) return;
				}
				// Template overrides
				if( $_JC_CONFIG->get('overrideTemplate') )
				{
					$customTemplatePath	= JC_CUSTOM_TPL.DS.'readmore.tpl.html';
					if( file_exists( $customTemplatePath ) )
						$fdata  = trim( $tpl->fetch_cache( $customTemplatePath, 'jcTranslate' ) );
					else
						$fdata = trim( $tpl->fetch_cache( JC_COM_PATH.DS.'templates'.DS.'_default'.DS.'readmore.tpl.html', 'jcTranslate' ) );
				}
				else
				{
					if( file_exists( JC_COM_PATH.DS.'templates'.DS.$_JC_CONFIG->get('template').DS.'readmore.tpl.html' ) )
						$fdata  = trim( $tpl->fetch_cache( JC_COM_PATH.DS.'templates'.DS.$_JC_CONFIG->get('template').DS.'readmore.tpl.html', 'jcTranslate' ) );
					else
						$fdata = trim( $tpl->fetch_cache( JC_COM_PATH.DS.'templates'.DS.'_default'.DS.'readmore.tpl.html', 'jcTranslate' ) );
				}
				$fdata  = str_replace('%HITS%',0, $fdata);
				$fdata  = str_replace('%COMMENTS%', $item->numcomments, $fdata);
				// Replace the readmore link and comment links with appropriate links.
				$fdata  = str_replace('%LINK_READMORE%', $link['readmore'], $fdata);
				$fdata  = str_replace('%LINK_COMMENT%', $link['comment'], $fdata);
				return $fdata;
			}
		}
		// get user
		$user =& JFactory::getUser();
		$database =& JFactory::getDBO();
		$url = $item->fullstorylink;
		// init output
		$output = '';
		// hide/show button
		// only if enabled in config - since 1.0.2
		if( $_JMLConfig->getInt( 'footer_toggle' ) == 1 )
		{
			$output .= '<div class="comJMyLifeItemFooterToggle">+</div>';
		}

		// wrapper for footer contents
		$output .= '<div class="comJMyLifeItemFooterWrapper">';
		// added ShareThis in 1.0.10, which overrides all other sharing links
		if( $_JMLConfig->getInt( 'sharethislink', 0 ) == 1 && strlen( $_JMLConfig->get( 'sharethislinkcode' ) ) > 0 )
		{
			JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
			$html = JmylifeHtmlHelper::getInstance();
			// all sharethis items have the same general template
			$template = '<span class="st_%s%s" st_url="%s" st_title="%s" displayText="%s"></span>';
			switch ($_JMLConfig->get('sharethislayout', 'classic')) {
				case 'classic':
					$output .= sprintf($template, 'sharethis', '', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS'));
					break;
				case 'varmini':
					$output .= sprintf($template, 'email', '', $url, $html->clean($item->title), '');
					$output .= sprintf($template, 'facebook', '', $url, $html->clean($item->title), '');
					$output .= sprintf($template, 'twitter', '', $url, $html->clean($item->title), '');
					$output .= sprintf($template, 'sharethis', '', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS'));
					break;
				case 'varsuper':
					$output .= sprintf($template, 'twitter', '_large', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_TWITTER'));
					$output .= sprintf($template, 'facebook', '_large', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_FACEBOOK'));
					$output .= sprintf($template, 'ybuzz', '_large', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_YBUZZ'));
					$output .= sprintf($template, 'gbuzz', '_large', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_GBUZZ'));
					$output .= sprintf($template, 'email', '_large', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_EMAIL'));
					$output .= sprintf($template, 'sharethis', '_large', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS'));
					break;
				case 'varstandard':
					$output .= sprintf($template, 'facebook', '_button', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_FACEBOOK'));
					$output .= sprintf($template, 'twitter', '_button', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_TWITTER'));
					$output .= sprintf($template, 'email', '_button', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_EMAIL'));
					break;
				case 'horizontal':
					$output .= sprintf($template, 'facebook', '_hcount', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_FACEBOOK'));
					$output .= sprintf($template, 'twitter', '_hcount', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_TWITTER'));
					$output .= sprintf($template, 'email', '_hcount', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_EMAIL'));
					$output .= sprintf($template, 'sharethis', '_hcount', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS'));
					break;
				case 'vertical':
					$output .= sprintf($template, 'facebook', '_vcount', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_FACEBOOK'));
					$output .= sprintf($template, 'twitter', '_vcount', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_TWITTER'));
					$output .= sprintf($template, 'email', '_vcount', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS_EMAIL'));
					$output .= sprintf($template, 'sharethis', '_vcount', $url, $html->clean($item->title), JText::_('COM_JMYLIFE_SHARETHIS'));
					break;
			}
		}
		else
		{
			// these items reordered in 1.0.9 to combat some weird IE float bug
			// since 1.0.4
			$output .= JmylifeCommon::twitlink( $item );
			// add facebook footer (actual check for config done in fblink() below
			$output .= JmylifeCommon::fblink( $item );
			// add send to friend link
			if( $_JMLConfig->getInt( 'sendfriendlink', 0 ) == 1 )
			{
				if( !$user->guest || $_JMLConfig->getInt( 'sendfriend_guests', 0 ) == 1 )
				{
					// this needs to be wrapped in a span in order to allow for injecting form elements
					$output .= '<span class="submitfriend_link_wrapper">'.$html->link(
						JRoute::_('index.php?option=com_jmylife&controller=ajax&task=emailfriend&id='.$item->id, false),
						JText::_('COM_JMYLIFE_STORY_SENDTOFRIEND'),
						array( 'class'=>'sendfriend_link', 'rel'=>'nofollow' )
					).'<span class="jmlEmailWrapper"><input class="jmlEmail" name="emailfriend" value=""/><input class="jmlEmailSend" type="button" value="'.$_JMLConfig->get('sendfriend_buttontext').'"/><input type="hidden" value="'.preg_replace('`\"`','%22',JRoute::_( 'index.php?option=com_jmylife&controller=ajax&task=emailfriend&id='.$item->id ) ).'"/></span></span>';
				}
			}
		}
		if( $_JMLConfig->getInt( 'reportlink' ) == 1 )
		{
			$output .= JmylifeCommon::reportstorylink( $item );
		}
		// other than this, we'll have different items for users/guests
		if( $user->guest )
		{
			// since 1.0.5 this is optional
			if( $_JMLConfig->getInt( 'show_signupitem' ) == 1 )
			{
				// get link for item from menu
				$database->setQuery( 'SELECT `link` FROM `#__menu` WHERE `id` = '.$_JMLConfig->getInt( 'signupitem' ), 0, 1 );
				// if no link use base, fixed in 1.0.9
				if (!($link = $database->loadResult())) {
					$link = JURI::base();
				} else {
					JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
					$helper = JmylifeUrlHelper::getInstance();
					// append Itemid
					$link .= $helper->q($link).'Itemid='.$_JMLConfig->getInt('signupitem');
				}
				$link = JRoute::_($link, false);
				$output .= $html->link($link, JText::_('COM_JMYLIFE_STORY_SIGNUPFORMORE'), array('class' => 'signup_link'));
			}
		}
		// registered user
		else
		{
			// check if user is subscribed to the story & add a subscription link
			$query = 'SELECT `id` FROM `#__jmylife_stories_subscriptions` WHERE `uid` = '.$user->id.' AND `sid` = '.$item->id;
			$database->setQuery( $query );
			if( intval( $database->loadResult() ) > 0 )
			{
				$output .= $html->link(
						JRoute::_('index.php?option=com_jmylife&controller=ajax&task=unsubscribe&sid='.$item->id.'&'.JUtility::getToken().'=1&tmpl=component', false),
						JText::_('COM_JMYLIFE_STORY_UNSUBSCRIBE'),
						array( 'class'=>"unsubscribe_link", 'rel'=>'nofollow' )
				);
			}
			// since 1.0.9 this is optional
			if ($_JMLConfig->getInt('favoritelink', 1)) {
				if ($item->fav) {
					$output .= '<span class="favorite_link isfavorite_link">'./*JText::_('COM_JMYLIFE_ERROR_STORY_ALREADYFAVORITE').*/'</span>';
				} else {
					$output .= $html->link(
						JRoute::_('index.php?option=com_jmylife&controller=ajax&task=favorite&sid='.$item->id.'&'.JUtility::getToken().'=1&tmpl=component', false),
						JText::_('COM_JMYLIFE_STORY_ADDTOFAVORITES'),
						array( 'class'=>"favorite_link", 'rel'=>'nofollow' )
					);
				}
			}
		}
		// end wrapper
		$output .= '</div>';

		// clear, in case...
		$output .= '<div class="comJMyLifeItemFooterClear"></div>';

		// all done!
		return $output;
	}
	/**
	 * fblink
	 * @param  object   item
	 * @return string   html for facebook link
	 */
	function fblink(&$item) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$helper = JmylifeUrlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if ($_JMLConfig->getInt('fblink')) {
			$url = $helper->clean($item->fullstorylink, true);
			$url = "http://www.facebook.com/sharer.php?u=$url";
			$attr = array('class'=>'fb_share_link', 'target'=>'_blank');
			if ($_JMLConfig->getInt('fbmodal')) {
				$attr = array('class'=>'fb_share_link modal', 'rel'=>'{handler:\'iframe\',size:{x:626,y:436}}');
			}
			return $html->link($url, JText::_('COM_JMYLIFE_STORY_SHAREONFACEBOOK'), $attr);
		}
		return '';
	}
	/**
	 * twitlink
	 * @param  object   item
	 * @return string   html for twitter link
	 */
	function twitlink(&$item) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$helper = JmylifeUrlHelper::getInstance();
		$string = JmylifeStringHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if ($_JMLConfig->getInt('twitlink')) {
			$url = $helper->clean($item->fullstorylink, true);
			$text = urlencode($string->shorten(JText::sprintf('COM_JMYLIFE_STORY_TWITTERSHARE', $item->fulltext), 137, false));
			$link = "http://twitter.com/home?status={$text}";
			$attr = array('class'=>'twit_share_link', 'target'=>'_blank');
			return $html->link($link, JText::_('COM_JMYLIFE_STORY_SHAREONTWITTER'), $attr);
		}
		return '';
	}

	/**
	 * buildLinkSubmissionLink
	 * @param   string   link url
	 * @return  string   submission form url
	 * @since   1.0.13
	 */
	function buildLinkSubmissionLink( $url )
	{
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$itemid = JmylifeItemidHelper::getInstance();
		$helper = JmylifeUrlHelper::getInstance();
		// unencode url, just in case
		$url = urldecode($url);
		$sub = JRoute::_('index.php?option=com_jmylife&view=submit&Itemid='.$itemid->view('submit'), true, -1);
		return $sub . $helper->q($sub) . 'link=' . $url;
	}

	/**
	 * handlepath
	 * @since 1.0.9
	 *
	 * TODO: make this work better ;P
	 *       at some point this should check menu items thoroughly
	 */
	function handlepath()
	{
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeItemidHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$database =& JFactory::getDBO();
		$appl     =& JFactory::getApplication();
		$pathway  =& $appl->getPathway();
		$menu     =& JSite::getMenu();
		$active   =  $menu->getActive();
		// get vars from request
		$view   = JRequest::getCmd('view');
		$catid  = JRequest::getInt('catid',0);
		$id     = JRequest::getInt('id',0);
		$sort   = JRequest::getWord('sort','none');
		$rand   = JRequest::getInt('random',0);
		$Itemid = JRequest::getInt('Itemid',0);
		$start  = $_JMLConfig->get('jmylife_name',JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_SITENAME'));
		// handle crumbs
		// check active to see where the user is
		// if it's a JML pathway item skip root pathway
		if ('com_jmylife' != @$active->query['option']) {
			// send initial crumb for JMyLife
			$pathway->addItem($start, JRoute::_( 'index.php?option=com_jmylife&view=list&Itemid='.$helper->category(0)));
		}
		switch ($view) {
			case 'list':
				if (0 < $catid && @$active->query['catid'] != $catid) {
					// get category
					$database->setQuery('SELECT `name` FROM `#__jmylife_categories` WHERE id = '.$catid);
					if ($catname = $database->loadResult()) {
						$pathway->addItem($catname, JRoute::_('index.php?option=com_jmylife&view=list&catid='.$catid.'&Itemid='.$helper->category($catid)));
					}
				}
				if (@$active->query['sort'] != $sort) {
					if ('best' == $sort) {
						$pathway->addItem(JText::_('COM_JMYLIFE_SEF_BEST'), JRoute::_('index.php?option=com_jmylife&view=list&sort=best&Itemid='.$helper->category(0, 'best')));
					}
					else if ('worst' == $sort) {
						$pathway->addItem(JText::_('COM_JMYLIFE_SEF_WORST'), JRoute::_('index.php?option=com_jmylife&view=list&sort=worst&Itemid='.$helper->category(0, 'worst')));
					}
				}
				break;
			case 'item':
				// handle random
				if ($rand) {
					$pathway->addItem(JText::_('COM_JMYLIFE_SEF_RANDOM'), JRoute::_('index.php?option=com_jmylife&view=item&random=1&Itemid='.$helper->story(0, 1)));
				} else {
					// get data from database
					$database->setQuery('SELECT cat.`name` AS catname, cat.`id` AS catid, s.`title`, s.`user_alias` FROM `#__jmylife_categories` AS cat LEFT JOIN `#__jmylife_stories` AS s ON ( cat.`id` = s.`catid` ) WHERE s.`id` = '.$id.' GROUP BY cat.`id`');
					if ($data = $database->loadObject()) {
						$pathway->addItem($data->catname, JRoute::_('index.php?option=com_jmylife&view=list&catid='.$data->catid.'&Itemid='.$helper->category($data->catid)));
						// now add story
						// add story title if present & allowed, otherwise use "story by" text
						$storylink = JRoute::_('index.php?option=com_jmylife&view=item&id='.$id.'&Itemid='.$helper->story($data));
						if (strlen($data->title)) {
							$pathway->addItem($data->title, $storylink);
						} else {
							$pathway->addItem(JText::sprintf('COM_JMYLIFE_STORY_TITLE', $data->user_alias), $storylink);
						}
					}
				}
				break;
			case 'submit':
				if (@$active->query['view'] != $view) {
					$pathway->addItem(JText::_('COM_JMYLIFE_SEF_SUBMIT'), JRoute::_('index.php?option=com_jmylife&view=submit&Itemid='.$helper->view('submit')));
				}
				break;
			case 'favorites':
				if (@$active->query['view'] != $view) {
					$pathway->addItem(JText::_('COM_JMYLIFE_SEF_FAVORITES'), JRoute::_('index.php?option=com_jmylife&view=favorites&Itemid='.$helper->view('favorites')));
				}
				break;
			case 'moderate':
				if (@$active->query['view'] != $view) {
					$pathway->addItem(JText::_('COM_JMYLIFE_SEF_MODERATE'), JRoute::_('index.php?option=com_jmylife&view=moderate&Itemid='.$helper->view('moderate')));
				}
				break;
			case 'categories':
				if (@$active->query['view'] != $view) {
					$pathway->addItem(JText::_('COM_JMYLIFE_SEF_CATEGORIES'), JRoute::_('index.php?option=com_jmylife&view=categories&Itemid='.$helper->view('categories')));
				}
				break;
		}
		return;
	}

	/**
	 * buildAvatarPath
	 * @param   string
	 * @return  string
	 * @since   1.0.9
	 */
	function buildAvatarPath($img='') {
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$path = JURI::base();
		if ($_JMLConfig->allow->cb) {
			if (strlen($img)) {
				$path .= '/images/comprofiler/';
				if (!preg_match('`gallery`', $img)) {
					$path .= 'tn';
				}
				$path .= $img;
			} else {
				$path .= '/components/com_comprofiler/images/english/tnnophoto.jpg';
			}
		}
		else if ($_JMLConfig->allow->jomsocial) {
			if (strlen($img)) {
				$path .= '/'.$img;
			} else {
				$path .= '/components/com_community/assets/default_thumb.jpg';
			}
		}
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->clean($path);
	}

	/**
	 * buildProfilePath
	 * @param   int
	 * @return  string
	 * @since   1.0.9
	 */
	function buildProfilePath($id) {
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$user =& JFactory::getUser();
		if ($id) {
			if ($_JMLConfig->allow->cb) {
				return JRoute::_('index.php?option=com_comprofiler&task=userProfile'.($user->id != $id ? '&user='.$id : ''));
			}
			else if ($_JMLConfig->allow->jomsocial) {
				return JRoute::_('index.php?option=com_community&view=profile'.($user->id != $id ? '&userid='.$id : ''));
			}
		}
		return '';
	}


	/**
	 * buildUserAwards
	 * @param   int
	 * @param   int
	 * @return  string
	 * @since   1.0.13
	 *
	 * based on jAwards readme for fireboard integration
	 */
	function buildUserAwards( $id )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if ( !$_JMLConfig->allow->jawards ) return '';
		// sanitize
		$id = intval( $id );
		$count = $_JMLConfig->getInt( 'jawards_icon_count', 5 );
		$query = "SELECT b.id, b.image, b.name"
		       . "\n FROM #__jawards_awards AS a"
					 . "\n LEFT JOIN #__jawards_medals AS b ON b.id = a.award"
					 . "\n WHERE a.userid=".$id
					 . "\n ORDER BY RAND() LIMIT ".$count
		;
		$_JMLConfig->db->setQuery( $query );
		if ( $medals = $_JMLConfig->db->loadObjectList() )
		{
			// original integration built a link to CB profile
			// but AFAIK there is no JomSocial jAwards plugin/tab/whatever
			// create a link to profile only for CB
			switch ( $_JMLConfig->getInt( 'social_engine' ) )
			{
				case 1 :
					$awards_url = JRoute::_("index.php?option=com_comprofiler&task=userProfile&user={$id}&tab=getawardstab");
					break;
			}
			// manually set the size via config
			$medal_width = $_JMLConfig->getInt( 'jawards_icon_width', 32 );
			$medal_height = $_JMLConfig->getInt( 'jawards_icon_height', 32 );
			// CSS-class "ja_medals" allows individual styling of medal images and
			// container. "nobr" keeps the medals from breaking apart, display them
			// in one row.
			$msg_jawards = "<div class=\"ja_medals\"><nobr>";
			JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
			$helper = JmylifeUrlHelper::getInstance();
			foreach ($medals as $medal)
			{
				$medal_image = $helper->clean(JURI::root()."/images/medals/".$medal->image );
				// for now only change the link if the url isn't being produced above
				if ( 1 != $_JMLConfig->getInt( 'social_engine' ) )
				{
					$awards_url = JRoute::_('index.php?option=com_jawards&task=listusers&award='.$medal->id);
				}
				$msg_jawards.= "<a href=\"$awards_url\" title=\"".JText::sprintf('COM_JMYLIFE_JAWARDS_CLICKFORMORE', $medal->name)."\">"
					. "<img style='border:0px;padding:0px;' src=\"".htmlspecialchars($medal_image)."\" alt=\"".htmlspecialchars($medal->name)."\""
					. ( 0 < $medal_width  ? " width=\"{$medal_width}\""   : "" )
					. ( 0 < $medal_height ? " height=\"{$medal_height}\"" : "" )
					. " />"
					. "</a>"
				;
			}
			$msg_jawards.="</nobr></div>";
			unset($medals);
			return $msg_jawards;
		}
		return '';
	}

	function getStoryAttachmentImageUrl($id) {
		if (!is_numeric($id) || !defined('JPATH_JMYLIFEIMAGEFILES') || !JFolder::exists(JPATH_JMYLIFEIMAGEFILES)) {
			return '';
		}
		$files = JFolder::files(JPATH_JMYLIFEIMAGEFILES, 'attachment_'.$id);
		if (count($files)) {
			$file = $files[0];
			// fix - images have 2 states, thumb & full
			if (1 < count($files)) {
				$view = JRequest::getWord('view');
				if ('item' != $view) {
					foreach ($files as $f) {
						if (false === stripos($f, '_full')) {
							$file = $f;
							break;
						}
					}
				}
			}
			if (!JFile::exists(JPATH_JMYLIFEIMAGEFILES.DS.$file)) {
				return '';
			}
			JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
			$helper = JmylifeUrlHelper::getInstance();
			return $helper->clean(JURI::root().'/images/jmylife/'.$file);
		}
		return '';
	}

	function getStoryAttachmentImagePath( $id )
	{
		if ( !is_numeric( $id ) || !defined( 'JPATH_JMYLIFEIMAGEFILES' ) || !JFolder::exists( JPATH_JMYLIFEIMAGEFILES ) )
		{
			return '';
		}
		$files = JFolder::files( JPATH_JMYLIFEIMAGEFILES, 'attachment_'.$id.'.' );
		if ( count( $files ) && JFile::exists( JPATH_JMYLIFEIMAGEFILES.DS.$files[0] ) )
		{
			return JPATH_JMYLIFEIMAGEFILES.DS.$files[0];
		}
		return '';
	}

	/**
	 * getSessionId
	 * @return  string
	 * @since   1.0.13
	 */
	function getSessionId()
	{
		$session =& JFactory::getSession();
		return $session->getId();
	}

	/**
	 * getRemoteData
	 * @param   string
	 * @param   array
	 * @return  string
	 * @since   1.0.11
	 */
	function getRemoteData($url, $data) {
		// TODO: rewrite this to allow POST data (not used currently)
		if (@ini_get('allow_url_fopen') && function_exists('file_get_contents') && !JmylifeCommon::_iscurlinstalled()) {
			return @file_get_contents($url);
		}
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_TIMEOUT, 120);
		// BUGFIX: safe_mode / open_basedir hates this
		if (!(@ini_get('open_basedir') || @ini_get('safe_mode'))) {
			@curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		}
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $url);
		if (0 < count($data)) {
			curl_setopt($ch, CURLOPT_POST, count($data));
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
		}
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; MSIE 7.0; Windows NT 6.0; en-US)");
		$result = curl_exec($ch);
		curl_close($ch);
		return $result;
	}


	function getStoryLinkPreviewData( $url )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$data = array();
		// fetch remote data
		$raw = JmylifeCommon::getRemoteData( $url, null );
		// parse title from data
		$data['title'] = preg_replace( '`.*?<title>(.*?)</title>.*`Ds', '$1', $raw );
		// shorten text
		$titlelimit = $_JMLConfig->getInt('storylink_title_limit',0);
		if ( 0 < $titlelimit )
		{
			JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
			$helper = JmylifeStringHelper::getInstance();
			$data['title'] = $helper->shorten( $data['title'], $titlelimit, false );
		}
		// parse description
		$data['description'] = ' ';
		if ( $_JMLConfig->getInt('storylink_desc_allow', 1) )
		{
			$metas = array();
			// get all meta tags
			// regex adapted from http://www.codeproject.com/KB/recipes/MetaTagParser.aspx
			preg_match_all('`(<meta\s*(?:(?:\b(?:\w|-)+\b\s*(?:=\s*(?:"[^"]*"|\'[^\']*\'|[^"\'<> ]+)\s*)?)*)/?\s*>)`Ds', $raw, $metas);
			// loop & find the meta tag for description
			if ( count( @$metas[0] ) )
			{
				foreach ( $metas[0] as $meta )
				{
					if ( preg_match( '`name\=\"description\"`', $meta ) )
					{
						$data['description'] = preg_replace('`.*content\=\"([^\"]*?)\".*?>`', '$1', $meta);
						break;
					}
				}
			}
			while ( is_array( $data['description'] ) )
			{
				$data['description'] = $data['description'][0];
			}
			if ( null == $data['description'] ) $data['description'] = ' ';
			// shorten text
			$desclimit = $_JMLConfig->getInt('storylink_desc_limit',0);
			if ( 0 < $desclimit )
			{
				JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
				$helper = JmylifeStringHelper::getInstance();
				$data['description'] = $helper->shorten( $data['description'], $desclimit, false );
			}
		}
		// go ahead & return here if not using images
		if ( 0 == $_JMLConfig->getInt( 'storylink_thumbnail' ) || 1 == JRequest::getInt('extra', 0) )
		{
			$data['images'] = array();
			return $data;
		}
		// parse images
		$images = array();
		preg_match_all( '`<img[^>]*?>`', $raw, $images );
		$images = $images[0];
		$thumbs = array();
		for ( $i=0 ; count( $images ) > $i ; $i++ )
		{
			$thumb = null;
			// only get images with alt tags
			if ( preg_match('`alt\=\"[^\"]*?\"`', $images[$i]) || preg_match('`alt\=\'[^\']*?\'`', $images[$i]) )
			{
				$thumb = preg_replace( '`.*src\=\"(.*?)\".*`', '$1', $images[$i] );
				$thumb = preg_replace( '`.*src\=\'(.*?)\'.*`', '$1', $thumb );
				// extra checks?
				$thumb = strip_tags($thumb);
				// append host to image if needed
				if ( !preg_match('`^https?\:\/{2}`', $thumb) )
				{
					if ( !preg_match('`^https?\:\/{2}.*?\/`', $url) )
					{
						$thumb = $url.'/'.$thumb;
					}
					else
					{
						$thumb = preg_replace('`(.*/)[^/]*$`', '$1', $url).$thumb;
					}
				}
				// don't bother with gif images as GD no longer supports them
				if ( preg_match( '`\.gif$`', strtolower( $thumb ) ) )
				{
					continue;
				}
				// load remote image & check file size of image
				$imgdata = JmylifeCommon::getRemoteData( $thumb, null );
				$tmpfile = md5( $imgdata );
				$imgtmp = JPATH_JMYLIFEIMAGEFILES.DS.$tmpfile;
				$keep = true;
				if ( JFile::write( $imgtmp, $imgdata ) )
				{
					$imageinfo = @getimagesize( $imgtmp );
					if ( !$imageinfo )
					{
						$keep = false;
					}
					if ( !is_int( $imageinfo[0] ) || 32 > $imageinfo[0] )
					{
						$keep = false;
					}
					if ( !is_int( $imageinfo[1] ) || 32 > $imageinfo[1] )
					{
						$keep = false;
					}
					JFile::delete( $imgtmp );
				}
				else
				{
					$keep = false;
				}
				if ( $keep )
				{
					JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
					$helper = JmylifeUrlHelper::getInstance();
					// clean & add to array
					$thumbs[] = $helper->clean( $thumb );
				}
			}
		}
		$data['images'] = array_values( array_unique( $thumbs ) );
		return $data;
	}

	/**
	 * resizeLinkAttachmentThumb
	 * @param   string
	 * @param   string
	 * @return  bool
	 * @since 1.0.13
	 */
	function resizeLinkAttachmentThumb( $file, $ext )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$width = $_JMLConfig->getInt( 'storylink_thumbwidth', 100 );
		$height = $_JMLConfig->getInt( 'storylink_thumbheight', 100 );
		JLoader::import('components.com_jmylife.helpers.image', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeImageHelper::getInstance();
		return $helper->resize( $file, $ext, $width, $height );
	}

	/**
	 * resizeImageAttachmentThumb
	 * @param   string
	 * @param   string
	 * @return  bool
	 * @since 1.0.13
	 */
	function resizeImageAttachmentThumb( $file, $ext )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$width = $_JMLConfig->getInt( 'storyimage_thumbwidth', 300 );
		$height = $_JMLConfig->getInt( 'storyimage_thumbheight', 200 );
		JLoader::import('components.com_jmylife.helpers.image', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeImageHelper::getInstance();
		return $helper->resize( $file, $ext, $width, $height );
	}

	/**
	 * resizeImageAttachment
	 * @param   string
	 * @param   string
	 * @return  bool
	 * @since 1.0.13
	 */
	function resizeImageAttachment( $file, $ext )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$width = $_JMLConfig->getInt( 'storyimage_width', 500 );
		$height = $_JMLConfig->getInt( 'storyimage_height', 400 );
		JLoader::import('components.com_jmylife.helpers.image', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeImageHelper::getInstance();
		return $helper->resize( $file, $ext, $width, $height );
	}

	/**
	 * _iscurlinstalled
	 * @return   bool
	 * @since    1.0.13
	 * @from     http://mywordpress.com/function-curl-php-extension-loaded/
	 *           ( shortened, of course )
	 */
	function _iscurlinstalled() {
		return in_array('curl', get_loaded_extensions());
	}

	/**
	 * redirect
	 * @param   string   url
	 * @param   string   message
	 * @param   string   message type
	 * @param   bool     use 301
	 * @since   1.0.13
	 *
	 * used to combat 301 cache behavior of certain browsers
	 */
	function redirect($url, $msg='', $msgType='message', $perm=true) {
		$appl = JFactory::getApplication();
		if ($perm || headers_sent()) {
			$appl->redirect($url, $msg, $msgType);
		} else {
			// pass message queue
			$queue = $appl->getMessageQueue();
			$session =& JFactory::getSession();
			if (0 < strlen($msg)) {
				$queue[] = array('message' => $msg, 'type' => strtolower($msgType));
				$session->set('application.queue', $queue);
			}
			header('Location: ' . $url, TRUE, 307);
			$appl->close();
		}
	}

	/**
	 * loadModal
	 */
	function loadModal() {
		if ('feed' == JRequest::getVar('format')) {
			return;
		}
		$libPath = JURI::root().'components/com_jmylife/libraries/';
		$document =& JFactory::getDocument();
		$document->addScript( $libPath.'jquery/nyroModal/js/jquery.nyroModal-1.6.2.pack.js' );
		$document->addStyleSheet( $libPath.'jquery/nyroModal/styles/nyroModal.full.css' );
	}

	/**
	 * loadWysiwygAssets
	 * @since   1.0.13
	 */
	function loadWysiwygAssets() {
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$document =& JFactory::getDocument();
		$assetPath = JURI::root().'components/com_jmylife/assets/';
		$libPath = JURI::root().'components/com_jmylife/libraries/';
		$wysiwyg = $_JMLConfig->getInt( 'use_wysiwyg', 0 ) == 1;
		$editorwidth = $_JMLConfig->getInt( 'editor_width', 300 );
		$editorheight = $_JMLConfig->getInt( 'editor_height', 180 );
		// add extras to document
		if ($wysiwyg) {
			// modal added in 1.0.11
			// this is so we can have "prompt()s" in IE without that annoying fucking security warning...
			// seriously Microsoft... the fuck?
			// regardless, this will make the wysiwyg a little prettier
			// at the expense of making it more complicated and prone to failure...
			// nyroModal to replace core modal
			JmylifeCommon::loadModal();
			if (1 == $_JMLConfig->getInt('wysiwyg_color')) {
				$document->addScript( $libPath.'jquery/colorpicker/js/colorpicker.js' );
				$document->addStyleSheet( $libPath.'jquery/colorpicker/css/colorpicker.css' );
				$document->addScriptDeclaration( '/* colorpicker */
jmlWYSIWYGColorPickerVisible = false;
(function($){
	$(document).ready(function() {
		var cPicker = $(\'<div id="jmlColorPicker"></div>\');
		var cPickerButton = $(\'#jmlWysiwygColorButton\');
		cPickerButton.after(cPicker);
		cPicker.css({left:cPickerButton.position().left}).hide().ColorPicker({
			flat: true,
			onShow: function(colpkr) {
				cPicker.height(173);
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function(colpkr) {
				$(colpkr).fadeOut(500, function(){
					cPicker.height( 0 );
				});
				return false;
			},
			onSubmit: function(hsb, hex, rgb, el) {
				cPicker.height(0);
				doColor(hex.toString().toUpperCase().replace(/^\#/,""));
				$(el).ColorPickerHide();
				jmlWYSIWYGColorPickerVisible = false;
			}
		});
		cPickerButton.click(function() {
			if (jmlWYSIWYGColorPickerVisible) {
				cPicker.stop().fadeOut(500, function(){
					cPicker.height(0);
				});
			} else {
				cPicker.height(173).stop().fadeIn(500);
			}
			jmlWYSIWYGColorPickerVisible = !jmlWYSIWYGColorPickerVisible;
		});
	});
})(window.jml.jQuery);' );
			}
			$editorScript = 'window.jml.jQuery(document).ready(function(){try{initEditor("fulltext");}catch(e){initEditor("comJMyLifeFulltext");}});';
			$document->addStyleSheet( $libPath.'wysiwyg/editor.css' );
			$document->addScript(JURI::root().'index.php?option=com_jmylife&controller=ajax&task=wysiwyg');
			$document->addScriptDeclaration('window.jmlWYSIWYG=1;'.$editorScript);
			$document->addStyleDeclaration( '#fulltext,#rte,#comJMyLifeStorySubmitText,#comJMyLifeStorySubmitText .editbar,#comJMyLifeFulltext{width:'.$editorwidth.'px !important;}#rte,#comJMyLifeFulltext{height:'.$editorheight.'px !important;}' );
		} else {
			$document->addScriptDeclaration('window.jmlWYSIWYG=0;');
			$document->addStyleDeclaration( '#fulltext#comJMyLifeStorySubmitText textarea{width:'.$editorwidth.'px !important;height:'.$editorheight.'px !important;}' );
		}
	}

	/**
	 * updateJomSocialActivity
	 * @param   string
	 * @param   int
	 * @param   int
	 * @param   int
	 */
	function updateJomSocialActivity( $cmd, $cid, $actor, $target=0 )
	{
		// try to load necessary class
		if( !class_exists( 'CFactory' ) )
		{
			$jomsocialcore = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'core.php';
			if( JFile::exists( $jomsocialcore ) )
				require_once( $jomsocialcore );
		}
		if( class_exists( 'CFactory' ) )
		{
			$act = new JmylifeJomSocialActivity( $cmd, $cid, $actor );
			CFactory::load( 'libraries', 'activities' );
			CActivityStream::add( $act );
		}
	}

	function attachmentBar()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$link  = $_JMLConfig->getInt('allow_storyattachment_link');
		$image = $_JMLConfig->getInt('allow_storyattachment_image');
		$video = $_JMLConfig->getInt('allow_storyattachment_video');
		// if in admin panel don't limit any options
		$appl =& JFactory::getApplication();
		if ( $appl->isAdmin() )
		{
			$link  = true;
			$image = true;
			//$video = $_JMLConfig->getInt('allow_storyattachment_video');
		}
		// I hate this... but apparently I can't use the buffer in a module?
		return '<!-- attachment bar -->
		<div id="comJMyLifeAttachment">
			<div id="comJMyLifeAttachmentItem">
				<div id="comJMyLifeAttachmentHeader">
					<input type="button" id="attachClose" />
					<span class="header"></span>
					<div class="jmlClear"></div>
				</div>
				<div id="comJMyLifeAttachmentArea">'.
($link ?'<div class="attachmentArea" id="jmylifeAttachLinkArea"></div>' :'').
($image?'<div class="attachmentArea" id="jmylifeAttachImageArea"></div>':'').
($video?'<div class="attachmentArea" id="jmylifeAttachVideoArea"></div>':'').
'				</div>
			</div>
			<div id="comJMyLifeAttachmentButtons">
				<span class="label">'.JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_ATTACH').' : </span>'.
($link ?'<input type="button" class="attachButton" id="jmylifeAttachLinkButton"  value="'.JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_LINK' ).'" />':'').
($image?'<input type="button" class="attachButton" id="jmylifeAttachImageButton" value="'.JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_IMAGE').'" />':'').
($video?'<input type="button" class="attachButton" id="jmylifeAttachVideoButton" value="'.JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_VIDEO').'" />':'').
'			</div>
		</div>
		<div class="jmlClear"></div>';
	}

	/**
	 * DEPRECIATED
	 * these functions had their code transplanted into helpers
	 * all instances of these functions should be removed later
	 */
	/* replaced by JmylifeHtmlHelper */
	function buildLink( $href, $text, $attributes=null ) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->link($href, $text, $attributes);
	}
	function alert($string) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->alert($string);
	}
	function clean($str='', $quotes=ENT_QUOTES, $charset='UTF-8') {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->clean($str, $quotes, $charset);
	}
	function unclean($str='', $quotes=ENT_QUOTES, $charset='UTF-8') {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->unclean($str, $quotes, $charset);
	}
	function parseBBCode($str, $strip=false) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->fromBB($str, $strip);
	}
	/* replaced by JmylifeEmailHelper */
	function sendMail($email, $body, $subject, $html=false) {
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		$mail = JmylifeEmailHelper::getInstance();
		$mail->send($email, $body, $subject, $html);
	}
	function notifyAuthorPending($sid, $email) {
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		$mail = JmylifeEmailHelper::getInstance();
		$mail->authorPending($sid, $email);
	}
	function notifyAuthorPublished($sid, $email) {
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		$mail = JmylifeEmailHelper::getInstance();
		$mail->authorPublished($sid, $email);
	}
	function notifyCommentSubscribers($cid) {
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		$mail = JmylifeEmailHelper::getInstance();
		$mail->commentSubscribers($cid);
	}
	/* replaced by JmylifeVersionHelper */
	function checkForUpdate($force=false) {
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeVersionHelper::getInstance();
		return $helper->checkForUpdate($force);
	}
	function updateBar() {
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeVersionHelper::getInstance();
		return $helper->updateBar();
	}
	function getCurrentVersion() {
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeVersionHelper::getInstance();
		return $helper->getCurrentVersion();
	}
	function getComparedVersions() {
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeVersionHelper::getInstance();
		return $helper->getComparedVersions();
	}
	/* replaced by JmylifeCaptchaHelper */
	function reloadcaptcha() {
		JLoader::import('components.com_jmylife.helpers.captcha', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCaptchaHelper::getInstance();
		return $helper->reload();
	}
	function recaptchascript() {
		JLoader::import('components.com_jmylife.helpers.captcha', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCaptchaHelper::getInstance();
		return $helper->recaptchascript();
	}
	function displaycaptcha() {
		JLoader::import('components.com_jmylife.helpers.captcha', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCaptchaHelper::getInstance();
		return $helper->display();
	}
	function captchasnet() {
		JLoader::import('components.com_jmylife.helpers.captcha', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCaptchaHelper::getInstance();
		return $helper->captchasnet();
	}
	/* replaced by JmylifeStoryHelper */
	function buildStoryQuery($request, $published=1, $goodonly=0, $countonly=0) {
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStoryHelper::getInstance();
		return $helper->buildQuery($request, $published, $goodonly, $countonly);
	}
	function prepareStory($object, $view, $break=true) {
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStoryHelper::getInstance();
		return $helper->prepare($object, $view, $break);
	}
	function prepareStoryList($list, $view, $break=true) {
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStoryHelper::getInstance();
		return $helper->prepareList($list, $view, $break);
	}
	/* replaced by JmylifeStringHelper */
	function breakLongWords($str) {
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStringHelper::getInstance();
		return $helper->breakLongWords($str);
	}
	function shortenText($text, $count, $addbb=true) {
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStringHelper::getInstance();
		return $helper->shorten($text, $count, $addbb);
	}
	function filterWords($str) {
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStringHelper::getInstance();
		return $helper->filterWords($str);
	}
	function replaceStubs($text, $id, $type='story') {
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStringHelper::getInstance();
		return $helper->stubs($text, $id, $type);
	}
	function replaceEmailStubs($text, $id, $type='story') {
		return JmylifeCommon::replaceStubs($text, $id, $type);
	}
	/* replaced by JmylifeItemidHelper */
	function getStoryItemid($story, $random=0) {
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeItemidHelper::getInstance();
		return $helper->story($story, $random);
	}
	function getCategoryItemid($catid, $sort='none') {
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeItemidHelper::getInstance();
		return $helper->category($catid, $sort);
	}
	function getViewItemid($view) {
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeItemidHelper::getInstance();
		return $helper->view($view);
	}
	/* replaced by JmylifeImageHelper */
	function validateImage($file) {
		JLoader::import('components.com_jmylife.helpers.image', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeImageHelper::getInstance();
		return $helper->validate($file);
	}
	function resizeImage($file, $ext, $width, $height) {
		JLoader::import('components.com_jmylife.helpers.image', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeImageHelper::getInstance();
		return $helper->resize($file, $ext, $width, $height);
	}
	/* replaced by JmylifeUrlHelper */
	function cleanUrl($string='', $urlencode=false) {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->clean($string, $urlencode);
	}
	function validateUrl($url) {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->validate($url);
	}
	function urlAppendChar($url) {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->q($url);
	}
	function isUrlAvailable($url) {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->isAvailable($url);
	}
	/* replaced by JmylifeCommentHelper */
	function buildCommentsQuery($id, $published=1, $latest=false) {
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCommentHelper::getInstance();
		return $helper->buildQuery($id, $published, $latest);
	}
	function buildSingleCommentQuery($id) {
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCommentHelper::getInstance();
		return $helper->buildQueryById($id);
	}
	function prepareComment($object, $view='') {
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCommentHelper::getInstance();
		return $helper->prepare($object, $view);
	}
	function prepareCommentList($list, $view='') {
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCommentHelper::getInstance();
		return $helper->prepareList($list, $view);
	}

	/* end common */
}

/**
 * jomsocial activity class
 * @since 1.0.12
 */
class JmylifeJomSocialActivity
{
	var $cmd;
	var $actor;
	var $target;
	var $title;
	var $content;
	var $app;
	var $cid;
	var $params;

	function __construct( $cmd, $cid, $actor, $target=0 )
	{
		$this->cmd = $cmd;
		$this->actor = $actor;
		$this->target = $target;
		$this->cid = $cid;
		$this->title = $this->getTitle( $cmd, $cid );
		$this->content = '';
		$this->app = 'jmylife';
		$this->params = '';
	}

	function getTitle( $cmd, $cid )
	{
		$title = '';
		$type = 'story';
		switch( $cmd )
		{
			case 'story.published':
				$title = JText::_('COM_JMYLIFE_JOMSOCIAL_ACTIVITY_STORYPUBLISHED');
				break;
			case 'story.favorite':
				$title = JText::_('COM_JMYLIFE_JOMSOCIAL_ACTIVITY_STORYFAVORITE');
				break;
			case 'comment.published':
				$title = JText::_('COM_JMYLIFE_JOMSOCIAL_ACTIVITY_COMMENTPUBLISHED');
				$type = 'comment';
				break;
		}
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStringHelper::getInstance();
		return $helper->stubs($title, $cid, $type);
	}
}