<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2010 Jeff Channell
 * libraries/jquery/datepicker/loader.php
 * @license    GNU/GPL
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// load JMyLife language
$language = JFactory::getLanguage();
$language->load('com_jmylife', JPATH_SITE);
// get document & app
$app = JFactory::getApplication();
$document = JFactory::getDocument();
// build language variable for datepicker
$dplang = array(
	'clear' => JText::_('COM_JMYLIFE_DATEPICKER_CLEAR'),
	'close' => JText::_('COM_JMYLIFE_DATEPICKER_CLOSE'),
	'current' => JText::_('COM_JMYLIFE_DATEPICKER_CURRENT'),
	'dateformat' => JText::_('COM_JMYLIFE_DATEPICKER_DATEFORMAT'),
	// this is ultra-lame... coding around it for now, may change in future...
	'days' => array(
		'sun' => JText::_('COM_JMYLIFE_DATEPICKER_DAYS_SUNDAY'),
		'mon' => JText::_('COM_JMYLIFE_DATEPICKER_DAYS_MONDAY'),
		'tue' => JText::_('COM_JMYLIFE_DATEPICKER_DAYS_TUESDAY'),
		'wed' => JText::_('COM_JMYLIFE_DATEPICKER_DAYS_WEDNESDAY'),
		'thu' => JText::_('COM_JMYLIFE_DATEPICKER_DAYS_THURSDAY'),
		'fri' => JText::_('COM_JMYLIFE_DATEPICKER_DAYS_FRIDAY'),
		'sat' => JText::_('COM_JMYLIFE_DATEPICKER_DAYS_SATURDAY')
	),
	'done' => JText::_('COM_JMYLIFE_DATEPICKER_DONE'),
	// see note about days above
	'months' => array(
		'long' => array(
			'jan' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_JANUARY'),
			'feb' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_FEBRUARY'),
			'mar' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_MARCH'),
			'apr' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_APRIL'),
			'may' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_MAY'),
			'jun' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_JUNE'),
			'jul' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_JULY'),
			'aug' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_AUGUST'),
			'sep' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_SEPTEMBER'),
			'oct' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_OCTOBER'),
			'nov' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_NOVEMBER'),
			'dec' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_LONG_DECEMBER')
		),
		'short' => array(
			'jan' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_JANUARY'),
			'feb' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_FEBRUARY'),
			'mar' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_MARCH'),
			'apr' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_APRIL'),
			'may' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_MAY'),
			'jun' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_JUNE'),
			'jul' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_JULY'),
			'aug' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_AUGUST'),
			'sep' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_SEPTEMBER'),
			'oct' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_OCTOBER'),
			'nov' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_NOVEMBER'),
			'dec' => JText::_('COM_JMYLIFE_DATEPICKER_MONTH_SHORT_DECEMBER')
		)
	),
	'next' => JText::_('COM_JMYLIFE_DATEPICKER_NEXT'),
	'picker' => array(
		'allafter' => JText::_('COM_JMYLIFE_DATEPICKER_PICKER_ALLAFTER'),
		'allbefore' => JText::_('COM_JMYLIFE_DATEPICKER_PICKER_ALLBEFORE'),
		'date' => JText::_('COM_JMYLIFE_DATEPICKER_PICKER_DATE'),
		'range' => JText::_('COM_JMYLIFE_DATEPICKER_PICKER_RANGE')
	),
	'prev' => JText::_('COM_JMYLIFE_DATEPICKER_PREV'),
	'ranges' => array(
		'all' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_ALL'),
		'allafter' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_ALLAFTER'),
		'allbefore' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_ALLBEFORE'),
		'days' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_DAYS'),
		'last12m' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_LAST12M'),
		'last30d' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_LAST30D'),
		'last7d' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_LAST7D'),
		'months' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_MONTHS'),
		'pastx' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_PASTX'),
		'range' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_RANGE'),
		'specific' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_SPECIFIC'),
		'ytd' => JText::_('COM_JMYLIFE_DATEPICKER_RANGE_YTD')
	),
	'splitter' => JText::_('COM_JMYLIFE_DATEPICKER_SPLITTER'),
	'today' => JText::_('COM_JMYLIFE_DATEPICKER_TODAY')
);
// ensure jQuery is loaded
// no longer using JRoute because admin routing fucks it all up
$jQuery = 'index.php?option=com_jmylife&controller=ajax&task=jQuery';
if ($app->isAdmin()) {
	$document->addScript(JURI::root().$jQuery);
} else {
	$document->addScript(JRoute::_($jQuery, false));
}
// add language to script using json object
$document->addScriptDeclaration('window.jml.dp = {text:'.json_encode($dplang).'};');
$document->addScript(JURI::root().'components/com_jmylife/libraries/jquery/datepicker/datepicker.js');
$document->addStyleSheet(JURI::root().'components/com_jmylife/libraries/jquery/datepicker/datepicker.css');