<?php
/**
 * Favorites Model for JMyLife Component
 *
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/models/favorites.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.model' );

/**
 * Favorites Model
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeModelFavorites extends JModel
{
	/**
	 * favorites
	 * @var stdClass
	 */
	var $_data = null;

	/**
	 * Items total - for pagination
	 * @var integer
	 */
	var $_total = null;

	/**
	 * Pagination object
	 * @var object
	 */
	var $_pagination = null;

	/**
	 * contructor
	 */
	function __construct()
	{
		parent::__construct();

		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// since 1.0.5 this check is here instead of template
		$user =& JFactory::getUser();
		if( $user->guest )
		{
			// get link for item from menu
			$_JMLConfig->db->setQuery( 'SELECT `link` FROM `#__menu` WHERE `id` = '.intval( $_JMLConfig->get( 'signupitem' ) ), 0, 1 );
			// if no link use /
			if( !( $link = $_JMLConfig->db->loadResult() ) )
				$link = JURI::base();
			else if( !preg_match( '`Itemid`', $link ) )
				$link .= ( preg_match( '`\?`', $link ) ? '&' : '?' ).'Itemid='.intval( $_JMLConfig->get( 'signupitem' ) );
			// lowercase for 1.6
			$appl->enqueuemessage( JText::_('COM_JMYLIFE_ERROR_STORY_NOGUESTFAVORITE') );
			$appl->redirect( JRoute::_( $link, false ) );
		}
		//$params	=& $appl->getParams( 'com_jmylife' );

		// Get pagination request variables
		$limit = (int)$_JMLConfig->get( 'page_limit' );
		$limitstart = JRequest::getVar( 'limitstart', 0, '', 'int' );

		// In case limit has been changed, adjust it
		$limitstart = ( $limit != 0 ? ( floor( $limitstart / $limit ) * $limit ) : 0 );

		$this->setState( 'limit', $limit );
		$this->setState( 'limitstart', $limitstart );
  }

	/**
	 * gets list (override for long word handling)
	 * @return object list
	 * @since 1.0.4
	 * @renamed 1.0.5
	 */
	function _jmlGetList( $query, $limitstart, $limit )
	{
		$list = parent::_getList( $query, $limitstart, $limit );
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$story = JmylifeStoryHelper::getInstance();
		return $story->prepareList( $list, 'favorites' );
	}

	/**
	 * Gets the item data
	 * @return stdClass object of listings
	 *
	 * @todo use Joomla Tables instead of simple queries
	 */
	function getData()
	{
		// Load the content if it doesn't already exist
		if( empty( $this->_data ) )
		{
			JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
			$story = JmylifeStoryHelper::getInstance();
			$query = $story->buildQuery( JRequest::get() );
			$this->_data = $this->_jmlGetList( $query, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
		}
		return $this->_data;
	}

	/**
	 * Gets the total amount of listings
	 * @return int
	 */
	function getTotal()
	{
		// Load the content if it doesn't already exist
		if( empty( $this->_total ) )
		{
			JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
			$story = JmylifeStoryHelper::getInstance();
			$query = $story->buildQuery(JRequest::get(), 1, 0, 1);
			$this->_total = $this->_getListCount( $query );
		}
		return $this->_total;
	}

	/**
	 * Gets the listings pagination
	 * @return JPagination object
	 */
	function getPagination()
	{
		// Load the content if it doesn't already exist
		if( empty( $this->_pagination ) )
		{
			jimport( 'joomla.html.pagination' );
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
		}
		return $this->_pagination;
	}

	/**
	 * Gets the hidden inputs for the form
	 * @return string
	 */
	function getFields()
	{
		global $option, $view;
		// hack for now, fix later...
		$fields = '<input type="hidden" name="option" value="'.htmlentities($option).'" />'
		        . '<input type="hidden" name="view"   value="'.htmlentities($view).'" />'
		        ;
		return $fields;
	}

}
