<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/router.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
if( !class_exists( 'JmylifeConfiguration' ) )
{
	jimport('joomla.filesystem.file');
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if( JFile::exists( $configfile ) ) require_once( $configfile );
}
// load language files no matter what
$language =& JFactory::getLanguage();
$language->load( 'com_jmylife', JPATH_SITE );

// TODO: try to resolve non-matching SEF urls for menus/non-menus

// component build route
function JmylifeBuildRoute(&$query) {
	$_JMLConfig = JmylifeConfiguration::getInstance();
	$segments = array();
	// get a menu item based on Itemid or currently active - since 1.0.3
	$menu = &JSite::getMenu();
	if (empty($query['Itemid'])) {
		$menuItem = &$menu->getActive();
	} else {
		$menuItem = &$menu->getItem($query['Itemid']);
	}
	// this check added in 1.0.2 - thanks lafrance!
	if (isset($query['view'])) {
		switch (strtolower($query['view'])) {
			case 'list':
				if (isset($query['catid']) && $query['catid']) {
					$catid = (int)$query['catid'];
					if (is_numeric($query['catid'])) {
						$sql = "SELECT `name` FROM #__jmylife_categories WHERE id = {$catid}";
						$_JMLConfig->db =& JFactory::getDBO();
						$_JMLConfig->db->setQuery($sql, 0, 1);
						$category = $_JMLConfig->db->loadResult();
						if ($category && !(preg_match('+[@:/\n\r\t\a\e\f\v\x00_]+', $category) || is_numeric($category))) {
							$query['catid'] = str_replace('.', '_', $category);		// a dot (.) in a category is mishandled by the dot htaccess of joomla 1.5
							$query['catid'] = JFilterOutput::stringURLSafe($query['catid']);
						}
					}
					// commented out in 1.0.11 as it's unnecessary
					//$segments[] = 'category';
					// verify that we're not already in this category
					if ((int)@$menuItem->query['catid'] != $catid) {
						$segments[] = JFilterOutput::stringURLSafe(strtolower($query['catid']));
					}
				}
				// this shouldn't be an 'else' - 1.0.11
				if (isset($query['sort']) && $query['sort']) {
					switch (strtolower($query['sort'])) {
						// handle "none"
						case 'none':
							break;
						case 'best':
							$segments[] = strtolower(JText::_('COM_JMYLIFE_SEF_BEST'));
							break;
						case 'worst':
							$segments[] = strtolower(JText::_('COM_JMYLIFE_SEF_WORST'));
							break;
						case 'vote':
							if ('asc' == $query['sortdir']) {
								$segments[] = strtolower(JText::_('COM_JMYLIFE_SEF_WORST'));
							} else {
								$segments[] = strtolower(JText::_('COM_JMYLIFE_SEF_BEST'));
							}
							break;
						default:
							// handle cb field sorting
							if (preg_match('`^cb_`', $query['sort'])) {
								// since this is a menu param only, leave out until there's a need
							}
							break;
					}
				}
				if (isset($query['range1'])) {
					$segments[] = JFilterOutput::stringURLSafe(sprintf('%s::%s', $query['range1'].'', @$query['range2'].''));
					unset ($query['range1']);
					unset ($query['range2']);
				}
				// moved in 1.0.11 to combat catid=0 bug when default menu item = jmylife
				unset( $query['catid'] );
				unset( $query['sort'] );
				break;
			case 'item':
				$segments[] = JFilterOutput::stringURLSafe(strtolower(JText::_('COM_JMYLIFE_SEF_STORY')));
				if (isset($query['id']) && (int)$query['id'] > 0) {
					$segment = '';
					$id = intval($query['id']);
					// old sef used id #, but now allow for story slug
					if ($_JMLConfig->getInt('sef_storyslug', 0)) {
						$_JMLConfig->db->setQuery("SELECT `title`, `user_alias` FROM `#__jmylife_stories` WHERE `id`={$id} LIMIT 1");
						if ($story = $_JMLConfig->db->loadObject()) {
							$titletext = '';
							if ($_JMLConfig->getInt('allow_titles')) {
								$titletext = $story->title;
							}
							if (0 == strlen($titletext)) {
								$titletext = JText::sprintf('COM_JMYLIFE_STORY_TITLE', $story->user_alias);
							}
							$segment = JFilterOutput::stringURLSafe( $id.'-'.$titletext );
						}
					}
					if (0 == $_JMLConfig->getInt('sef_storyslug', 0) || 0 == strlen($segment)) {
						$segment = $id;
					}
					$segments[] = $segment;
					if (isset($query['layout']) && 'edit' == @$query['layout'].'') {
						$segments[] = JFilterOutput::stringURLSafe(strtolower(JText::_('COM_JMYLIFE_SEF_STORY_EDIT')));
						unset($query['layout']);
					}
				}
				else if (isset($query['random']) && $query['random']) {
					$segments[] = JFilterOutput::stringURLSafe(strtolower(JText::_('COM_JMYLIFE_SEF_RANDOM')));
				}
				unset($query['id']);
				unset($query['random']);
				break;
			case 'submit':
			case 'favorites':
			case 'moderate':
			case 'categories':
				// only add this segment if needed
				if (strtolower(@$menuItem->query['view']) != strtolower($query['view'])) {
					$segments[] = strtolower(JText::_('COM_JMYLIFE_SEF_'.strtoupper($query['view'])));
				}
				break;
			default:
				break;
		}
		unset($query['view']);
	}
	return $segments;
}

// component parse route
function JmylifeParseRoute($segments) {
	$_JMLConfig = JmylifeConfiguration::getInstance();
	//Get the active menu item
	$menu =& JSite::getMenu();
	$item =& $menu->getActive();
	// var init
	$count = count($segments);
	$vars  = array();
	// routing completely rewritten for 1.0.3
	// and again in 1.0.11 ;)
	if ($count > 0) {
		$segment = strtolower($segments[0]);
		if (strtolower(JText::_('COM_JMYLIFE_SEF_MODERATE')) == $segment) {
			$vars['view'] = 'moderate';
			return $vars;
		}
		if (strtolower(JText::_('COM_JMYLIFE_SEF_FAVORITES')) == $segment) {
			$vars['view'] = 'favorites';
			return $vars;
		}
		if (strtolower(JText::_('COM_JMYLIFE_SEF_SUBMIT')) == $segment) {
			$vars['view'] = 'submit';
			return $vars;
		}
		if (strtolower(JText::_('COM_JMYLIFE_SEF_CATEGORIES')) == $segment) {
			$vars['view'] = 'categories';
			return $vars;
		}
		if (strtolower(JText::_('COM_JMYLIFE_SEF_STORY')) == $segment) {
			$vars['view'] = 'item';
			$next = strtolower($segments[1]);
			if (strtolower(JText::_('COM_JMYLIFE_SEF_RANDOM')) == $next) {
				$vars['random'] = 1;
			}
			// not random, get story
			else {
				// parse out slug
				$vars['id'] = intval(preg_replace('`^([0-9]+).*?`', '$1', $next));
			}
			// are we editing?
			if (strtolower(JText::_('COM_JMYLIFE_SEF_STORY_EDIT')) == strtolower(@$segments[2].'')) {
				$vars['layout'] = 'edit';
			}
			return $vars;
		}
		// so far, so good - if we've gotten this far, it must be a list, right?
		// first, "fix" segment
		$vars['view'] = 'list';
		$segment = preg_replace(
			array( '`[\.\{\}\[\]\?\`\~\!\@\#\$\%\^\&\*\(\)\-\_\=\+\\\|]`', '`\:`', '`\%+`' ),
			'%',
			'%'.$segment.'%'
		);
		$_JMLConfig->db->setQuery('SELECT `id` FROM `#__jmylife_categories` WHERE LOWER(`name`) LIKE '.$_JMLConfig->db->Quote( $segment ).' LIMIT 1');
		if (!($catid = $_JMLConfig->db->loadResult())) {
			$catid = 0;
		}
		$vars['catid'] = intval($catid);
		// check for sort order
		if (array_search(strtolower(JText::_('COM_JMYLIFE_SEF_BEST')), $segments)) {
			$vars['sort'] = 'best';
		}
		else if (array_search(strtolower(JText::_('COM_JMYLIFE_SEF_WORST')), $segments)) {
			$vars['sort'] = 'worst';
		}
		if (!isset($vars['sort'])) {
			$vars['sort'] = 'none';
		}
		// step through segments & see if any look like ranges
		foreach ($segments as $segment) {
			if (false !== strpos('::', $segment)) {
				$ranges = explode('::', $segment, 2);
				$vars['range1'] = $ranges[0];
				$vars['range2'] = $ranges[1];
			}
		}
	}
	return $vars;
}