<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/CHANGELOG.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since      1.0.8
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// ------------------  standard plugin initialize function - don't change ---------------------------
global $sh_LANG, $mainframe;
$sefConfig = & shRouter::shGetConfig();
$shLangName = '';
$shLangIso = '';
$title = array();
$shItemidString = '';
// this isn't used any more?
$params	=& $mainframe->getParams( 'com_jmylife' );
$dosef = shInitializePlugin( $lang, $shLangName, $shLangIso, $option);
if ($dosef == false) return;
$language =& JFactory::getLanguage();
// load language from component
$language->load( 'com_jmylife', JPATH_SITE );
require_once( JPATH_SITE.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php' );
$_JMLConfig = JmylifeConfiguration::getInstance();

// ------------------  standard plugin initialize function - don't change ---------------------------

// ------------------  load language file - adjust as needed ----------------------------------------
//$shLangIso = shLoadPluginLanguage( 'com_XXXXX', $shLangIso, '_SEF_SAMPLE_TEXT_STRING');
// ------------------  load language file - adjust as needed ----------------------------------------

// remove common URL from GET vars list, so that they don't show up as query string in the URL
shRemoveFromGETVarsList('option');
shRemoveFromGETVarsList('lang');
if (!empty($Itemid)) shRemoveFromGETVarsList('Itemid');
if (!empty($limit)) shRemoveFromGETVarsList('limit');
/*
NOTE: as JMyLife doesn't bother with user-selected limitstart
this needs to be handled manually
if (isset($limitstart))
  shRemoveFromGETVarsList('limitstart'); // limitstart can be zero
*/

// start by inserting the menu element title (just an idea, this is not required at all)
foreach (array('view', 'task', 'id', 'controller', 'layout', 'sort', 'sortdir', 'random', 'format', 'Itemid') as $var) {
	$$var = isset($$var) ? @$$var : null;
}
$shJMyLife = shGetComponentPrefix($option);
$shJMyLife = empty($shJMyLife) ? getMenuTitle($option, $task, $Itemid, null, $shLangName) : $shJMyLife;
$shJMyLife = (empty($shJMyLife) || $shJMyLife == '/') ? JText::_('COM_JMYLIFE_SEF_JMYLIFE') : $shJMyLife;

// check against menu item
$db =& JFactory::getDBO();
$db->setQuery( 'SELECT id FROM #__menu WHERE `link` LIKE "%com_jmylife%" AND `home` = 1' );
if (!($db->loadResult())) {
	$title[] = $_JMLConfig->get('jmylife_name', JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_SITENAME'));
}

switch( $view )
{
	case 'categories':
		$title[] = JText::_('COM_JMYLIFE_SEF_CATEGORIES');
		shRemoveFromGETVarsList( 'view' );
	break;

	case 'favorites':
		$title[] = JText::_('COM_JMYLIFE_SEF_FAVORITES');
		shRemoveFromGETVarsList( 'view' );
	break;

	case 'moderate':
		$title[] = JText::_('COM_JMYLIFE_SEF_MODERATE');
		shRemoveFromGETVarsList( 'view' );
	break;

	case 'submit':
		$title[] = JText::_('COM_JMYLIFE_SEF_SUBMIT');
		shRemoveFromGETVarsList( 'view' );
		if ('attach' == $layout) {
			$title[] = JText::_('COM_JMYLIFE_SEF_SUBMIT_ATTACH');
			shRemoveFromGETVarsList('layout');
		}
	break;

	case 'item':
	  if (!empty($id) || 0 < (int)$id ) {
			$title[] = JText::_('COM_JMYLIFE_SEF_STORY');
			// slug
			if ($_JMLConfig->getBool('sef_storyslug')) {
				$id = intval($id);
				$_JMLConfig->db->setQuery("SELECT `title`, `user_alias` FROM `#__jmylife_stories` WHERE `id`={$id} LIMIT 1");
				if ($story = $_JMLConfig->db->loadObject()) {
					$titletext = '';
					if ($_JMLConfig->getBool('allow_titles')) {
						$titletext = $story->title;
					}
					if (0 == strlen($titletext)) {
						$titletext = JText::sprintf('COM_JMYLIFE_STORY_TITLE', $story->user_alias);
					}
					$title[] = JFilterOutput::stringURLSafe($id.'-'.$titletext);
					shRemoveFromGETVarsList('id');
				}
			}
    }
    else if (0 == (int)$id && 1 == (int)$random) {
			$title[] = JText::_('COM_JMYLIFE_SEF_RANDOM');
      shRemoveFromGETVarsList('random');
    }
    if ('raw' == $format) {
			$title[] = JText::_('COM_JMYLIFE_SEF_RAW');
      shRemoveFromGETVarsList('format');
		}
    shRemoveFromGETVarsList('view');
	break;

	default:
		// check for ajax controller
		if ('ajax' == $controller) {
			switch ($task) {
				case 'votegood':
				case 'votebad':
				case 'favorite':
				case 'unfavorite':
				case 'report':
				case 'getcomment': // bugfix in 1.0.9
				case 'emailfriend':
				case 'sendfriend':
				case 'getlatestcomments': // added in 1.0.10
				case 'reportstory': // added in 1.0.10
				case 'wysiwyg': // added in 1.0.11
				case 'moderatestory': // added in 1.0.11
				case 'jQuery':
				case 'share':
					$title[] = ucwords($task);
				break;
				default:
					$title[] = 'ajax';
				break;
			}
			shRemoveFromGETVarsList('task');
			shRemoveFromGETVarsList('controller');
			// break out of switch
			break;
		}
		// handle sorting
		if ('best' == $sort || 'worst' == $sort) {
			$title[] = JText::_('COM_JMYLIFE_SEF_'.strtoupper($sort));
			shRemoveFromGETVarsList('catid');
		}
		else if ('vote' == $sort) {
			$title[] = $sortdir == 'asc' ? JText::_('COM_JMYLIFE_SEF_WORST') : JText::_('COM_JMYLIFE_SEF_BEST');
			shRemoveFromGETVarsList('catid');
		}
		// TODO: is this else necessary?
		else {
			if (!empty($catid) && 0 < (int)$catid) {
				$q = 'SELECT id, name FROM #__jmylife_categories WHERE id = '.(int)$catid;
				$db->setQuery($q);
				if (shTranslateUrl($option, $shLangName)) {
					$jmlTitle = $db->loadObject();
				} else {
					$jmlTitle = $db->loadObject(false);
				}
				if ($jmlTitle) {
					$title[] = $jmlTitle->name;
      		shRemoveFromGETVarsList('catid');
      	}
			} else {
				shRemoveFromGETVarsList('catid');
			}
		}
		shRemoveFromGETVarsList('view');
		shRemoveFromGETVarsList('sort');
	break;
}
if (0 === $Itemid) {
	shRemoveFromGETVarsList('Itemid');
}
// ------------------  standard plugin finalize function - don't change ---------------------------
if ($dosef){
   $string = shFinalizePlugin( $string, $title, $shAppendString, $shItemidString,
      (isset($limit) ? @$limit : null), (isset($limitstart) ? @$limitstart : null),
      (isset($shLangName) ? @$shLangName : null));
}
// ------------------  standard plugin finalize function - don't change ---------------------------