<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/item/tmpl/default.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined('_JEXEC') or die('Restricted access');
// user
$user =& JFactory::getUser();
$isStory = $this->item->id > 0;// && strlen( $this->item->fulltext ) > 0;
?>
<form method="post" name="jmylifeForm" action="<?php echo JRoute::_( 'index.php' ); ?>">
<div class="comJMyLifeItem jmylifeRound" <?php echo $this->item->style; ?>><?php
	// if ID isn't found, only show an error
	if( !$isStory ) :
		echo JText::_('COM_JMYLIFE_ERROR_STORY_NOID');
	else:
		// edit button
		if ($this->item->viewerCanEdit) {
			echo $this->html->link($this->item->editlink, $this->html->image(JURI::root().'images/M_images/edit.png', array('alt' => 'edit')), array('class' => 'jmlEditLink'));
		}
		// graphical voting since 1.0.10
		if( $this->item->show_votes && $this->params->getInt( 'graphical_voting', 0 ) == 1 ): ?>
		<div class="comJMyLifeGraphicalVote">
			<?php echo JmylifeCommon::graphicvote( $this->item ); ?>
		</div>
		<?php endif;
		// since 1.0.5 optional title
		if( $this->params->getInt( 'allow_titles' ) == 1 && strlen( $this->item->title ) > 0 ) : ?>
		<div class="comJMyLifeItemTitle">
			<?php
				if( $this->params->getInt( 'link_titles' ) == 1 ) : ?>
				<a href="<?php echo $this->item->storylink; ?>"><?
					echo $this->item->title;
				?></a><?php
				else:
					echo $this->item->title;
				endif;
			?>
		</div><?php
		endif;
		// end title

		// since 1.0.13 add attachment
		if ( 0 < $this->params->getInt( 'allow_storyattachment', 0 ) ) : ?>
		<div class="comJMyLifeItemAttachment"><?php
			// load item attachment template
			echo $this->loadTemplate( $this->item->attachment_type );
		?>
		</div>
		<?php
		endif;
		// end attachment

		// since 1.0.9 add avatar
		$linkavatar = strlen( $this->item->profile_path ) && $this->params->allow->cb && $this->params->getInt( 'link_story_avatar', 0 ) == 1;
		if( $this->params->getInt( 'social_engine', 0 ) > 0 && $this->params->getInt( 'show_story_avatar' ) ): ?>
		<div class="comJMyLifeItemAvatar"><?php
			if( $linkavatar ) : ?><a href="<?php echo $this->item->profile_path; ?>"><?php endif; ?>
			<img src="<?php echo $this->item->avatar_image; ?>" alt="<?php if( $this->params->getInt( 'disable_avatar_alt' ) == 0 ) echo $this->item->user_alias; ?>" /><?php
			if( $linkavatar ) : ?></a><?php endif; ?>
		</div>
		<?php
		endif;
		?>
		<div class="comJMyLifeItemText<?php if( $this->item->show_votes && $this->params->getInt( 'graphical_voting', 0 ) == 1 ) echo ' jmlGraphicText'; ?>">
			<?php
				// added in 1.0.6
				echo '<span class="comJMyLifeItemPretext">'.$this->params->get( 'story_pretext' ).' </span>';
				// since 1.0.5 this is preprocessed
				echo $this->item->fulltext;
				// added in 1.0.6
				echo '<span class="comJMyLifeItemPosttext"> '.$this->params->get( 'story_posttext' ).'</span>';
				?>
		</div>
		<div class="comJMyLifeItemReadComments">
			<a href="<?php
				echo $this->item->storylink;
				if( $this->item->show_comments && $this->params->getInt('comment_counts') == 1 && $this->params->getInt('comment_engine') == 3 )
				{
					echo '#disqus_thread';
				}
			?>" rel="<?php echo $this->item->id; ?>"><?php
				// since 1.0.5 this link is dynamic depending on comment status
				if( $this->item->show_comments && $this->params->getInt('comment_counts') == 1 )
					echo $this->params->get('readmore_text',JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_READMORE')).' ('.$this->item->numcomments.')';
				else
					echo '#'.$this->item->id;
			?></a>
		</div>
		<div class="comJMyLifeItemInfo"><?php
			// since 1.0.5 item vote is optional
			if( $this->item->show_votes && $this->params->getInt( 'graphical_voting', 0 ) == 0 ): ?>
			<div class="comJMyLifeItemVote">
				<?php echo JmylifeCommon::votelinks( $this->item ); ?>
			</div><?php
			endif;
			// end optional vote
			?>
			<div class="comJMyLifeItemAuthor">
			<?php
				$_catlink = '<a href="'.$this->item->catlink.'">'.$this->item->catname.'</a>';
				if( strlen( $this->item->profile_path ) > 0 && $this->params->getInt( 'social_engine', 0 ) > 0 && $this->params->getInt( 'link_story_author' ) )
				{
					$_author = '<a href="'.$this->item->profile_path.'">'.$this->item->user_alias.'</a>';
				}
				else
				{
					$_author = $this->item->user_alias;
				}

				echo JText::sprintf( 'COM_JMYLIFE_STORY_INFOFORMAT', date( JText::_( 'COM_JMYLIFE_STORY_DATEFORMAT' ), $this->item->time ), date( JText::_( 'COM_JMYLIFE_STORY_TIMEFORMAT' ), $this->item->time ), $_catlink, $_author );
				if( $this->params->allow->cb && strlen( $this->item->cbextra ) > 0 ) : ?>
				<div class="comJMyLifeItemAuthorExtra"><?php echo $this->item->cbextra; ?></div><?php
				endif;
				// handle jawards
				if ( $this->params->allow->jawards ) :
					echo JmylifeCommon::buildUserAwards($this->curitem->user_id);
				endif;
			?>
			</div>
		</div><?php
			// admin response added in 1.0.5
			if( strlen( $this->item->admin_fulltext ) > 0 ) : ?>
		<div class="comJMyLifeItemResponse">
			<?php	echo $this->item->admin_fulltext; ?>
		</div><?php
			endif;
			// end admin response
			?>
		<div class="comJMyLifeItemFooter">
			<?php echo JmylifeCommon::itemfooter( $this->item ); ?>
		</div><?php
	endif; ?>
</div>
</form><?php
if( $isStory ):
	// since 1.0.5 comments are optional
	$comment_engine = $this->params->getInt('comment_engine');
	// jom_comment has a nifty "disabled" bit
	if( $comment_engine == 4 && $this->params->allow->jomcomment ):
		// jomcomment
		if( ( $this->params->getInt( 'jomcomment_hide_disabled', 0 ) == 0 && !$this->item->show_comments ) || $this->item->show_comments ):
			$commentpath = JPATH_SITE.DS.'plugins'.DS.'content'.DS.'jom_comment_bot.php';
			if( file_exists( $commentpath ) ):
				require_once( $commentpath );
				echo jomcomment( $this->item->id, 'com_jmylife', '', '', !$this->item->show_comments );
				// jomcomment has it's own favorites system but it won't allow for proper JML titles
				// destroy jomcomment's favorites action and replace with a JML-specific one
				?>
<script type="text/javascript">
// <!--
var $isUser  = <?php echo $user->guest ? 'false' : 'true'; ?>;
var $favhref = "<?php echo JRoute::_('index.php?option=com_jmylife&controller=ajax&task=favorite&sid='.$this->item->id.'&'.JUtility::getToken().'=1&tmpl=component&ajax=1'); ?>";
(function($){
	$(document).ready(function() {
		try {
			$('.jcfav a').each(function() {
				var el = $(this);
				if (!$isUser) {
					el.parent().remove();
				}
				el.unbind( 'click' );
				el.click(function() {
					$.ajax({
						type: "GET",
						url: $favhref,
						success: function(data, textStatus, XMLHttpRequest) {
							el.text(data);
						}
					});
					return false;
				});
			});
		} catch( err ){}
	});
})(window.jml.jQuery);
// -->
</script>
				<?php
			endif;
		endif;
	// not using jomcomment, show others
	elseif( $this->item->show_comments ):
		if( $comment_engine == 0 ):
		?>
	<div class="comJMyLifeItem jmylifeRound" <?php echo $this->item->style; ?>>
		<h3 class="comJMyLifeCommentHeader"><?php echo JText::_('COM_JMYLIFE_COMMENT_HEADER'); ?></h3>
	</div>
	<?php
			// loop listings
			if( sizeof( $this->comments ) != 0 ) :
				// this fixed in 1.0.9
				$curcommentnum = 0;
				foreach( $this->comments as $comment ) :
					$this->curcomment =& $comment;
					$this->curcomment->num = ++$curcommentnum;
					echo $this->loadTemplate('comment');
					unset( $this->curcomment );
				endforeach;
			else: ?>
	<div class="comJMyLifeItem jmylifeRound" <?php echo $this->item->style; ?>>
		<?php echo JText::_('COM_JMYLIFE_ERROR_COMMENT_NOCOMMENTS'); ?>
	</div>
	<?php
			endif;
	?>
	<?php
			$_links = @$this->pagination->getPagesLinks();
			$_counter = @$this->pagination->getPagesCounter();
			if( strlen( $_links ) > 0 && strlen( $_counter ) > 0 && $this->params->getInt( 'comment_pagination', 1 ) == 1 ): ?>
	<div class="comJMyLifeItem jmylifeRound" <?php echo $this->item->style; ?>>
		<div class="comJMyLifePagesLinks"><?php echo $_links; ?></div>
		<div class="comJMyLifePagesCounter"><?php echo $_counter; ?></div>
	</div>
	<?php
			endif;

			if( !$user->guest ) :
				// load comment submission form template
				echo $this->loadTemplate('commentform');
			else: ?>
	<div class="comJMyLifeItem jmylifeRound" <?php echo $this->item->style; ?>><?php echo JText::_( 'COM_JMYLIFE_ERROR_COMMENT_LOGINFIRST' ); ?></div>
	<?php
			endif;

		elseif( $comment_engine == 1 ):
			// jcomments
			$commentpath = JPATH_SITE.DS.'components'.DS.'com_jcomments'.DS.'jcomments.php';
			if( file_exists( $commentpath ) ):
				require_once( $commentpath );
				echo JComments::showComments( $this->item->id, 'com_jmylife', $this->item->id );
			endif;
		elseif( $comment_engine == 2 ):
			// joomlacomment
			$commentpath = JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_comment'.DS.'plugin'.DS.'com_jmylife'.DS.'josc_com_jmylife.php';
			if( file_exists( $commentpath ) ):
				require_once( $commentpath );
			endif;
		elseif( $comment_engine == 3 ):
			// disqus
			$disqus = $this->params->get( 'disqus_shortname', '' );
			if( strlen( $disqus ) > 0 ): ?>
	<script type="text/javascript">
	// <!--
		var disqus_developer = <?php echo ( $this->params->getInt( 'disqus_developer', 0 ) == 1 ? 'true' : 'false' ); ?>;
		var disqus_url = "<?php echo $this->urlhelper->clean( JURI::root().'/index.php?option=com_jmylife&view=item&id='.$this->item->id ); ?>";
	// -->
	</script>
	<div id="disqus_thread"></div><script type="text/javascript" src="http://disqus.com/forums/<?php echo $disqus; ?>/embed.js"></script><noscript><a href="http://disqus.com/forums/<?php echo $disqus; ?>/?url=ref"><?php echo JText::_('COM_JMYLIFE_ERROR_COMMENT_DISQUS_VIEWTHREAD'); ?></a></noscript><a href="http://disqus.com" class="dsq-brlink"><?php echo JText::_('COM_JMYLIFE_ERROR_COMMENT_DISQUS_POWEREDBY'); ?></a><script type="text/javascript">
//<![CDATA[
(function()
{
	var links = document.getElementsByTagName('a');
	var query = '?';
	for (var i = 0; i < links.length; i++) {
		if (0 <= links[i].href.indexOf('#disqus_thread')) {
			query += 'url' + i + '=' + encodeURIComponent( "<?php echo $this->urlhelper->clean( JURI::root().'/index.php?option=com_jmylife&view=item&id=' ); ?>" + $(links[i]).getAttribute( 'rel' ) ) + '&';
		}
	}
	document.write('<script charset="utf-8" type="text/javascript" src="http://disqus.com/forums/<?php echo $disqus; ?>/get_num_replies.js' + query + '"></' + 'script>');
})();
//]]>
</script><?php
			endif;
		endif;
	// end optional comment form
	endif;
endif;