<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/item/tmpl/edit.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined('_JEXEC') or die('Restricted access'); ?>
<form name="editForm" class="jmlForm" id="comJMyLifeEditForm" method="post" action="<?php echo JRoute::_('index.php'); ?>">
<?php if ($this->params->getBool('allow_titles')) :?>
<div class="jmlFormItem">
	<label for="title"><?php echo JText::_('COM_JMYLIFE_STORY_TITLE_TITLE'); ?>:</label>&nbsp;
	<input type="text" name="title" value="<?php echo $this->item->title; ?>" />
</div>
<?php endif;
if ($this->params->getBool('edit_category')) : ?>
<div class="jmlFormItem">
	<label for="catid"><?php echo JText::_('COM_JMYLIFE_STORY_TITLE_CATEGORY'); ?>:</label>&nbsp;
	<select name="catid">
		<?php foreach ($this->categories as $cat) : ?>
		<option value="<?php echo $cat->id; ?>"><?php echo htmlspecialchars($cat->name); ?></option>
		<?php endforeach; ?>
	</select>
</div>
<?php endif;
if ($this->params->getBool('guest_email') && $this->params->getBool('edit_email')): ?>
<div class="jmlFormItem">
	<label for="user_email"><?php echo JText::_('COM_JMYLIFE_STORY_TITLE_EMAIL'); ?>:</label>&nbsp;
	<input type="text" name="user_email" value="<?php echo htmlspecialchars($this->item->user_email); ?>" />
</div>
<?php endif;
if ($this->params->getBool('edit_username')): ?>
<div class="jmlFormItem">
	<label for="user_alias"><?php echo JText::_('COM_JMYLIFE_STORY_TITLE_AUTHOR'); ?>:</label>&nbsp;
	<input type="text" name="user_alias" value="<?php echo htmlspecialchars($this->item->user_alias); ?>" />
</div>
<?php endif; ?>
<div id="comJMyLifeStorySubmitText">
	<?php if( $this->wysiwyg == 1 ): ?>
	<div class="editbar">
		<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_BOLD'); ?>" onclick="doClick('bold');" type="button"><b>B</b></button>
		<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_ITALIC'); ?>" onclick="doClick('italic');" type="button"><i>I</i></button>
		<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_UNDERLINE'); ?>" onclick="doClick('underline');" type="button"><u>U</u></button><?php
		if ($this->params->getBool('wysiwyg_links')): ?>
		<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_LINK'); ?>" onclick="doLink();" type="button" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/url.gif');"></button><?php
		endif;
		if ($this->params->getBool('wysiwyg_images')): ?>
		<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_IMAGE'); ?>" onclick="doImage();" type="button" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/img.gif');"></button><?php
		endif;
		if ($this->params->getBool('wysiwyg_list')): ?>
		<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_LIST'); ?>" onclick="doClick('InsertUnorderedList');" type="button" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/icon_list.gif');"></button><?php
		endif;
		if ($this->params->getBool('wysiwyg_color')): ?>
		<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_COLOR'); ?>" id="jmlWysiwygColorButton"<?php /* onclick="showColorGrid2('none')"*/?> type="button" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/colors.gif');"></button><span id="colorpicker201" class="colorpicker201"></span><?php
		endif; ?>
		<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_SOURCE'); ?>" class="htmlswitch" type="button" onclick="javascript:SwitchEditor()" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/icon_html.gif');"></button>
	</div>
	<?php endif; ?>
	<textarea id="comJMyLifeFulltext" name="fulltext" cols="60" rows="13"><?php echo $this->item->fulltext; ?></textarea>
</div>
<div class="jmlClear"><!-- --></div>
<?php
// attachments...
echo $this->attachbar;
// options
if (strlen($this->options)) : ?>
<div class="jmlFormItem">
	<h4><?php echo JText::_('COM_JMYLIFE_STORY_TITLE_OPTIONS'); ?>:</h4>&nbsp;
	<?php echo $this->options; ?>
</div>
<?php endif; ?>
<div class="jmlFormSubmit">
	<input type="submit" value="<?php echo JText::_('COM_JMYLIFE_STORY_EDIT_SAVE'); ?>" />
</div>
<input type="hidden" name="id" value="<?php echo $this->item->id; ?>" />
<input type="hidden" name="nickname" value="<?php echo $this->item->user_alias; ?>" />
<input type="hidden" name="option" value="com_jmylife" />
<input type="hidden" name="view" value="item" />
<input type="hidden" name="task" value="save" />
<input type="hidden" name="controller" value="item" />
<input type="hidden" name="rawoutput" value="<?php echo $this->rawoutput; ?>"/>
<input type="hidden" name="attachment[url]" id="jmlAttachUrlField" value="<?php echo $this->item->attachment_url; ?>" />
<input type="hidden" name="attachment[type]" id="jmlAttachTypeField" value="<?php echo $this->item->attachment_type; ?>" />
<input type="hidden" name="attachment[thumb]" id="jmlAttachThumbField" value="<?php echo $this->item->attachment_thumb; ?>" />
<input type="hidden" name="attachment[usethumb]" id="jmlAttachUseThumbField" value="<?php echo $this->item->attachment_usethumb; ?>" />
<input type="hidden" name="attachment[title]" id="jmlAttachTitleField" value="<?php echo $this->item->attachment_title; ?>" />
<input type="hidden" name="attachment[description]" id="jmlAttachDescriptionField" value="<?php echo $this->item->attachment_description; ?>" />
<?php echo JHTML::_('form.token'); ?>
</form>