<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/item/view.html.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.view' );

/**
 * HTML View Item class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewItem extends JView
{
	function display($tpl = null) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$string = JmylifeStringHelper::getInstance();
		$url = JmylifeUrlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$document =& JFactory::getDocument();
		// request vars
		$layout = JRequest::getWord('layout', 'default');
		// get item
		$item =& $this->get('Data');
		// hack - now that the data's here
		// reassign id, to account for "random"
		JRequest::setVar('id', $item->id);
		// Get Categories
		$categories =& $this->get('Categories');
		// task-specific code
		switch ($layout) {
			case 'edit':
				JRequest::setVar('layout', 'edit');
				$assetPath = JURI::root().'components/com_jmylife/assets/';
				$libPath = JURI::root().'components/com_jmylife/libraries/';
				// reset fulltext
				@$item->fulltext = strip_tags(@$item->rawfulltext);
				// option editing
				$options = $this->get('Options');
				$this->assignRef('options', $options);
				// attachments
				$attachbar = '';
				if ($_JMLConfig->getInt('allow_storyattachment',0)) {
					$document->addStyleSheet($assetPath.'css/attachbar.css');
					// set this for config option
					// NOTE: changes must also be set in admin moderate view and submission module
					$document->addScriptDeclaration('/* story attachment options */
window.jml.Attachment={
	AllowImages:'      .($_JMLConfig->getInt('storylink_thumbnail') ? 'true' : 'false').',
	Link:"'            .$item->attachment_url.'",
	Type:"'            .$item->attachment_type.'",
	Title:"'           .$item->attachment_title.'",
	TitleLimit:"'      .$_JMLConfig->getInt('storylink_title_limit', 0).'",
	Description:"'     .$item->attachment_description.'",
	DescriptionAllow:"'.$_JMLConfig->getInt('storylink_desc_allow', 1).'",
	Image:"'           .JmylifeCommon::getStoryAttachmentImageUrl($item->id).'",
	Item:"'            .$item->id.'",
	Editable:'         .($_JMLConfig->getInt('storylink_editable') ? 'true' : 'false').',
	Extra:"'           .$item->attachment_extra.'",
	Text:{
		paste: "'  .JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_PASTE')  .'",
		attach: "' .JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_ATTACH') .'",
		nothumb: "'.JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_NOTHUMB').'"
	}
};
');
					$document->addScript($assetPath.'js/storyAttachment.js');
					$attachbar = JmylifeCommon::attachmentBar();
				}
				$this->set('attachbar', $attachbar);
				// wysiwyg
				JmylifeCommon::loadWysiwygAssets();
				$wysiwyg = (bool)$_JMLConfig->getInt('use_wysiwyg', 0);
				// add extras to document
				if ($wysiwyg) {
					// set base path for wysiwyg
					$wysiwygpath = $libPath.'wysiwyg/';
					$this->assignRef('wysiwygpath', $wysiwygpath);
				}
				$this->assignRef('wysiwyg', $wysiwyg);
				// text limit
				if ($limit = $_JMLConfig->getInt('editor_limit',0)) {
					$document->addScript($assetPath.'js/limitText.js');
					$document->addScriptDeclaration('(function($){
	$(document).ready(function() {
		$("#comJMyLifeFulltext").limitText({
			limit: '.$limit.',
			text: {
				charleft: "'.JText::_('COM_JMYLIFE_SUBMIT_EDITOR_LENGTH_CHARLEFT').'",
				nomore: "'.JText::_('COM_JMYLIFE_SUBMIT_EDITOR_LENGTH_NOMORE').'"
			}
		}).trigger("change");
	});
})(window.jml.jQuery);');
				}
				break;
			default:
				// Get data from the model
				$pagination =& $this->get('Pagination');
				// Get comment data from the model
				$comments =& $this->get('Comments');
				// load comments js
				// TODO: combine these?
				if ($_JMLConfig->getInt('allow_comments') && (int)$item->catallowcomments && 0 == $_JMLConfig->getInt('comment_engine')) {
					$document->addScript(JURI::base().'/components/com_jmylife/assets/js/commentToggle.js');
					$document->addScript(JURI::base().'/components/com_jmylife/assets/js/showBadComment.js');
				}
				// handle meta
				$itemtitle = $html->unclean($item->title);
				$itemdesc  = preg_replace('`&nbsp;`', ' ', $_JMLConfig->get('story_pretext','').$html->unclean($item->fulltext).$_JMLConfig->get('story_posttext',''));
				if ($_JMLConfig->getInt('allow_titles') && strlen($itemtitle)) {
					$document->setTitle($string->shorten(strip_tags($itemtitle), $_JMLConfig->getInt('title_meta_limit'), false));
				}
				else if ($_JMLConfig->getInt('story_as_title')) {
					$document->setTitle($string->shorten(strip_tags($item->fulltext), $_JMLConfig->getInt('title_meta_limit'), false));
				}
				else if (strlen($item->user_alias)) {
					$document->setTitle(JText::sprintf('COM_JMYLIFE_STORY_TITLE', $item->user_alias));
				}
				if (strlen($itemdesc)) {
					$document->setDescription(preg_replace('`"`', '&quot;', $string->shorten(strip_tags($itemdesc), $_JMLConfig->getInt('story_meta_limit'), false)));
				}
				// add alternate feed link - since 1.0.8
				if ($_JMLConfig->getInt('show_feed_link') && $_JMLConfig->getInt('show_feed_link_in_story')) {
					$document =& JFactory::getDocument();
					$link = 'index.php?option=com_jmylife&view=list&catid='.$item->catid.'&format=feed&limitstart=';
					foreach (array('rss' => 'RSS 2.0', 'atom' => 'Atom 1.0') as $key => $val) {
						$attribs = array('type' => "application/{$key}+xml", 'title' => $val);
						$document->addHeadLink(JRoute::_("{$link}&type={$key}", false ), 'alternate', 'rel', $attribs );
					}
				}
				$this->assignRef('comments', $comments);
				$this->assignRef('pagination', $pagination);
				break;
		}
		// push data into the template
		$this->assignRef('item', $item);
		$this->assignRef('categories', $categories);
		$this->assignRef('params', $_JMLConfig);
		$this->assignRef('urlhelper', $url);
		$this->assignRef('html', $html);
		// all done
		parent::display($tpl);
	}
}