<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/submit/view.raw.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since      1.0.13
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.view' );

/**
 * HTML View Submit class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewItem extends JView
{
	function display( $tpl = null )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// fetch layout from request
		$layout = JRequest::getWord( 'layout', null );
		// if url is a param use it instead of data
		$link = JRequest::getString('link', '');
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$url = JmylifeUrlHelper::getInstance();
		if ($url->validate($link)) {
			JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
			$itemid = JmylifeItemidHelper::getInstance();
			$item = new stdClass();
			$item->id = 0;
			$item->attachment_type = 'link';
			$item->attachment_url = $link;
			$item->storylink = JRoute::_('index.php?option=com_jmylife&view=submit&Itemid='.$itemid->view('submit'), false);
			$item->storylink .= $url->q($item->storylink).'link='.urlencode($link);
			$item->isExternal = true;
		} else {
			// fetch item
			$item =& $this->get( 'Data' );
			$item->isExternal = false;
		}
		$this->assignRef( 'item', $item );

		// hack - now that the data's here
		// reassign id, to account for "random"
		JRequest::setVar( 'id', $item->id );

		// ensure that story actually has a link associated - otherwise redirect
		if (0 == strlen($item->attachment_url)) {
			JmylifeCommon::redirect($item->storylink);
		}

		if ( 'header' == $layout ) :
			$assetPath = JURI::root().'components/com_jmylife/assets/';
			$libPath = JURI::root().'components/com_jmylife/libraries/';

			$scripts = array('raw'=>array());
			$styles = array('raw'=>array());

			// since this is raw output just use jquery (meh)
			$scripts[$libPath.'jquery/jquery-1.4.2.min.js'] = 1;
			$scripts[$libPath.'jquery/jquery.noconflict.js'] = 1;

			// get styles for jml
			$styles[$assetPath.'css/styles.css'] = 1;
			// custom css
			$customcss = $_JMLConfig->get( 'css_custom_styles', '' );
			if( strlen( $customcss ) > 0 && preg_match( '`\.css$`', $customcss ) && $_JMLConfig->getInt( 'css_custom_published', 0 ) == 1 )
			{
				$styles[$assetPath.'css/custom/'.$customcss] = 1;
			}

			// build logo path
			$logo = $_JMLConfig->get('storylink_header_logo', '');
			if ( '' == $logo )
			{
				JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
				$url = JmylifeUrlHelper::getInstance();
				$logo = $url->clean( JURI::root().'/components/com_jmylife/assets/images/logo.png' );
			}
			$this->set( 'logo', $logo );

			// get latest comments
			$comments = $this->get('LatestComments');
			$this->set( 'latestcomments', $comments );

		?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="en-gb" xml:lang="en-gb">
<head>
	<title><?php echo $item->title; ?></title>
	<?php
		foreach( $styles as $style => $value )
		{
			if( 'raw' == $style ) continue;
			echo "\n".'<link rel="stylesheet" href="'.$style.'" type="text/css" />';
		}
		foreach( $scripts as $script => $value )
		{
			if( 'raw' == $script ) continue;
			echo "\n".'<script type="text/javascript" src="'.$script.'"></script>';
		}
	?>
	<style type="text/css">
		body { margin: 0px; padding: 0px; }
		#jmlStoryLinkHeaderContainer { height: <?php echo $_JMLConfig->getInt('storylink_header_height', 120); ?>px; width: 100%; overflow: hidden; }
		#jmlStoryLinkHeaderContainer a img { border: 0; }
	</style>
</head>
<body class="jmlStoryLinkHeaderBody">
<div id="jmlStoryLinkHeaderContainer"><?php parent::display( $tpl ); ?></div>
</body>
</html><?php die();

		else :
			$topsrc = JRoute::_('index.php?option=com_jmylife&view=item&format=raw&layout=header&'.($item->isExternal?'link='.urlencode($item->attachment_url):'id='.$item->id), false);
			$btmsrc = $item->attachment_url;

		?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="en-gb" xml:lang="en-gb">
<head>
	<title><?php echo $item->title; ?></title>
</head>
<frameset rows="<?php echo $_JMLConfig->getInt('storylink_header_height', 120); ?>, *" FRAMEBORDER=NO FRAMESPACING=0 BORDER=0>
	<frame src="<?php echo $topsrc; ?>" noresize scrolling=no>
	<frame src="<?php echo $btmsrc; ?>" noresize scrolling=auto>
</frameset>
</html><?php die();

		endif;
		// end display
	}
}