<?php
/**
 * List Default Item Layout for JMyLife Component
 *
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/list/tmpl/default_item.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined('_JEXEC') or die('Restricted access');
?>
<div class="comJMyLifeItem jmylifeRound" <?php echo $this->curitem->style; ?>><?php
	// edit button
	if ($this->curitem->viewerCanEdit) {
		echo $this->html->link($this->curitem->editlink, $this->html->image(JURI::root().'images/M_images/edit.png', array('alt' => 'edit')), array('class' => 'jmlEditLink'));
	}
	// graphical voting since 1.0.10
	if( $this->curitem->show_votes && $this->params->getInt( 'graphical_voting', 0 ) == 1 ): ?>
	<div class="comJMyLifeGraphicalVote">
		<?php echo JmylifeCommon::graphicvote( $this->curitem ); ?>
	</div>
	<?php endif;
	// since 1.0.5 optional title
	if( $this->params->getInt( 'allow_titles' ) == 1 && strlen( $this->curitem->title ) > 0 ) : ?>
	<div class="comJMyLifeItemTitle">
		<?php
			if( $this->params->getInt( 'link_titles' ) == 1 ) : ?>
			<a href="<?php echo $this->curitem->storylink; ?>"><?
				echo $this->curitem->title;
			?></a><?php
			else:
				echo $this->curitem->title;
			endif;
		?>
	</div><?php
	endif;
	// end title
	// since 1.0.9 add avatar
	$linkavatar = strlen( $this->curitem->profile_path ) > 0 && $this->params->allow->cb && $this->params->getInt( 'link_story_avatar', 0 ) == 1;
	if( $this->params->getInt( 'social_engine', 0 ) > 0 && $this->params->getInt( 'show_story_avatar' ) ): ?>
	<div class="comJMyLifeItemAvatar"><?php
		if( $linkavatar ) : ?><a href="<?php echo $this->curitem->profile_path; ?>"><?php endif; ?>
		<img src="<?php echo $this->curitem->avatar_image; ?>" alt="<?php if( $this->params->getInt( 'disable_avatar_alt' ) == 0 ) echo $this->curitem->user_alias; ?>" /><?php
		if( $linkavatar ) : ?></a><?php endif; ?>
	</div>
	<?php
	endif;
	// end avatar

	// since 1.0.13 add attachment
	if ( 1 < $this->params->getInt( 'allow_storyattachment', 0 ) + $this->params->getInt( 'storyattachment_list', 0 ) ) : ?>
	<div class="comJMyLifeItemAttachment"><?php
		// load item attachment template
		echo $this->loadTemplate( $this->curitem->attachment_type );
	?>
	</div>
	<?php
	endif;
	// end attachment

	?>
	<div class="comJMyLifeItemText<?php if( $this->curitem->show_votes && $this->params->getInt( 'graphical_voting', 0 ) == 1 ) echo ' jmlGraphicText'; ?>">
		<?php
			// added in 1.0.6
			echo '<span class="comJMyLifeItemPretext">'.$this->params->get( 'story_pretext' ).' </span>';
			// since 1.0.5 this is preprocessed
			echo $this->curitem->fulltext;
			// added in 1.0.6
			echo '<span class="comJMyLifeItemPosttext"> '.$this->params->get( 'story_posttext' ).'</span>';
			// added in 1.0.9, will be blank if not needed
			echo $this->curitem->readmore;
			?>
	</div>
	<div class="comJMyLifeItemReadComments">
		<a href="<?php
			echo $this->curitem->storylink;
			if( $this->curitem->show_comments && $this->params->getInt('comment_counts') == 1 && $this->params->allow->disqus )
			{
				echo '#disqus_thread';
			}
		?>"<?php if( !( $this->curitem->show_comments ) ) echo ' class="noballoon"'; ?> rel="<?php echo $this->curitem->id; ?>"><?php
			// since 1.0.5 this link is dynamic depending on comment status
			// since 1.0.8 also global
			if( $this->curitem->show_comments && $this->params->getInt('comment_counts') == 1 )
				echo $this->params->get('readmore_text',JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_READMORE')).' ('.$this->curitem->numcomments.')';
			else
				echo '#'.$this->curitem->id;
		?></a>
	</div>
	<div class="comJMyLifeItemInfo"><?php
		// since 1.0.5 item vote is optional
		if( $this->curitem->show_votes && $this->params->getInt( 'graphical_voting', 0 ) == 0 ): ?>
		<div class="comJMyLifeItemVote">
			<?php echo JmylifeCommon::votelinks( $this->curitem ); ?>
		</div><?php
		endif;
		// end vote
		?>
		<div class="comJMyLifeItemAuthor">
		<?php
			$_catlink = '<a href="'.$this->curitem->catlink.'">'.$this->curitem->catname.'</a>';
			if( strlen( $this->curitem->profile_path ) > 0 && $this->params->getInt( 'social_engine', 0 ) > 0 && $this->params->getInt( 'link_story_author' ) )
			{
				$_author = '<a href="'.$this->curitem->profile_path.'">'.$this->curitem->user_alias.'</a>';
			}
			else
			{
				$_author = $this->curitem->user_alias;
			}
			// changed in 1.0.5 for encoding
			echo JText::sprintf( 'COM_JMYLIFE_STORY_INFOFORMAT', date( JText::_( 'COM_JMYLIFE_STORY_DATEFORMAT' ), $this->curitem->time ), date( JText::_( 'COM_JMYLIFE_STORY_TIMEFORMAT' ), $this->curitem->time ), $_catlink, $_author );
			if( $this->params->allow->cb && strlen( $this->curitem->cbextra ) > 0 ) : ?>
			<div class="comJMyLifeItemAuthorExtra"><?php echo $this->curitem->cbextra; ?></div><?php
			endif;
			// handle jawards
			if ( $this->params->allow->jawards ) :
				echo JmylifeCommon::buildUserAwards($this->curitem->user_id);
			endif;
		?>
		</div>
	</div>
	<div class="comJMyLifeItemFooter">
		<?php echo JmylifeCommon::itemfooter( $this->curitem ); ?>
	</div>
</div>