<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/submit/tmpl/default.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined('_JEXEC') or die('Restricted access');
$user =& JFactory::getUser(); ?>
<div class="comJMyLifeItem jmylifeRound" id="comJMyLifeStorySubmit">
	<div id="comJMyLifeStoryFormMessage"></div>
	<form method="post" name="jmylifeForm" id="comJMyLifeStoryForm" action="<?php echo JRoute::_( 'index.php' ); ?>"><?php
		if( 0 == intval( $this->rawoutput ) ) : ?>
		<div id="comJMyLifeStorySubmitHeader">
			<h3><?php echo JText::_( 'COM_JMYLIFE_SUBMIT_TITLE' ); ?></h3>
		</div><?php
		endif;
			// show pre text since 1.0.7
			$pretext = $this->cparams->get( 'submission_pretext' );
			if( strlen( $pretext ) > 0 ): ?>
		<div class="comJMyLifeStorySubmitPretext"><?php echo $this->html->clean( $pretext ); ?></div>
		<?php endif; ?>
		<?php
			// since 1.0.5 title is optional
			if( $this->cparams->getInt( 'allow_titles' ) == 1 ) :?>
		<div id="comJMyLifeStorySubmitTitle">
			<label for="title"><?php echo JText::_( 'COM_JMYLIFE_STORY_TITLE_TITLE' ); ?>:</label>&nbsp;
			<input type="text" name="title" value="" />&nbsp;
		</div><?php
			endif; ?>
		<div id="comJMyLifeStorySubmitCategorySelect"><?php
		// fixed in 1.0.13
		if ($user->guest || (0 == $this->cparams->getInt('force_user_name', 0) && 0 == $this->cparams->getInt('force_user_username', 0))) : ?>
			<label for="nickname"><?php echo JText::_( 'COM_JMYLIFE_STORY_TITLE_YOURNAME' ); ?>:</label>&nbsp;
			<input type="text" name="nickname" value="" />&nbsp;<?php
		elseif (1 == $this->cparams->getInt('force_user_name', 0)) : ?>
			<input type="hidden" name="nickname" value="<?php echo $user->name; ?>" /><?php
		elseif (1 == $this->cparams->getInt('force_user_username', 0)) : ?>
			<input type="hidden" name="nickname" value="<?php echo $user->username; ?>" /><?php
		endif; ?>
			<label for="catid"><?php echo JText::_( 'COM_JMYLIFE_STORY_TITLE_CATEGORY' ); ?>:</label>&nbsp;
			<select name="catid">
				<?php foreach( $this->categories as $cat ): ?>
				<option value="<?php echo $cat->id; ?>"><?php echo $cat->name; ?></option>
				<?php endforeach; ?>
			</select>
		</div>
		<div id="comJMyLifeStorySubmitText">
			<?php if( $this->wysiwyg == 1 ): ?>
			<div class="editbar">
				<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_BOLD'); ?>" onclick="doClick('bold');" type="button"><b>B</b></button>
				<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_ITALIC'); ?>" onclick="doClick('italic');" type="button"><i>I</i></button>
				<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_UNDERLINE'); ?>" onclick="doClick('underline');" type="button"><u>U</u></button><?php
				if( $this->cparams->getInt( 'wysiwyg_links', 1 ) == 1 ): ?>
				<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_LINK'); ?>" onclick="doLink();" type="button" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/url.gif');"></button><?php
				endif;
				if( $this->cparams->getInt( 'wysiwyg_images', 1 ) == 1 ): ?>
				<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_IMAGE'); ?>" onclick="doImage();" type="button" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/img.gif');"></button><?php
				endif;
				if( $this->cparams->getInt( 'wysiwyg_list', 1 ) == 1 ): ?>
				<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_LIST'); ?>" onclick="doClick('InsertUnorderedList');" type="button" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/icon_list.gif');"></button><?php
				endif;
				if( $this->cparams->getInt( 'wysiwyg_color', 1 ) == 1 ): ?>
				<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_COLOR'); ?>" id="jmlWysiwygColorButton"<?php /* onclick="showColorGrid2('none')"*/?> type="button" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/colors.gif');"></button><span id="colorpicker201" class="colorpicker201"></span><?php
				endif; ?>
				<button title="<?php echo JText::_('COM_JMYLIFE_WYSIWYG_BUTTON_SOURCE'); ?>" class="htmlswitch" type="button" onclick="javascript:SwitchEditor()" style="background-image:url('<?php echo $this->wysiwygpath; ?>images/icon_html.gif');"></button>
			</div>
			<?php endif; ?>
			<textarea id="comJMyLifeFulltext" name="fulltext" cols="60" rows="13"></textarea>
		</div>
		<?php if( strlen( $this->recaptcha ) > 0 ) : ?>
		<div id="comJMyLifeStorySubmitCaptcha">
			<?php echo $this->recaptcha; ?>
		</div>
		<?php endif; ?>
		<input type="hidden" name="option" value="com_jmylife" />
		<input type="hidden" name="task" value="addstory" />
		<input type="hidden" name="controller" value="ajax" />
		<input type="hidden" name="form" value="comJMyLifeStoryForm" />
		<input type="hidden" name="check" value="post"/>
		<input type="hidden" name="rawoutput" value="<?php echo $this->rawoutput; ?>"/>
		<input type="hidden" name="attachment[url]" id="jmlAttachUrlField" value="" />
		<input type="hidden" name="attachment[type]" id="jmlAttachTypeField" value="" />
		<input type="hidden" name="attachment[thumb]" id="jmlAttachThumbField" value="" />
		<input type="hidden" name="attachment[usethumb]" id="jmlAttachUseThumbField" value="1" />
		<input type="hidden" name="attachment[title]" id="jmlAttachTitleField" value="" />
		<input type="hidden" name="attachment[description]" id="jmlAttachDescriptionField" value="" />
		<?php echo JHTML::_( 'form.token' ); ?>
		<?php /* this javascript is for detecting ajax */ ?>
		<script type="text/javascript">
		//<!--
			document.write( '<inp' + 'ut type="hidden" name="ajax" value="1" /' + '>' );
		// -->
		</script>
		<?php if ($user->guest && $this->cparams->get('guest_email', 0)): ?>
		<div id="comJMyLifeStoryEmail">
			<div id="comJMyLifeStoryEmailOverlay">
				<a id="jmlEmailToggle" href="#"><?php echo JText::_('COM_JMYLIFE_SUBMIT_EMAILNOTIFICATION'); ?></a>
			</div>
			<div id="comJMyLifeStoryEmailInput">
				<label for="user_email"><?php echo JText::_('COM_JMYLIFE_STORY_TITLE_EMAIL'); ?> : </label>
				<input type="text" name="user_email" value="" />
			</div>
		</div>
		<?php endif; ?>
		<div class="jmlClear"></div>

		<?php echo $this->attachbar; ?>

		<div id="comJMyLifeStorySubmitButton">
			<button class="button" type="submit"><?php echo $this->cparams->get('submission_buttontext', JText::_('COM_JMYLIFE_SUBMIT_SUBMIT')); ?></button>
		</div>
		<div class="jmlClear"></div>
		<?php
			// show post text since 1.0.7
			$posttext = $this->cparams->get( 'submission_posttext' );
			if( strlen( $posttext ) > 0 ): ?>
		<div class="comJMyLifeStorySubmitPosttext"><?php echo $this->html->clean( $posttext ); ?></div>
		<?php endif; ?>
	</form>
	<?php /* since 1.0.4 comJMyLifeStorySubmitMessage is outside the form to prevent errors from IE */ ?>
	<div id="comJMyLifeStorySubmitMessage"></div>
</div>