<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/submit/view.raw.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since      1.0.12
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.view' );

/**
 * HTML View Submit class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewSubmit extends JView
{
	function display($tpl = null) {
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$appl =& JFactory::getApplication();
		$layout = JRequest::getWord('layout', null);
		// user check
		$user =& JFactory::getUser();
		if ($user->guest && $_JMLConfig->getInt('user_stories_only')) {
			$this->assignRef('message', JText::_('COM_JMYLIFE_ERROR_STORY_NOGUEST'));
			parent::display('error');
			return;
		}

		$assetPath = JURI::root().'components/com_jmylife/assets/';
		$libPath = JURI::root().'components/com_jmylife/libraries/';

		$scripts = array('raw'=>array());
		$styles = array('raw'=>array());

		$scripts[JRoute::_('index.php?option=com_jmylife&controller=ajax&task=jQuery', false)] = 1;
		$scripts[$assetPath.'js/submissionToggle.js'] = 1;

		// get styles for jml
		$styles[$assetPath.'css/styles.css'] = 1;

		// try to disable textarea resizing, if enabled
		if(1 == $_JMLConfig->getInt('disable_resize',0)) {
			$styles['raw']['textarea{resize:none;}'] = 1;
		}

		/**
		 * Attachment minilayout
		 */
		if ('attach' == $layout) :
			$image = $appl->getUserState("com_jmylife.new_image", '');
			$title = '';
			$desc = '';
			if (JRequest::getInt('local', 0)) {
				$id = JRequest::getInt('id');
				$image = JmylifeCommon::getStoryAttachmentImageUrl($id);
				// fetch remaining data from db
				$_JMLConfig->db->setQuery('SELECT `title`, `description` FROM `#__jmylife_stories_attachments` WHERE `sid` = '.$id);
				$data = $_JMLConfig->db->loadObject();
				$title = $data->title;
				$desc = $data->description;
			}
			if (!strlen($image)) {
				$fileName = md5($_SERVER['HTTP_USER_AGENT'].$_SERVER['REMOTE_ADDR']);
				// build absolute path for images
				$path = JPATH_ROOT.DS.'images'.DS.'jmylife'.DS;
				if (JFolder::exists($path)) {
					$files = JFolder::files($path, $fileName);
					if (!empty($files)) {
						$image = JURI::root().'images/jmylife/'.$files[0];
					}
				}
			}

		?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="en-gb" xml:lang="en-gb">
<head>
	<?php
		foreach ($styles as $style => $value) {
			if ('raw' == $style) continue;
			echo "\n".'<link rel="stylesheet" href="'.$style.'" type="text/css" />';
		}
		foreach ($scripts as $script => $value) {
			if ('raw' == $script) continue;
			echo "\n".'<script type="text/javascript" src="'.$script.'"></script>';
		}
	?>
	<style type="text/css">
		body { margin: 0px; padding: 0px; }
		#thumbnail { float: left; padding-right: 20px; }
		.clear { line-height: 1px; font-size: 1px; height: 0px; overflow: hidden; clear: both; }
	</style>
	<script type="text/javascript">
	// <!--
		(function($){
			$(document).ready(function(){
				var _frame = $(parent.document.getElementById('comJMyLifeAttachmentArea')).find('iframe:first').show().height( $('#wrapper').height() + 20 );
				$(parent.document.getElementById('jmlAttachTypeField')).val( 'image' );
				$('.thumbdetail').blur(function(){
					$(parent.document.getElementById('jmlAttach'+$(this).attr('id'))).val($(this).val());
				});
			});
		})(window.jml.jQuery);
	// -->
	</script>
</head>
<body>
<div id="wrapper">
<?php if ( 0 < strlen($image) ) : ?>
	<div id="thumbnail">
		<img src="<?php echo $image; ?>" />
	</div>
	<div id="thumbdetails">
		<div>
			<label for="TitleField"><?php echo JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_IMAGETITLE'); ?></label><br />
			<input type="text" id="TitleField" class="thumbdetail" value="<?php echo htmlspecialchars($title); ?>" />
		</div>
		<div>
			<label for="DescriptionField"><?php echo JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_IMAGEDESCRIPTION'); ?></label><br />
			<textarea id="DescriptionField" class="thumbdetail"><?php echo htmlspecialchars($desc); ?></textarea>
		</div>
	</div>
	<div class="clear"></div>
<?php else : ?>
	<span class="error"><?php echo JText::_('COM_JMYLIFE_ERROR_FILE_IMAGENOTFOUND'); ?></span>
<?php endif; ?>
</div>
</body>
</html><?php die();

		/**
		 * Upload minilayout
		 */
		elseif ('upload' == $layout) :

		?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="en-gb" xml:lang="en-gb">
<head>
	<?php
		foreach ($styles as $style => $value) {
			if ('raw' == $style) continue;
			echo "\n".'<link rel="stylesheet" href="'.$style.'" type="text/css" />';
		}
		foreach ($scripts as $script => $value) {
			if ('raw' == $script) continue;
			echo "\n".'<script type="text/javascript" src="'.$script.'"></script>';
		}
	?>
	<style type="text/css">
		body { margin: 0px; padding: 0px; }
		#wrapper { width: 400px; margin: 0 auto; }
	</style>
	<script type="text/javascript">
	// <!--
		(function($){
			$(document).ready(function(){
				var _frame = $(parent.document.getElementById('comJMyLifeAttachmentArea')).find('iframe:first').show().height( $('#wrapper').height() + 20 );
				$('#uploadForm').submit(function(e){
					// hide myself ;)
					//_frame.hide();
				});
			});
		})(window.jml.jQuery);
	// -->
	</script>
</head>
<body>
<div id="wrapper">
	<form id="uploadForm" name="uploadForm" action="index.php" method="post" enctype="multipart/form-data">
		<input type="file" name="image" />
		<input type="submit" value="<?php echo JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_ATTACH'); ?>" />
		<input type="hidden" name="option" value="com_jmylife" />
		<input type="hidden" name="controller" value="ajax" />
		<input type="hidden" name="task" value="uploadimage" />
	</form>
</div>
</body>
</html><?php die();

		/**
		 * raw minilayout (for jomsocial)
		 */
		else :

		// since 1.0.9 - wysiwyg!
		$wysiwyg = (bool)$_JMLConfig->getInt('use_wysiwyg', 0);
		$editorwidth = $_JMLConfig->getInt( 'editor_width', 300 );
		$editorheight = $_JMLConfig->getInt( 'editor_height', 180 );
		// add extras to document
		if ($wysiwyg) {
			$scripts[$libPath.'jquery/nyroModal/js/jquery.nyroModal-1.6.2.pack.js'] = 1;
			$styles[$libPath.'jquery/nyroModal/styles/nyroModal.full.css'] = 1;
			if ($_JMLConfig->getInt('wysiwyg_color')) {
				$styles[$libPath.'jquery/colorpicker/css/colorpicker.css'] = 1;
				$scripts[$libPath.'jquery/colorpicker/js/colorpicker.js'] = 1;
				$scripts['raw']['/* colorpicker */
jmlWYSIWYGColorPickerVisible = false;
(function($){
	$(document).ready(function() {
		var cPicker = $(\'<div id="jmlColorPicker"></div>\');
		var cPickerButton = $(\'#jmlWysiwygColorButton\');
		cPickerButton.after(cPicker);
		cPicker.css({left:cPickerButton.position().left}).hide().ColorPicker({
			flat: true,
			onShow: function(colpkr) {
				cPicker.height(173);
				$(colpkr).fadeIn(500);
				return false;
			},
			onHide: function(colpkr) {
				$(colpkr).fadeOut(500, function(){
					cPicker.height(0);
				});
				return false;
			},
			onSubmit: function(hsb, hex, rgb, el) {
				cPicker.height(0);
				doColor(hex.toString().toUpperCase().replace(/^\#/,""));
				$(el).ColorPickerHide();
				jmlWYSIWYGColorPickerVisible = false;
			}
		});
		cPickerButton.click(function() {
			if (jmlWYSIWYGColorPickerVisible) {
				cPicker.stop().fadeOut(500, function(){
					cPicker.height(0);
				});
			} else {
				cPicker.height(173).stop().fadeIn(500);
			}
			jmlWYSIWYGColorPickerVisible = !jmlWYSIWYGColorPickerVisible;
		});
	});
})(window.jml.jQuery);'] = 1;
			}
			$editorScript = 'window.jml.jQuery(document).ready(function(){initEditor("comJMyLifeFulltext");});';
			// set base path for wysiwyg
			$wysiwygpath = $libPath.'wysiwyg/';
			$styles[$wysiwygpath.'editor.css'] = 1;
			$scripts[JRoute::_('index.php?option=com_jmylife&controller=ajax&task=wysiwyg', false)] = 1;
			$scripts['raw']['window.jmlWYSIWYG=1;'.$editorScript] = 1;
			$styles['raw']['#rte,#comJMyLifeStorySubmitText,#comJMyLifeStorySubmitText .editbar,#comJMyLifeFulltext{width:'.$editorwidth.'px !important;}#rte,#comJMyLifeFulltext{height:'.$editorheight.'px !important;}'] = 1;
			$this->assignRef('wysiwygpath', $wysiwygpath);
		} else {
			$scripts['raw']['window.jmlWYSIWYG=0;'] = 1;
			$styles['raw']['#comJMyLifeStorySubmitText textarea{width:'.$editorwidth.'px !important;height:'.$editorheight.'px !important;}'] = 1;
		}
		$this->assignRef('wysiwyg', $wysiwyg);
		// attachments
		$attachbar = '';
		if ($_JMLConfig->getInt('allow_storyattachment',0)) {
			$styles[$assetPath.'css/attachbar.css']=1;
			// set this for config option
			// NOTE: changes must also be set in admin moderate view and submission module
			$scripts['raw']['/* story attachment options */
window.jml.Attachment={
	AllowImages:'.( $_JMLConfig->getInt('storylink_thumbnail') ? 'true' : 'false' ).',
	Link:"",
	Type:"link",
	Title:"",
	TitleLimit:"'.$_JMLConfig->getInt('storylink_title_limit', 0).'",
	Description:"",
	DescriptionAllow:"'.$_JMLConfig->getInt('storylink_desc_allow', 1).'",
	Image:"",
	Editable:'.( $_JMLConfig->getInt('storylink_editable') ? 'true' : 'false' ).',
	Extra:0,
	Text:{
		paste: "'  .JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_PASTE')  .'",
		attach: "' .JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_ATTACH') .'",
		nothumb: "'.JText::_('COM_JMYLIFE_STORY_ATTACHMENT_LABEL_NOTHUMB').'"
	}
};
']=1;
			$scripts[$assetPath.'js/storyAttachment.js']=1;
			$attachbar = JmylifeCommon::attachmentBar();
		}
		$this->set('attachbar', $attachbar);

		// text limit
		if ($limit = $_JMLConfig->getInt('editor_limit',0)) {
			$scripts[$assetPath.'js/limitText.js'] = 1;
			$scripts['raw']['(function($){
	$(document).ready(function() {
		$("#comJMyLifeFulltext").limitText({
			limit: '.$limit.',
			text: {
				charleft: "'.JText::_('COM_JMYLIFE_SUBMIT_EDITOR_LENGTH_CHARLEFT').'",
				nomore: "'.JText::_('COM_JMYLIFE_SUBMIT_EDITOR_LENGTH_NOMORE').'"
			}
		}).trigger("change");
	});
})(window.jml.jQuery);'] = 1;
		}

		// Get recaptcha
		$recaptcha =& $this->get('Recaptcha');

		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();

		// Get Categories
		$categories =& $this->get('Categories');
		// since 1.0.5 preprocess data before sending to template
		if (count($categories)) {
			foreach ($categories as $key => $item) {
				$categories[$key]->name = $html->clean($item->name);
			}
		}

		// push data into the template
		$this->assignRef('categories', $categories);
		$this->assignRef('recaptcha', $recaptcha);
		// handle recaptcha script here since it can't be added earlier
		if (1 == $_JMLConfig->getInt('captcha_engine', 0)) {
			// get recaptcha key
			$publickey = $_JMLConfig->get('recaptcha_public_key');
			if (strlen($publickey)) {
				$scripts["http://api.recaptcha.net/js/recaptcha_ajax.js"] = 1;
				JLoader::import('components.com_jmylife.helpers.captcha', JPATH_ADMINISTRATOR, '');
				$captcha = JmylifeCaptchaHelper::getInstance();
				$scripts['raw'][$captcha->recaptchascript()] = 1;
			}
		}

		// extra flag for jomsocial integration
		$raw = 1;
		$this->assignRef('rawoutput', $raw);

		// since 1.0.5
		// pass-by-reference removed in 1.0.6
		$this->assignRef('cparams', $_JMLConfig);

		?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="en-gb" xml:lang="en-gb">
<head>
<title><?php echo JText::_('COM_JMYLIFE_SUBMIT_TITLE'); ?></title>
<?php
	foreach ($scripts as $script => $value) {
		if ('raw' == $script) continue;
		echo "\n".'<script type="text/javascript" src="'.$script.'"></script>';
	}
	foreach ($styles as $style => $value) {
		if ('raw' == $style) continue;
		echo "\n".'<link rel="stylesheet" href="'.$style.'" type="text/css" />';
	}
	if (count($scripts['raw'])) {
		echo "<script type=\"text/javascript\">\n// <!-- \n";
		foreach ($scripts['raw'] as $script => $value) {
			echo $script."\n";
		}
		echo "\n// -->\n</script>";
	}
	if (count($styles['raw'])) {
		echo "<style type=\"text/css\">\n";
		foreach ($styles['raw'] as $style => $value) {
			echo $style."\n";
		}
		echo "\n</style>";
	}
?></head>
<body><?php
		parent::display($tpl);
	?>
</body>
</html><?php die();
		// end display
		endif;
	}
}