<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/CHANGELOG.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since      1.0.2
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
define( 'COM_JMYLIFE_CHANGELOG_KEY', nl2br(<<<EOF
CHANGELOG:

Key:
* : change
+ : addition
- : removal
^ : bugfix
! : security update

EOF
));
define( 'COM_JMYLIFE_CHANGELOG', nl2br(<<<EOF
com_jmylife
-----------

1.0.16

^ fixes for language file parsing errors
* admin menu names shortened
* installation routine changed to further 1.6 support (soon!)
+ date range selection for list view
^ html stripped from RSS feeds
+ method getBool added to JmylifeConfiguration
+ mod_jmylifedatepicker
^ object error when using Disqus in story template
^ text limits when using wysiwyg
+ prominent links to admin actions in installer
^ sh404sef attachment fix
^ sh404sef ignored story slug setting
^ router story slug language string
^ double round comment form
* jQuery noconflict mode now more defensive of other jQuery instances
^ captchas.net error

1.0.15

^ string helper comment bug
^ extra ajax tasks added to sef_ext
^ captchas.net fatal error

1.0.14

^ major change to language files - namespacing implemented, all texts should be translatable now
+ story text limits
^ more "common" functions moved to helpers
! a few missing blank index.html files
+ slider added to installer
* admin controller fallback changed from getString to getWord (not vulnerable to exploitation)
^ incorrect comment admin controller texts
* Twitter link now shares story, not link
^ editing stories didn't obey "allow blank" rule
* list view category select uses element instead of sql parameter type
* all text references to !JoomlaComment changed to CompojoomComment
! low-risk xss via story attachments
^ image attachments showing full image in list view
^ fetching remote data checks for safe_mode/open_basedir before setting CURLOPT_FOLLOWLOCATION
* unsubscribe link moved inside footer
* favorites icon
* admin story edit form revamp

1.0.13

+ story attachments
^ moderation view was incorrectly publishing stories voted down
^ extra checks on Community Builder as the database tables may remain after uninstall
^ changelog credits for JomSocial/JomComment were reversed (sorry guys! d'oh!)
^ language strings in comment form
+ ability to toggle between ip/cookie vote filtering
+ block guests from voting
^ database optimizations (thanks Matt!)
^ changed bbcode parser for https links
+ jAwards shown below author footer (you're welcome, Felix)
* installer changelog autosizes vertically based on install details height
* mootools code removed in favor of jQuery to compensate for MooRainbow being broken in latest IE8
* core comment list no longer shown in admin if 3rd party comments are being used
* assorted code cleanup
^ category ordering on submission form select
^ sign up item now appends Itemid to sign up link
^ saving stories no longer reorders them
^ !JoomlaComment plugin updated to work in CompojoomComment
^ JomSocial submit form iframe code fixed to force 100% width
^ forcing user names hides nickname input on submit form
^ submission form error layout fix
^ bbcode parser no longer removes certain characters when bbcode is disabled
^ bbcode parser pushes final render through HTMLPurifier to prevent broken code
^ list view sort order fixed when sort was "none"
^ wysiwyg editbar now below modals
^ submit button now disabled while posting to prevent duplicates
^ ShareThis updated to match changes
+ Xmap plugin
^ admin filter bugfixes

1.0.12.1

^ sh404sef plugin bug
^ update notice missing from integrations view

1.0.12

+ JomComment support (thanks to B. Hurst)
+ JomSocial support (thanks to Azrul)
+ plg_community_jmylifefavorites
+ plg_community_jmylifestories
+ plg_community_jmylifetoolbar
+ plug_cbjmylifetoolbar
^ 500 error in configuration if debug mode is on and community builder is not installed
+ assignable category ordering
^ sh404sef had troubles with categories view
+ integrations view for installing 3rd party plugins
+ raw view for submission form (used in social engines toolbar plugins)
^ recaptcha toggles only used mootools
* plugin install routine completely rewritten
* cb plugins are no longer automatically enabled by installer
^ cb plugins background color errors
+ author link in cpanel
* changed installer text to enforce strict promotion rules on JED
! extra checks in bbcode parser for nested tags
+ class added to readmore link
+ inline css on pagination divs
^ category Itemid only applied if no other Itemids are found
^ fixed "no text" error in stories admin form

1.0.11

+ site description in main list view
+ category descriptions in category list view
^ submission redirect now appends Itemid and runs URL through JRoute
^ uninstall routine issued false errors for duplicate modules
* list view menu item sort param now a list instead of radio
+ sort by Community Builder custom field in list view
+ custom Community Builder fields in item footer
* database calls made through JmylifeConfiguration class
* Community Builder checks shortened by using JMLConfig->allow
^ readmore link for shortened texts wasn't created properly
^ router now replaces spaces and ampersands, as well as strips question marks in categories
^ story query now grouped by both story id and comment id to prevent duplicates when CB support enabled
+ rtl stylesheet
* URL redirects should all use Itemid now
^ set error reporting levels
+ Disqus support
+ separate language table for long texts
^ long texts shouldn't be limited to 255 characters
+ bad words filter
* generic captcha engine instead of recaptcha
+ Bigo Captcha support
+ captchas.net support
* subgroups in configuration using JPane sliders
+ email texts tab in configuration
* certain email texts now available for backend editing
* email texts use text replacement instead of sprintf
^ notifications not sent on new comment if comment is not autopublished
^ email friend form url fixed
+ added latest comments and best stories to cpanel
+ update check on admin views with a big red notice for outdated versions
^ wysiwyg blocked changes in admin edit form
+ wysiwyg button filtering
* cleaned up old moderation columns accidentally left in release 1.0.10
+ moderation view
* about screen uses tabs for each extension type
^ malformed view caused scripts to not load
* more router rewriting
* certain url params (Item > Random, List > Sort) now default to "" to prevent showing in url
+ categories view
+ color picker for color-based configuration items and category colors
^ email toggle script error when toggle is disabled
* wysiwyg now alerts user if selected text is empty when creating a link
+ added extra styles to wysiwyg
* replaced prompt() calls in wysiwyg to combat IE security warnings
^ fixed array_reverse error in configuration on first-time installs
* changed votes to be restricted only by ip address, instead of the ip/user combo to prevent multiple votes by puppet users
* swapped wysiwyg color dialog with mooRainbow
* cleaned up wysiwyg code
* changed installer to use static versioning to prevent wrong version install information appearing
* rewrote all javascript to use jquery as well as mootools
+ added option to load jquery as a replacement for mootools
* wysiwyg links target and nofollow now optional
+ option to disable negative voting
^ admin language file did not list a few bbcode tags in the bbcode description
^ in some circumstances configuration appeared blank due to mismatching collations
+ mod_jmylifefeed
* reported stories now logged as a boolean to prevent spamming of report emails
+ reported column in stories administrator list
^ apply was broken in stories administrator form on newly created stories
^ zero width spaces no longer inserted in stories administrator form, any remaining zero width spaces are stripped
^ default values for votes and comments in administrator story form
+ javascript validation in administrator story form
^ email texts now populated with correct urls if SEF is enabled

1.0.10

* similar disparate model code consolidated to common functions
^ !JoomlaComment integration didn't show proper counts in admin
+ ajax comment preview in list/favorites views
+ different colors and backgrounds for each category
+ ShareThis link to replace other share links
+ mod_jmylifetopauthors
+ added graphical voting
! improper handling of controller input in admin
! improper handling of certain user-supplied inputs in moderate form
+ plg_system_jmylifemenucounts
* installer now checks if JmylifeConfiguration class already exists before loading
+ story report link
+ wysiwyg in backend moderate form
^ story author notification didn't send when published status changed in form view
^ story author published email didn't fill in details if published through admin
+ uninstall routine and options to remove database and helper extensions
* List menu items use sql type instead of raw id input
* explicit loading of filesystem libraries in configuration to combat 3rd party integrations that do not load these libraries
+ extra option to force username to be used in the case of forced user names for stories
! extra entity replacing in bbcode parser to combat xss in obsolete browsers (IE6) when certain conditions are met
+ toggle to remove alt text from avatars for those rare conditions where avatar cannot be found or has been removed
^ double slash in avatar image src

1.0.9

+ custom css tab in configuration
^ fixed sh404sef support - it only worked in 1.0.8 if JMyLife was set as the Default menu item
^ sh404sef could not resolve buried comments
+ added handler to install CB Plugins through upgrade install routine
+ added favorites CB tab plugin
+ added stories CB tab plugin
^ added forgotten error message
* more install/upgrade tweaks, code cleanup
^ component description had 'MyLife' instead of 'JMyLife', fixed
* version check in About view now color coded, labels changed to be more clear
+ recaptcha theme selection
+ added EXPERIMENTAL simple bbcode-based wysiwyg editor for stories
+ added option to disable the favorites button in the item footer
+ submission form as a configuration tab
+ submission button text is configurable
+ optional guest email input
+ email options as a configuration tab
+ email notifications for published stories
+ moved versioning to the changelog include
+ moved "read comments" text from language file to configuration
+ added optional text limit to story list
* configuration screen remembers last tab
+ mod_jmylifelatestcomments
+ comment pagination is now optional
+ added pathway (breadcrumb) support
+ added send to friend via email functionality
+ cb avatars now available in stories as well as comments, with controls for each
^ enabling cb support without having cb installed should no longer cause errors
^ added more handling to js assets for mootools 1.2 compatibility
* changed handling of votes for 1.6 compatibility
* added sanity checks for 3rd party integrations
+ admin configuration view invokes keepalive behavior
* added spaces after pretext and before posttext
* reversed links in common footer and removed floats
^ css added to prevent element hiding in IE6
+ optional !JoomlaComment integration
+ added option to force user's name to be used in submissions
* JmylifeConfiguration is now a proper singleton, all references updated
* favorites removal confirmation text is a bit more descriptive
^ when no sign up link is selected now redirect to base instead of / to account for installs inside subdirectories
^ missing stories display an error instead of a blank story
* helper extension individual changelogs removed in free release

1.0.8

^ submission form posttext check had the wrong variable
^ module installer had a bad habit of leaving behind tmp files
+ sef_ext for sh404sef support
+ configurable item background
+ configurable rounded corners
* changed helper extension install routine
* moved all configurable text to Language tab
* reworked install.php a bit to make maintenance easier
* install script creates a default category if none are found in the database
+ added "textarea" type configuration items
* changed text/int type configuration options to have a set input width
* rewrote most js files to be mootools 1.2 compatible (for 1.6)
+ rss feeds on list & item views, for all stories and individual categories
+ category descriptions for rss
* configuration view table cell realignment
+ all views now set title and description metadata
+ optional metadata limits
! improper handling of controller input

1.0.7

^ comment query grouping was incorrect
^ query to fix comment warning database upon upgrade had a typo
+ added pre and post texts to core submission form

1.0.6

^ fixed admin configuration tabs in IE
^ fixed reference warnings in various view.html.php files
^ now maintaining two installers to account for older Joomla behaviors
+ comments can use either real name OR username
* title is on its own line in the default submit template now
+ default admin response
+ mod_jmylifelatest
^ favorites was grabbing all stories in 1.0.5
* default email messages changed so the site address didn't have : appended during autolinking in Thunderbird

1.0.5

^ fixed htmlentities for special characters, for real this time - data is now stored raw and processed before being sent to the template
+ added support for using JComments instead of JMyLife core comment engine
+ added link to story in Moderate Comments view
+ added option to disable commenting per-category, per-story, and site-wide
+ added option to disable voting per-category, per-story, and site-wide
+ added optional textarea for stories available only to admins to allow a specialized message separate from the average comment
+ added optional story title with options to be required and/or linked to the story
+ added different messages for moderated comments and stories
* made configuration page a bit nicer, with tabs!

1.0.4

+ added changelog key
* changed styles of changelog view template
+ added "Powered By" link (and option to remove in Pro version)
+ added configuration text fields for vote texts
+ added configuration field for limiting story submissions to users only
* configuration options now grouped
* general story submission tweaks
+ added story form redirect menuitem option in configuration
^ found a few untranslated strings and added to language files
^ long words are now broken by null characters to induce wrapping (optional)
^ fixed bug in submit view re: loading of scripts
+ added "Share on Twitter" link
+ added option to toggle modal window on Facebook links (in case the inoperative "cancel" button bothers you)
^ fixed paths to icons in css for sites not located at /
^ comment warnings had ip as primary key, so once a comment has been reported, no other comments by that user could be reported
^ showing of warned comments actually work now
- removed required class on submission name (defaults to Anonymous)
- disabled core behavior.formvalidation due to IE bug
+ added simple version check in admin About view
^ fixed a few minor conversion bugs left over from older configuration handling

1.0.3

* mapped controllers to views directly in admin
* replaced J!1.5 global \$mainframe with \$appl =& JFactory::getApplication(); for 1.6
* lower case enqueuemessage for 1.6 (still works in 1.5)
* changed handling of menu item select in admin configuration page (for 1.6 - still bugged though)
- depreciated admin/jmylife.install.php, as both 1.5 and 1.6 use the script located at root
* rewrite of router.php
* javascript reload of item view on comment submission
* updated changelog to include official helper modules as well
* changed nl2br on stories to only happen on render
^ Favorites model on site had wrong header in source

1.0.2

+ added changelog
+ added check for set variables in router.php - thanks lafrance
^ fixed broken form fields in list view - thanks lafrance
- removed leftover captcha code from list view - thanks lafrance
+ added configuration to toggle animated footer on items
+ added toggle for IE rounded corners
* only load recaptchalib.php if recaptcha is enabled in configuration
^ fixed form field bug in favorites view
^ if cbsupport is enabled and a user has no avatar, a default one is now shown
^ added conditional to submit view so recaptcha div is not shown if recaptcha is off
^ corrected version number in administrator About view (1.0.1 incorrectly reports 1.0)
^ fixed issue with dates on "latest stories" panel in admin
+ added copy of jmylife.install.php to root of installer zip for 1.6 (NOTE: 1.6 is currently NOT supported)
^ fixed errant Notice: messages in backend
^ fixed icons in jmylife.install.php
^ fixed story submission being lost when captcha is invalid in both core component and mod_jmylifesubmit (js only - recaptcha is js-only anyways)

1.0.1

^ fixed htmlentities for special characters
* submissions respect newlines (nl2br)
+ redirect on submission

1.0

* initial release


+++mod_jmylifecategorymenu
-----------------------

1.0.13 - released with JMyLife 1.0.14

* call to common lib changed to helpers
^ incorrect versioning in headers

1.0.12 - released with JMyLife 1.0.13

^ all texts moved to language files
^ ordering support

1.0.11

- removed Itemid param
* links now have Itemid
+ added moderate view
* dropped path construction for JModuleHelper::getLayoutPath
+ added categories view

1.0.10

+ added category color support
* categories now generated in seperate template to reduce code duplication
* category counts can be positioned before or after category
* category counts given their own wrapper element
+ all li elements now include the generic class 'catitem'
* main page link now shows counts when counts are enabled
^ database prefix previously hard-coded
^ checks to confirm existence of necessary JMyLife files

1.0.9

+ added Itemid param

1.0.8

* categories cleaned by core lib

1.0.7

+ added counts

1.0.6

+ categories are now optional
+ category filter

1.0.5

^ 1.0.4 was still marked 1.0.3 in xml (oops!)
* changed tmpl to use htmlentities()

1.0.4

+ added "all" option to category list, changed ordering code
+ added upgrade flag to install xml
^ removed JText::_() from Random link - caused weird behaviors

1.0.3

+ added option to show cats first or last
+ added support for link ordering

1.0.2

+ added support for submission form link
+ added support for favorites link

1.0.1

* no changes, version sync

1.0

* initial release


mod_jmylifesubmit
-----------------

1.0.14

+ story text limits
+ language file
* not shown on frontend edit

1.0.13

^ category ordering on submission form select
* mootools code removed in favor of jQuery to compensate for MooRainbow being broken in IE8
+ attachment bar

1.0.12

+ redirection option

1.0.11

* generic captcha engine instead of recaptcha
^ submit function moved from $. to window. to combat jQuery conflicts
* mooRainbow script added
* changed default form height to 0
+ custom css param

1.0.10

* style changes for email field
^ checks to confirm existence of necessary JMyLife files
^ email input float moved to horizontal-wide template
* form height can be disabled by setting to 0

1.0.9

^ IE roundies check had artifacts from botched copy/paste - thanks Hanif
+ wysiwyg support
- removed col & row params in favor of px sizes
+ added email capture for guests
^ moved ieroundies code to module js

1.0.8

* colors/radius now driven by main component

1.0.7

+ added support for new core feature - submission pre and post texts

1.0.6

^ clearing on pre & post text
- removed inner js toggle - now options are Menu Toggle or always shown
+ added height controls

1.0.5

^ 1.0.4 was still marked 1.0.3 in xml (oops!)
+ added title field

1.0.4

+ added upgrade flag to install xml
+ module checks config and displays nothing to guests if user story submission is disabled

1.0.3

+ added layouts: horizontal-wide (original default) or vertical
+ added size controls params for textarea
- removed "required" class from nickname, as "Anonymous" is used if blank

1.0.2

* no changes, version sync

1.0.1

* no changes, version sync

1.0

* initial release


mod_jmylifelatest
-----------------

1.0.6

* common libs changed to helpers

1.0.5 - released with JMyLife 1.0.13

+ user avatar
+ allow component styles
+ allow rounded corners
* helper changed to use common library for story preparation
* code cleanup
^ all texts moved to language files

1.0.4 - released with JMyLife 1.0.11

+ blank module text for overzealous template module chrome
* links now have Itemid

1.0.3 - released with JMyLife 1.0.10

^ checks to confirm existence of necessary JMyLife files

1.0.2 - released with JMyLife 1.0.9

+ bbcode parsing
+ user only mode
+ story info text format override (uses sprintf)
+ cb profile link
+ custom css parameter

1.0.1 - released with JMyLife 1.0.8

* changed inline casts on config elements to use config->getInt

1.0.0

* initial release (with JMyLife 1.0.6)


mod_jmylifelatestcomments
-------------------------

1.0.3 - released with JMyLife 1.0.14

* common libs changed to helpers
^ profile links for JomSocial
+ language file

1.0.2 - released with JMyLife 1.0.11

+ blank module text for overzealous template module chrome

1.0.1 - released with JMyLife 1.0.10

^ checks to confirm existence of necessary JMyLife files
^ user comments only was broken

1.0.0

* initial release (with JMyLife 1.0.9)


mod_jmylifetopauthors
---------------------

1.0.3 - released with JMyLife 1.0.14

+ language file

1.0.2 - released with JMyLife 1.0.12

+ show good votes
+ show bad votes
+ worst votes ordering

1.0.1 - released with JMyLife 1.0.11

+ added color selection

1.0.0

* initial release (with JMyLife 1.0.10)


mod_jmylifefeed
---------------

1.0.2 - released with JMyLife 1.0.14

* call to common lib changed to helpers
+ language file for backend params

1.0.1 - released with JMyLife 1.0.12

+ image override

1.0.0

* initial release (with JMyLife 1.0.11)


mod_jmylifedatepicker
---------------------

1.0.0

* initial release (with JMyLife 1.0.16)


+++plg_search_jmylifesearch
------------------------

1.0.13 - released with JMyLife 1.0.14

* call to common lib changed to helpers

1.0.12

+ support for addon plugin jmylifesearchavatars

1.0.11

* links now have Itemid

1.0.10

^ checks to confirm existence of necessary JMyLife files

1.0.9

+ bbcode parser support
* added spaces after pretext and before posttext
^ changed to use configured name instead of 'jmylifesearch'

1.0.8

* changed inline casts on config elements to use config->getInt
^ extra long titles now shortened
^ 1.0.7 marked 1.0.6 in xml - wtf? :P

1.0.7

* if core comments use 3rd party engine disable comment search

1.0.6

+ added support for pre & post text
^ fixed bug re: breakLongWords
^ fixed bug in comment name search
+ added support for usernames on comments instead of real names
^ fixed missing link bug on titleless items when titles enabled

1.0.5

^ 1.0.4 was still marked 1.0.3 in xml (oops!)
+ added title search
+ added check to only search comments if allowed in config

1.0.4

+ added optional username search for stories and comments
+ added upgrade flag to install xml
+ added breakLongWords support

1.0.3

* no changes, version sync

1.0.2

^ corrected version numbering (1.0 mislabelled as 0.1, no 1.0.1)

1.0

* initial release


plg_system_jmylifemenucounts
----------------------------

1.0.3 - released with JMyLife 1.0.14

+ language file

1.0.2 - released with JMyLife 1.0.12

^ fixed background color bug


1.0.1 - released with JMyLife 1.0.11

^ cleaned up notices (seriously, you masochists...)

1.0.0

* initial release (with JMyLife 1.0.10)


plg_system_jmylifesearchavatars
-------------------------------

1.0.1 - released with JMyLife 1.0.14

* call to common lib changed to helper
+ language file

1.0.0

* initial release (with JMyLife 1.0.12)



+++plg_community_jmylifefavorites
------------------------------

1.0.2 - released with JMyLife 1.0.14

* call to common lib changed to helpers
+ language file
^ fix for addScript bug introduced in 1.0.1
^ mismatched div tags
* code cleanup
^ missing icons

1.0.1 - released with JMyLife 1.0.13

* added JMyLife's version of jQuery

1.0.0

* initial release (with JMyLife 1.0.12)


plg_community_jmylifestories
----------------------------

1.0.2 - released with JMyLife 1.0.14

* call to common lib changed to helpers
+ language file
^ fix for addScript bug introduced in 1.0.1
^ mismatched div tags
* code cleanup
^ missing icons

1.0.1 - released with JMyLife 1.0.13

* added JMyLife's version of jQuery

1.0.0

* initial release (with JMyLife 1.0.12)


plg_community_jmylifetoolbar
----------------------------

1.0.2 - released with JMyLife 1.0.14

* call to common lib changed to helpers
+ language file
^ no longer considered an "application" and no longer browsable
^ missing icons

1.0.1 - released with JMyLife 1.0.13

^ iframe in modal forced to use sizes from params

1.0.0

* initial release (with JMyLife 1.0.12)


plug_cbjmylifefavorites
-----------------------

1.0.4 - released with JMyLife 1.0.14

* call to common lib changed to helpers
* code cleanup
* language strings

1.0.3 - released with JMyLife 1.0.12

^ background color error

1.0.2 - released with JMyLife 1.0.11

* links now have Itemid

1.0.1 - released with JMyLife 1.0.10

^ checks to confirm existence of necessary JMyLife files
* common functions used to get data
+ disable avatar alt tag support added

1.0.0

* initial release (with JMyLife 1.0.9)


plug_cbjmylifestories
---------------------

1.0.4 - released with JMyLife 1.0.14

* call to common lib changed to helpers
* code cleanup
* language strings

1.0.3 - released with JMyLife 1.0.12

^ background color error

1.0.2 - released with JMyLife 1.0.11

* links now have Itemid

1.0.1 - released with JMyLife 1.0.10

^ checks to confirm existence of necessary JMyLife files

1.0.0

* initial release (with JMyLife 1.0.9)


plug_cbjmylifetoolbar
---------------------

1.0.2 - released with JMyLife 1.0.14

* call to common lib changed to helpers
* code cleanup
* language strings
^ worst link not shown if disabled in config

1.0.1 - released with JMyLife 1.0.13

* added JMyLife's version of jQuery

1.0.0

* initial release (with JMyLife 1.0.12)


EOF
));